#ifndef D2ITEM_H
#define D2ITEM_H

#include "d2char.h"
#include "d2strings.h"

#include <stdint.h>
#include <stdlib.h>

#define D2S_ITEMDATA_HEADER_LENGTH 2
#define D2S_ITEMDATA_NUMIDENTIFIERS 638
#define D2S_ITEMDATA_IDENTIFIER_LENGTH 4

typedef enum D2S_ITEMDATA_LOCATION {
    D2S_ITEMDATA_LOCATION_UNKNOWN = -1,
	D2S_ITEMDATA_LOCATION_STORED = 0,
	D2S_ITEMDATA_LOCATION_EQUIPPED,
	D2S_ITEMDATA_LOCATION_BELT,
	D2S_ITEMDATA_LOCATION_CURSOR,
	D2S_ITEMDATA_LOCATION_SOCKETED
} D2S_ITEMDATA_LOCATION;

typedef enum D2S_ITEMDATA_RARITY {
    D2S_ITEMDATA_RARITY_UNKNOWN = -1,
    D2S_ITEMDATA_RARITY_LOWQUALITY = 0,
	D2S_ITEMDATA_RARITY_NORMAL,
	D2S_ITEMDATA_RARITY_HIGHQUALITY,
	D2S_ITEMDATA_RARITY_MAGICAL,
	D2S_ITEMDATA_RARITY_SET,
	D2S_ITEMDATA_RARITY_RARE,
	D2S_ITEMDATA_RARITY_UNIQUE,
	D2S_ITEMDATA_RARITY_CRAFTED
} D2S_ITEMDATA_RARITY;

typedef enum D2S_INVENTORYCLASS {
    D2S_INVENTORYCLASS_UNKNOWN = -1,
    D2S_INVENTORYCLASS_INVENTORY = 0,
    D2S_INVENTORYCLASS_MERCENARY,
    D2S_INVENTORYCLASS_CORPSE,
    D2S_INVENTORYCLASS_GOLEM
} D2S_INVENTORYCLASS;

typedef enum D2S_ITEMCLASS {
    D2S_ITEMCLASS_UNKNOWN = 0xFF,
    D2S_ITEMCLASS_OTHER = 0x01,
    D2S_ITEMCLASS_ARMOR = 0x02,
    D2S_ITEMCLASS_SHIELD = 0x03,
    D2S_ITEMCLASS_WEAPON = 0x04,
    D2S_ITEMCLASS_EAR = 0x05,
    D2S_ITEMCLASS_TOME = 0x06,
    D2S_ITEMCLASS_STACKABLE = 0x10
} D2S_ITEMCLASS;

typedef enum D2S_ITEMDATA_IDENTIFIER {
    D2S_ITEMDATA_IDENTIFIER_NOTHING =                     0x00000000,
    D2S_ITEMDATA_IDENTIFIER_CAP =                         0x20706163,
    D2S_ITEMDATA_IDENTIFIER_WAR_HAT =                     0x20706178,
    D2S_ITEMDATA_IDENTIFIER_SHAKO =                       0x20706175,
    D2S_ITEMDATA_IDENTIFIER_SKULL_CAP =                   0x20706B73,
    D2S_ITEMDATA_IDENTIFIER_SALLET =                      0x20706B78,
    D2S_ITEMDATA_IDENTIFIER_HYDRASKULL =                  0x20706B75,
    D2S_ITEMDATA_IDENTIFIER_HELM =                        0x206D6C68,
    D2S_ITEMDATA_IDENTIFIER_CASQUE =                      0x206D6C78,
    D2S_ITEMDATA_IDENTIFIER_ARMET =                       0x206D6C75,
    D2S_ITEMDATA_IDENTIFIER_FULL_HELM =                   0x206C6866,
    D2S_ITEMDATA_IDENTIFIER_BASINET =                     0x206C6878,
    D2S_ITEMDATA_IDENTIFIER_GIANT_CONCH =                 0x206C6875,
    D2S_ITEMDATA_IDENTIFIER_GREAT_HELM =                  0x206D6867,
    D2S_ITEMDATA_IDENTIFIER_WINGED_HELM =                 0x206D6878,
    D2S_ITEMDATA_IDENTIFIER_SPIRED_HELM =                 0x206D6875,
    D2S_ITEMDATA_IDENTIFIER_CROWN =                       0x206E7263,
    D2S_ITEMDATA_IDENTIFIER_GRAND_CROWN =                 0x206E7278,
    D2S_ITEMDATA_IDENTIFIER_CORONA =                      0x206E7275,
    D2S_ITEMDATA_IDENTIFIER_MASK =                        0x206B736D,
    D2S_ITEMDATA_IDENTIFIER_DEATH_MASK =                  0x206B7378,
    D2S_ITEMDATA_IDENTIFIER_DEMONHEAD =                   0x206B7375,
    D2S_ITEMDATA_IDENTIFIER_BONE_HELM =                   0x206D6862,
    D2S_ITEMDATA_IDENTIFIER_GRIM_HELM =                   0x20396878,
    D2S_ITEMDATA_IDENTIFIER_BONE_VISAGE =                 0x20396875,
    D2S_ITEMDATA_IDENTIFIER_QUILTED_ARMOR =               0x20697571,
    D2S_ITEMDATA_IDENTIFIER_GHOST_ARMOR =                 0x20697578,
    D2S_ITEMDATA_IDENTIFIER_DUSK_SHROUD =                 0x20697575,
    D2S_ITEMDATA_IDENTIFIER_LEATHER_ARMOR =               0x2061656C,
    D2S_ITEMDATA_IDENTIFIER_SERPENTSKIN =                 0x20616578,
    D2S_ITEMDATA_IDENTIFIER_WYRMHIDE =                    0x20616575,
    D2S_ITEMDATA_IDENTIFIER_HARD_LEATHER =                0x20616C68,
    D2S_ITEMDATA_IDENTIFIER_DEMONHIDE_ARMOR =             0x20616C78,
    D2S_ITEMDATA_IDENTIFIER_SCARAB_HUSK =                 0x20616C75,
    D2S_ITEMDATA_IDENTIFIER_STUDDED_LEATHER =             0x20757473,
    D2S_ITEMDATA_IDENTIFIER_TRELLISED_ARMOR =             0x20757478,
    D2S_ITEMDATA_IDENTIFIER_WIRE_FLEECE =                 0x20757475,
    D2S_ITEMDATA_IDENTIFIER_RING_MAIL =                   0x20676E72,
    D2S_ITEMDATA_IDENTIFIER_LINKED_MAIL =                 0x20676E78,
    D2S_ITEMDATA_IDENTIFIER_DIAMOND_MAIL =                0x20676E75,
    D2S_ITEMDATA_IDENTIFIER_SCALE_MAIL =                  0x206C6373,
    D2S_ITEMDATA_IDENTIFIER_TIGULATED_MAIL =              0x206C6378,
    D2S_ITEMDATA_IDENTIFIER_LORICATED_MAIL =              0x206C6375,
    D2S_ITEMDATA_IDENTIFIER_CHAIN_MAIL =                  0x206E6863,
    D2S_ITEMDATA_IDENTIFIER_MESH_ARMOR =                  0x206E6878,
    D2S_ITEMDATA_IDENTIFIER_BONEWEAVE =                   0x206E6875,
    D2S_ITEMDATA_IDENTIFIER_BREAST_PLATE =                0x20737262,
    D2S_ITEMDATA_IDENTIFIER_CUIRASS =                     0x20737278,
    D2S_ITEMDATA_IDENTIFIER_GREAT_HAUBERK =               0x20737275,
    D2S_ITEMDATA_IDENTIFIER_SPLINT_MAIL =                 0x206C7073,
    D2S_ITEMDATA_IDENTIFIER_RUSSET_ARMOR =                0x206C7078,
    D2S_ITEMDATA_IDENTIFIER_BALROG_SKIN =                 0x206C7075,
    D2S_ITEMDATA_IDENTIFIER_PLATE_MAIL =                  0x20746C70,
    D2S_ITEMDATA_IDENTIFIER_TEMPLAR_COAT =                0x20746C78,
    D2S_ITEMDATA_IDENTIFIER_HELLFORGE_PLATE =             0x20746C75,
    D2S_ITEMDATA_IDENTIFIER_FIELD_PLATE =                 0x20646C66,
    D2S_ITEMDATA_IDENTIFIER_SHARKTOOTH =                  0x20646C78,
    D2S_ITEMDATA_IDENTIFIER_KRAKEN_SHELL =                0x20646C75,
    D2S_ITEMDATA_IDENTIFIER_GOTHIC_PLATE =                0x20687467,
    D2S_ITEMDATA_IDENTIFIER_EMBOSSED_PLATE =              0x20687478,
    D2S_ITEMDATA_IDENTIFIER_LACQUERED_PLATE =             0x20687475,
    D2S_ITEMDATA_IDENTIFIER_FULL_PLATE_MAIL =             0x206C7566,
    D2S_ITEMDATA_IDENTIFIER_CHAOS_ARMOR =                 0x206C7578,
    D2S_ITEMDATA_IDENTIFIER_SHADOW_PLATE =                0x206C7575,
    D2S_ITEMDATA_IDENTIFIER_ANCIENT_ARMOR =               0x20726161,
    D2S_ITEMDATA_IDENTIFIER_ORNATE_ARMOR =                0x20726178,
    D2S_ITEMDATA_IDENTIFIER_SACRED_ARMOR =                0x20726175,
    D2S_ITEMDATA_IDENTIFIER_LIGHT_PLATE =                 0x2070746C,
    D2S_ITEMDATA_IDENTIFIER_MAGE_PLATE =                  0x20707478,
    D2S_ITEMDATA_IDENTIFIER_ARCHON_PLATE =                0x20707475,
    D2S_ITEMDATA_IDENTIFIER_BUCKLER =                     0x20637562,
    D2S_ITEMDATA_IDENTIFIER_DEFENDER =                    0x20637578,
    D2S_ITEMDATA_IDENTIFIER_HEATER =                      0x20637575,
    D2S_ITEMDATA_IDENTIFIER_SMALL_SHIELD =                0x206C6D73,
    D2S_ITEMDATA_IDENTIFIER_ROUND_SHIELD =                0x206C6D78,
    D2S_ITEMDATA_IDENTIFIER_LUNA =                        0x206C6D75,
    D2S_ITEMDATA_IDENTIFIER_LARGE_SHIELD =                0x2067726C,
    D2S_ITEMDATA_IDENTIFIER_SCUTUM =                      0x20677278,
    D2S_ITEMDATA_IDENTIFIER_HYPERION =                    0x20677275,
    D2S_ITEMDATA_IDENTIFIER_KITE_SHIELD =                 0x2074696B,
    D2S_ITEMDATA_IDENTIFIER_DRAGON_SHIELD =               0x20746978,
    D2S_ITEMDATA_IDENTIFIER_MONARCH =                     0x20746975,
    D2S_ITEMDATA_IDENTIFIER_TOWER_SHIELD =                0x20776F74,
    D2S_ITEMDATA_IDENTIFIER_PAVISE =                      0x20776F78,
    D2S_ITEMDATA_IDENTIFIER_AEGIS =                       0x20776F75,
    D2S_ITEMDATA_IDENTIFIER_GOTHIC_SHIELD =               0x20737467,
    D2S_ITEMDATA_IDENTIFIER_ANCIENT_SHIELD =              0x20737478,
    D2S_ITEMDATA_IDENTIFIER_WARD =                        0x20737475,
    D2S_ITEMDATA_IDENTIFIER_BONE_SHIELD =                 0x20687362,
    D2S_ITEMDATA_IDENTIFIER_GRIM_SHIELD =                 0x20687378,
    D2S_ITEMDATA_IDENTIFIER_TROLL_NEST =                  0x20687375,
    D2S_ITEMDATA_IDENTIFIER_SPIKED_SHIELD =               0x206B7073,
    D2S_ITEMDATA_IDENTIFIER_BARBED_SHIELD =               0x206B7078,
    D2S_ITEMDATA_IDENTIFIER_BLADE_BARRIER =               0x206B7075,
    D2S_ITEMDATA_IDENTIFIER_LEATHER_GLOVES =              0x206C676C,
    D2S_ITEMDATA_IDENTIFIER_DEMONHIDE_GLOVE =             0x20676C78,
    D2S_ITEMDATA_IDENTIFIER_BRAMBLE_MITTS =               0x20676C75,
    D2S_ITEMDATA_IDENTIFIER_HEAVY_GLOVES =                0x206C6776,
    D2S_ITEMDATA_IDENTIFIER_SHARKSKIN_GLOVE =             0x20677678,
    D2S_ITEMDATA_IDENTIFIER_VAMPIREBONE_GLOVES =          0x20677675,
    D2S_ITEMDATA_IDENTIFIER_CHAIN_GLOVES =                0x206C676D,
    D2S_ITEMDATA_IDENTIFIER_HEAVY_BRACERS =               0x20676D78,
    D2S_ITEMDATA_IDENTIFIER_VAMBRACES =                   0x20676D75,
    D2S_ITEMDATA_IDENTIFIER_LIGHT_GAUNTLETS =             0x206C6774,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_GAUNTLET =             0x20677478,
    D2S_ITEMDATA_IDENTIFIER_CRUSADER_GAUNTLETS =          0x20677475,
    D2S_ITEMDATA_IDENTIFIER_GAUNTLETS =                   0x206C6768,
    D2S_ITEMDATA_IDENTIFIER_WAR_GAUNTLETS =               0x20676878,
    D2S_ITEMDATA_IDENTIFIER_OGRE_GAUNTLETS =              0x20676875,
    D2S_ITEMDATA_IDENTIFIER_BOOTS =                       0x2074626C,
    D2S_ITEMDATA_IDENTIFIER_DEMONHIDE_BOOTS =             0x20626C78,
    D2S_ITEMDATA_IDENTIFIER_WYRMHIDE_BOOTS =              0x20626C75,
    D2S_ITEMDATA_IDENTIFIER_HEAVY_BOOTS =                 0x20746276,
    D2S_ITEMDATA_IDENTIFIER_SHARKSKIN_BOOTS =             0x20627678,
    D2S_ITEMDATA_IDENTIFIER_SCARABSHELL_BOOTS =           0x20627675,
    D2S_ITEMDATA_IDENTIFIER_CHAIN_BOOTS =                 0x2074626D,
    D2S_ITEMDATA_IDENTIFIER_MESH_BOOTS =                  0x20626D78,
    D2S_ITEMDATA_IDENTIFIER_BONEWEAVE_BOOTS =             0x20626D75,
    D2S_ITEMDATA_IDENTIFIER_LIGHT_PLATED_BOOTS =          0x20746274,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_BOOTS =                0x20627478,
    D2S_ITEMDATA_IDENTIFIER_MIRRORED_BOOTS =              0x20627475,
    D2S_ITEMDATA_IDENTIFIER_GREAVES =                     0x20746268,
    D2S_ITEMDATA_IDENTIFIER_WAR_BOOTS =                   0x20626878,
    D2S_ITEMDATA_IDENTIFIER_MYRMIDON_GREAVE =             0x20626875,
    D2S_ITEMDATA_IDENTIFIER_SASH =                        0x206C626C,
    D2S_ITEMDATA_IDENTIFIER_DEMONHIDE_SASH =              0x20626C7A,
    D2S_ITEMDATA_IDENTIFIER_SPIDERWEB_SASH =              0x20636C75,
    D2S_ITEMDATA_IDENTIFIER_LIGHT_BELT =                  0x206C6276,
    D2S_ITEMDATA_IDENTIFIER_SHARKSKIN_BELT =              0x2062767A,
    D2S_ITEMDATA_IDENTIFIER_VAMPIREFANG_BELT =            0x20637675,
    D2S_ITEMDATA_IDENTIFIER_BELT =                        0x206C626D,
    D2S_ITEMDATA_IDENTIFIER_MESH_BELT =                   0x20626D7A,
    D2S_ITEMDATA_IDENTIFIER_MITHRIL_COIL =                0x20636D75,
    D2S_ITEMDATA_IDENTIFIER_HEAVY_BELT =                  0x206C6274,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_BELT =                 0x2062747A,
    D2S_ITEMDATA_IDENTIFIER_TROLL_BELT =                  0x20637475,
    D2S_ITEMDATA_IDENTIFIER_PLATED_BELT =                 0x206C6268,
    D2S_ITEMDATA_IDENTIFIER_WAR_BELT =                    0x2062687A,
    D2S_ITEMDATA_IDENTIFIER_COLOSSUS_GIRDLE =             0x20636875,
    D2S_ITEMDATA_IDENTIFIER_WOLF_HEAD =                   0x20317264,
    D2S_ITEMDATA_IDENTIFIER_ALPHA_HELM =                  0x20367264,
    D2S_ITEMDATA_IDENTIFIER_BLOOD_SPIRIT =                0x20627264,
    D2S_ITEMDATA_IDENTIFIER_HAWK_HELM =                   0x20327264,
    D2S_ITEMDATA_IDENTIFIER_GRIFFON_HEADDRESS =           0x20377264,
    D2S_ITEMDATA_IDENTIFIER_SUN_SPIRIT =                  0x20637264,
    D2S_ITEMDATA_IDENTIFIER_ANTLERS =                     0x20337264,
    D2S_ITEMDATA_IDENTIFIER_HUNTERS_GUISE =               0x20387264,
    D2S_ITEMDATA_IDENTIFIER_EARTH_SPIRIT =                0x20647264,
    D2S_ITEMDATA_IDENTIFIER_FALCON_MASK =                 0x20347264,
    D2S_ITEMDATA_IDENTIFIER_SACRED_FEATHERS =             0x20397264,
    D2S_ITEMDATA_IDENTIFIER_SKY_SPIRIT =                  0x20657264,
    D2S_ITEMDATA_IDENTIFIER_SPIRIT_MASK =                 0x20357264,
    D2S_ITEMDATA_IDENTIFIER_TOTEMIC_MASK =                0x20617264,
    D2S_ITEMDATA_IDENTIFIER_DREAM_SPIRIT =                0x20667264,
    D2S_ITEMDATA_IDENTIFIER_JAWBONE_CAP =                 0x20316162,
    D2S_ITEMDATA_IDENTIFIER_JAWBONE_VISOR =               0x20366162,
    D2S_ITEMDATA_IDENTIFIER_CARNAGE_HELM =                0x20626162,
    D2S_ITEMDATA_IDENTIFIER_FANGED_HELM =                 0x20326162,
    D2S_ITEMDATA_IDENTIFIER_LION_HELM =                   0x20376162,
    D2S_ITEMDATA_IDENTIFIER_FURY_VISOR =                  0x20636162,
    D2S_ITEMDATA_IDENTIFIER_HORNED_HELM =                 0x20336162,
    D2S_ITEMDATA_IDENTIFIER_RAGE_MASK =                   0x20386162,
    D2S_ITEMDATA_IDENTIFIER_DESTROYER_HELM =              0x20646162,
    D2S_ITEMDATA_IDENTIFIER_ASSUALT_HELMET =              0x20346162,
    D2S_ITEMDATA_IDENTIFIER_SAVAGE_HELMET =               0x20396162,
    D2S_ITEMDATA_IDENTIFIER_CONQUEROR_CROWN =             0x20656162,
    D2S_ITEMDATA_IDENTIFIER_AVENGER_GUARD =               0x20356162,
    D2S_ITEMDATA_IDENTIFIER_SLAYER_GUARD =                0x20616162,
    D2S_ITEMDATA_IDENTIFIER_GUARDIAN_CROWN =              0x20666162,
    D2S_ITEMDATA_IDENTIFIER_TARGE =                       0x20316170,
    D2S_ITEMDATA_IDENTIFIER_AKARAN_TARGE =                0x20366170,
    D2S_ITEMDATA_IDENTIFIER_SACRED_TARGE =                0x20626170,
    D2S_ITEMDATA_IDENTIFIER_RONDACHE =                    0x20326170,
    D2S_ITEMDATA_IDENTIFIER_AKARAN_RONDACHE =             0x20376170,
    D2S_ITEMDATA_IDENTIFIER_SACRED_RONDACHE =             0x20636170,
    D2S_ITEMDATA_IDENTIFIER_HERALDIC_SHIELD =             0x20336170,
    D2S_ITEMDATA_IDENTIFIER_PROTECTOR_SHLD =              0x20386170,
    D2S_ITEMDATA_IDENTIFIER_KURAST_SHIELD =               0x20646170,
    D2S_ITEMDATA_IDENTIFIER_AERIN_SHIELD =                0x20346170,
    D2S_ITEMDATA_IDENTIFIER_GUILDED_SHIELD =              0x20396170,
    D2S_ITEMDATA_IDENTIFIER_ZAKARUM_SHIELD =              0x20656170,
    D2S_ITEMDATA_IDENTIFIER_CROWN_SHIELD =                0x20356170,
    D2S_ITEMDATA_IDENTIFIER_ROYAL_SHIELD =                0x20616170,
    D2S_ITEMDATA_IDENTIFIER_VORTEX_SHIELD =               0x20666170,
    D2S_ITEMDATA_IDENTIFIER_PRESERVED_HEAD =              0x2031656E,
    D2S_ITEMDATA_IDENTIFIER_MUMMIFIED_TRPHY =             0x2036656E,
    D2S_ITEMDATA_IDENTIFIER_MINION_SKULL =                0x2062656E,
    D2S_ITEMDATA_IDENTIFIER_ZOMBIE_HEAD =                 0x2032656E,
    D2S_ITEMDATA_IDENTIFIER_FETISH_TROPHY =               0x2037656E,
    D2S_ITEMDATA_IDENTIFIER_HELLSPAWN_SKULL =             0x2063656E,
    D2S_ITEMDATA_IDENTIFIER_UNRAVELLER_HEAD =             0x2033656E,
    D2S_ITEMDATA_IDENTIFIER_SEXTON_TROPHY =               0x2038656E,
    D2S_ITEMDATA_IDENTIFIER_OVERSEER_SKULL =              0x2064656E,
    D2S_ITEMDATA_IDENTIFIER_GARGOYLE_HEAD =               0x2034656E,
    D2S_ITEMDATA_IDENTIFIER_CANTOR_TROPHY =               0x2039656E,
    D2S_ITEMDATA_IDENTIFIER_SUCCUBUS_SKULL =              0x2065656E,
    D2S_ITEMDATA_IDENTIFIER_DEMON_HEAD =                  0x2035656E,
    D2S_ITEMDATA_IDENTIFIER_HEIROPHANT_TRPHY =            0x2061656E,
    D2S_ITEMDATA_IDENTIFIER_BLOODLORD_SKULL =             0x2066656E,
    D2S_ITEMDATA_IDENTIFIER_HAND_AXE =                    0x20786168,
    D2S_ITEMDATA_IDENTIFIER_HATCHET =                     0x20616839,
    D2S_ITEMDATA_IDENTIFIER_TOMAHAWK =                    0x20616837,
    D2S_ITEMDATA_IDENTIFIER_AXE =                         0x20657861,
    D2S_ITEMDATA_IDENTIFIER_CLEAVER =                     0x20786139,
    D2S_ITEMDATA_IDENTIFIER_SMALL_CRESCENT =              0x20786137,
    D2S_ITEMDATA_IDENTIFIER_DOUBLE_AXE =                  0x20786132,
    D2S_ITEMDATA_IDENTIFIER_TWIN_AXE =                    0x20613239,
    D2S_ITEMDATA_IDENTIFIER_ETTIN_AXE =                   0x20613237,
    D2S_ITEMDATA_IDENTIFIER_MILITARY_PICK =               0x2069706D,
    D2S_ITEMDATA_IDENTIFIER_CROWBILL =                    0x20706D39,
    D2S_ITEMDATA_IDENTIFIER_WAR_SPIKE =                   0x20706D37,
    D2S_ITEMDATA_IDENTIFIER_WAR_AXE =                     0x20786177,
    D2S_ITEMDATA_IDENTIFIER_NAGA =                        0x20617739,
    D2S_ITEMDATA_IDENTIFIER_BERSERKER_AXE =               0x20617737,
    D2S_ITEMDATA_IDENTIFIER_LARGE_AXE =                   0x2078616C,
    D2S_ITEMDATA_IDENTIFIER_MILITARY_AXE =                0x20616C39,
    D2S_ITEMDATA_IDENTIFIER_FERAL_AXE =                   0x20616C37,
    D2S_ITEMDATA_IDENTIFIER_BROAD_AXE =                   0x20786162,
    D2S_ITEMDATA_IDENTIFIER_BEARDED_AXE =                 0x20616239,
    D2S_ITEMDATA_IDENTIFIER_SILVER_EDGED_AX =             0x20616237,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_AXE =                  0x20787462,
    D2S_ITEMDATA_IDENTIFIER_TABAR =                       0x20746239,
    D2S_ITEMDATA_IDENTIFIER_DECAPITATOR =                 0x20746237,
    D2S_ITEMDATA_IDENTIFIER_GREAT_AXE =                   0x20786167,
    D2S_ITEMDATA_IDENTIFIER_GOTHIC_AXE =                  0x20616739,
    D2S_ITEMDATA_IDENTIFIER_CHAMPION_AXE =                0x20616737,
    D2S_ITEMDATA_IDENTIFIER_GIANT_AXE =                   0x20786967,
    D2S_ITEMDATA_IDENTIFIER_ANCIENT_AXE =                 0x20696739,
    D2S_ITEMDATA_IDENTIFIER_GLORIOUS_AXE =                0x20696737,
    D2S_ITEMDATA_IDENTIFIER_CLUB =                        0x20626C63,
    D2S_ITEMDATA_IDENTIFIER_CUDGEL =                      0x206C6339,
    D2S_ITEMDATA_IDENTIFIER_TRUNCHEON =                   0x206C6337,
    D2S_ITEMDATA_IDENTIFIER_SPIKED_CLUB =                 0x20637073,
    D2S_ITEMDATA_IDENTIFIER_BARBED_CLUB =                 0x20707339,
    D2S_ITEMDATA_IDENTIFIER_TYRANT_CLUB =                 0x20707337,
    D2S_ITEMDATA_IDENTIFIER_MACE =                        0x2063616D,
    D2S_ITEMDATA_IDENTIFIER_FLANGED_MACE =                0x20616D39,
    D2S_ITEMDATA_IDENTIFIER_REINFORCED_MACE =             0x20616D37,
    D2S_ITEMDATA_IDENTIFIER_MORNING_STAR =                0x2074736D,
    D2S_ITEMDATA_IDENTIFIER_JAGGED_STAR =                 0x20746D39,
    D2S_ITEMDATA_IDENTIFIER_DEVIL_STAR =                  0x20666D37,
    D2S_ITEMDATA_IDENTIFIER_FLAIL =                       0x20616C66,
    D2S_ITEMDATA_IDENTIFIER_KNOUT =                       0x206C6639,
    D2S_ITEMDATA_IDENTIFIER_SCOURGE =                     0x206C6637,
    D2S_ITEMDATA_IDENTIFIER_WAR_HAMMER =                  0x206D6877,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_HAMMER =               0x20687739,
    D2S_ITEMDATA_IDENTIFIER_LEGENDARY_MALLET =            0x20687737,
    D2S_ITEMDATA_IDENTIFIER_MAUL =                        0x2075616D,
    D2S_ITEMDATA_IDENTIFIER_WAR_CLUB =                    0x20396D39,
    D2S_ITEMDATA_IDENTIFIER_OGRE_MAUL =                   0x20376D37,
    D2S_ITEMDATA_IDENTIFIER_GREAT_MAUL =                  0x20616D67,
    D2S_ITEMDATA_IDENTIFIER_MARTEL_DE_FER =               0x206D6739,
    D2S_ITEMDATA_IDENTIFIER_THUNDER_MAUL =                0x206D6737,
    D2S_ITEMDATA_IDENTIFIER_SHORT_SWORD =                 0x20647373,
    D2S_ITEMDATA_IDENTIFIER_GLADIUS =                     0x20737339,
    D2S_ITEMDATA_IDENTIFIER_FALCATA =                     0x20737337,
    D2S_ITEMDATA_IDENTIFIER_SCIMITAR =                    0x206D6373,
    D2S_ITEMDATA_IDENTIFIER_CUTLASS =                     0x206D7339,
    D2S_ITEMDATA_IDENTIFIER_ATAGHAN =                     0x206D7337,
    D2S_ITEMDATA_IDENTIFIER_SABER =                       0x20726273,
    D2S_ITEMDATA_IDENTIFIER_SHAMSHIR =                    0x20627339,
    D2S_ITEMDATA_IDENTIFIER_ELEGANT_BLADE =               0x20627337,
    D2S_ITEMDATA_IDENTIFIER_FALCHION =                    0x20636C66,
    D2S_ITEMDATA_IDENTIFIER_TULWAR =                      0x20636639,
    D2S_ITEMDATA_IDENTIFIER_HYDRA_EDGE =                  0x20636637,
    D2S_ITEMDATA_IDENTIFIER_CRYSTAL_SWORD =               0x20737263,
    D2S_ITEMDATA_IDENTIFIER_DIMENSIONAL_BLADE =           0x20726339,
    D2S_ITEMDATA_IDENTIFIER_PHASE_BLADE =                 0x20726337,
    D2S_ITEMDATA_IDENTIFIER_BROAD_SWORD =                 0x20647362,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_SWORD =                0x20736239,
    D2S_ITEMDATA_IDENTIFIER_CONQUEST_SWORD =              0x20736237,
    D2S_ITEMDATA_IDENTIFIER_LONG_SWORD =                  0x2064736C,
    D2S_ITEMDATA_IDENTIFIER_RUNE_SWORD =                  0x20736C39,
    D2S_ITEMDATA_IDENTIFIER_CRYPTIC_SWORD =               0x20736C37,
    D2S_ITEMDATA_IDENTIFIER_WAR_SWORD =                   0x20647377,
    D2S_ITEMDATA_IDENTIFIER_ANCIENT_SWORD =               0x20647739,
    D2S_ITEMDATA_IDENTIFIER_MYTHICAL_SWORD =              0x20647737,
    D2S_ITEMDATA_IDENTIFIER_TWOHANDED_SWORD =             0x20736832,
    D2S_ITEMDATA_IDENTIFIER_ESPADON =                     0x20683239,
    D2S_ITEMDATA_IDENTIFIER_LEGEND_SWORD =                0x20683237,
    D2S_ITEMDATA_IDENTIFIER_CLAYMORE =                    0x206D6C63,
    D2S_ITEMDATA_IDENTIFIER_DACIAN_FALX =                 0x206D6339,
    D2S_ITEMDATA_IDENTIFIER_HIGHLAND_BLADE =              0x206D6337,
    D2S_ITEMDATA_IDENTIFIER_GIANT_SWORD =                 0x20736967,
    D2S_ITEMDATA_IDENTIFIER_TUSK_SWORD =                  0x20736739,
    D2S_ITEMDATA_IDENTIFIER_BALROG_BLADE =                0x20736737,
    D2S_ITEMDATA_IDENTIFIER_BASTARD_SWORD =               0x20777362,
    D2S_ITEMDATA_IDENTIFIER_GOTHIC_SWORD =                0x20396239,
    D2S_ITEMDATA_IDENTIFIER_CHAMPION_SWORD =              0x20376237,
    D2S_ITEMDATA_IDENTIFIER_FLAMBERGE =                   0x20626C66,
    D2S_ITEMDATA_IDENTIFIER_ZWEIHANDER =                  0x20626639,
    D2S_ITEMDATA_IDENTIFIER_COLOSSAL_SWORD =              0x20626637,
    D2S_ITEMDATA_IDENTIFIER_GREAT_SWORD =                 0x20647367,
    D2S_ITEMDATA_IDENTIFIER_EXECUTIONER_SWORD =           0x20646739,
    D2S_ITEMDATA_IDENTIFIER_COLOSSUS_BLADE =              0x20646737,
    D2S_ITEMDATA_IDENTIFIER_DAGGER =                      0x20726764,
    D2S_ITEMDATA_IDENTIFIER_POIGNARD =                    0x20676439,
    D2S_ITEMDATA_IDENTIFIER_BONE_KNIFE =                  0x20676437,
    D2S_ITEMDATA_IDENTIFIER_DIRK =                        0x20726964,
    D2S_ITEMDATA_IDENTIFIER_RONDEL =                      0x20696439,
    D2S_ITEMDATA_IDENTIFIER_MITHRAL_POINT =               0x20696437,
    D2S_ITEMDATA_IDENTIFIER_KRISS =                       0x2069726B,
    D2S_ITEMDATA_IDENTIFIER_CINQUEDEAS =                  0x20726B39,
    D2S_ITEMDATA_IDENTIFIER_FANGED_KNIFE =                0x20726B37,
    D2S_ITEMDATA_IDENTIFIER_BLADE =                       0x20646C62,
    D2S_ITEMDATA_IDENTIFIER_STILLETO =                    0x206C6239,
    D2S_ITEMDATA_IDENTIFIER_LEGEND_SPIKE =                0x206C6237,
    D2S_ITEMDATA_IDENTIFIER_THROWING_KNIFE =              0x20666B74,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_DART =                 0x206B7439,
    D2S_ITEMDATA_IDENTIFIER_FLYING_KNIFE =                0x206B7437,
    D2S_ITEMDATA_IDENTIFIER_THROWING_AXE =                0x20786174,
    D2S_ITEMDATA_IDENTIFIER_FRANCISCA =                   0x20617439,
    D2S_ITEMDATA_IDENTIFIER_FLYING_AXE =                  0x20617437,
    D2S_ITEMDATA_IDENTIFIER_BALANCED_KNIFE =              0x20666B62,
    D2S_ITEMDATA_IDENTIFIER_WAR_DART =                    0x206B6239,
    D2S_ITEMDATA_IDENTIFIER_WINGED_KNIFE =                0x206B6237,
    D2S_ITEMDATA_IDENTIFIER_BALANCED_AXE =                0x206C6162,
    D2S_ITEMDATA_IDENTIFIER_HURLBAT =                     0x20386239,
    D2S_ITEMDATA_IDENTIFIER_WINGED_AXE =                  0x20386237,
    D2S_ITEMDATA_IDENTIFIER_JAVELIN =                     0x2076616A,
    D2S_ITEMDATA_IDENTIFIER_WAR_JAVELIN =                 0x20616A39,
    D2S_ITEMDATA_IDENTIFIER_HYPERION_JAVELIN =            0x20616A37,
    D2S_ITEMDATA_IDENTIFIER_PILUM =                       0x206C6970,
    D2S_ITEMDATA_IDENTIFIER_GREAT_PILUM =                 0x20697039,
    D2S_ITEMDATA_IDENTIFIER_STYGIAN_PILUM =               0x20697037,
    D2S_ITEMDATA_IDENTIFIER_SHORT_SPEAR =                 0x20707373,
    D2S_ITEMDATA_IDENTIFIER_SIMBILAN =                    0x20397339,
    D2S_ITEMDATA_IDENTIFIER_BALROG_SPEAR =                0x20377337,
    D2S_ITEMDATA_IDENTIFIER_GLAIVE =                      0x20766C67,
    D2S_ITEMDATA_IDENTIFIER_SPICULUM =                    0x206C6739,
    D2S_ITEMDATA_IDENTIFIER_GHOST_GLAIVE =                0x206C6737,
    D2S_ITEMDATA_IDENTIFIER_THROWING_SPEAR =              0x20707374,
    D2S_ITEMDATA_IDENTIFIER_HARPOON =                     0x20737439,
    D2S_ITEMDATA_IDENTIFIER_WINGED_HARPOON =              0x20737437,
    D2S_ITEMDATA_IDENTIFIER_SPEAR =                       0x20727073,
    D2S_ITEMDATA_IDENTIFIER_WAR_SPEAR =                   0x20727339,
    D2S_ITEMDATA_IDENTIFIER_HYPERION_SPEAR =              0x20727337,
    D2S_ITEMDATA_IDENTIFIER_TRIDENT =                     0x20697274,
    D2S_ITEMDATA_IDENTIFIER_FUSCINA =                     0x20727439,
    D2S_ITEMDATA_IDENTIFIER_STYGIAN_PIKE =                0x20727437,
    D2S_ITEMDATA_IDENTIFIER_BRANDISTOCK =                 0x206E7262,
    D2S_ITEMDATA_IDENTIFIER_WAR_FORK =                    0x20726239,
    D2S_ITEMDATA_IDENTIFIER_MANCATCHER =                  0x20726237,
    D2S_ITEMDATA_IDENTIFIER_SPETUM =                      0x20747073,
    D2S_ITEMDATA_IDENTIFIER_YARI =                        0x20747339,
    D2S_ITEMDATA_IDENTIFIER_GHOST_SPEAR =                 0x20747337,
    D2S_ITEMDATA_IDENTIFIER_PIKE =                        0x206B6970,
    D2S_ITEMDATA_IDENTIFIER_LANCE =                       0x20397039,
    D2S_ITEMDATA_IDENTIFIER_WAR_PIKE =                    0x20377037,
    D2S_ITEMDATA_IDENTIFIER_BARDICHE =                    0x20726162,
    D2S_ITEMDATA_IDENTIFIER_LOCHABER_AXE =                0x20376239,
    D2S_ITEMDATA_IDENTIFIER_OGRE_AXE =                    0x20376F37,
    D2S_ITEMDATA_IDENTIFIER_VOULGE =                      0x20756F76,
    D2S_ITEMDATA_IDENTIFIER_BILL =                        0x206F7639,
    D2S_ITEMDATA_IDENTIFIER_COLOSSUS_VOULGE =             0x206F7637,
    D2S_ITEMDATA_IDENTIFIER_SCYTHE =                      0x20796373,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_SCYTHE =               0x20387339,
    D2S_ITEMDATA_IDENTIFIER_THRESHER =                    0x20387337,
    D2S_ITEMDATA_IDENTIFIER_POLEAXE =                     0x20786170,
    D2S_ITEMDATA_IDENTIFIER_PARTIZAN =                    0x20617039,
    D2S_ITEMDATA_IDENTIFIER_CRYPTIC_AXE =                 0x20617037,
    D2S_ITEMDATA_IDENTIFIER_HALBERD =                     0x206C6168,
    D2S_ITEMDATA_IDENTIFIER_BEC_DE_CORBIN =               0x20396839,
    D2S_ITEMDATA_IDENTIFIER_GREAT_POLEAXE =               0x20376837,
    D2S_ITEMDATA_IDENTIFIER_WAR_SCYTHE =                  0x20637377,
    D2S_ITEMDATA_IDENTIFIER_GRIM_SCYTHE =                 0x20637739,
    D2S_ITEMDATA_IDENTIFIER_GIANT_THRESHER =              0x20637737,
    D2S_ITEMDATA_IDENTIFIER_SHORT_BOW =                   0x20776273,
    D2S_ITEMDATA_IDENTIFIER_EDGE_BOW =                    0x20627338,
    D2S_ITEMDATA_IDENTIFIER_SPIDER_BOW =                  0x20627336,
    D2S_ITEMDATA_IDENTIFIER_HUNTERS_BOW =                 0x20776268,
    D2S_ITEMDATA_IDENTIFIER_RAZOR_BOW =                   0x20626838,
    D2S_ITEMDATA_IDENTIFIER_BLADE_BOW =                   0x20626836,
    D2S_ITEMDATA_IDENTIFIER_LONG_BOW =                    0x2077626C,
    D2S_ITEMDATA_IDENTIFIER_CEDAR_BOW =                   0x20626C38,
    D2S_ITEMDATA_IDENTIFIER_SHADOW_BOW =                  0x20626C36,
    D2S_ITEMDATA_IDENTIFIER_COMPOSITE_BOW =               0x20776263,
    D2S_ITEMDATA_IDENTIFIER_DOUBLE_BOW =                  0x20626338,
    D2S_ITEMDATA_IDENTIFIER_GREAT_BOW =                   0x20626336,
    D2S_ITEMDATA_IDENTIFIER_SHORT_BATTLE_BOW =            0x20626273,
    D2S_ITEMDATA_IDENTIFIER_SHORT_SIEGE_BOW =             0x20387338,
    D2S_ITEMDATA_IDENTIFIER_DIAMOND_BOW =                 0x20377336,
    D2S_ITEMDATA_IDENTIFIER_LONG_BATTLE_BOW =             0x2062626C,
    D2S_ITEMDATA_IDENTIFIER_LONG_SIEGE_BOW =              0x20386C38,
    D2S_ITEMDATA_IDENTIFIER_CRUSADER_BOW =                0x20376C36,
    D2S_ITEMDATA_IDENTIFIER_SHORT_WAR_BOW =               0x20627773,
    D2S_ITEMDATA_IDENTIFIER_RUNE_BOW =                    0x20777338,
    D2S_ITEMDATA_IDENTIFIER_WARD_BOW =                    0x20777336,
    D2S_ITEMDATA_IDENTIFIER_LONG_WAR_BOW =                0x2062776C,
    D2S_ITEMDATA_IDENTIFIER_GOTHIC_BOW =                  0x20776C38,
    D2S_ITEMDATA_IDENTIFIER_HYDRA_BOW =                   0x20776C36,
    D2S_ITEMDATA_IDENTIFIER_LIGHT_CROSSBOW =              0x2062786C,
    D2S_ITEMDATA_IDENTIFIER_ARBALEST =                    0x20786C38,
    D2S_ITEMDATA_IDENTIFIER_PELLET_BOW =                  0x20786C36,
    D2S_ITEMDATA_IDENTIFIER_CROSSBOW =                    0x2062786D,
    D2S_ITEMDATA_IDENTIFIER_SIEGE_CROSSBOW =              0x20786D38,
    D2S_ITEMDATA_IDENTIFIER_GORGON_CROSSBOW =             0x20786D36,
    D2S_ITEMDATA_IDENTIFIER_HEAVY_CROSSBOW =              0x20627868,
    D2S_ITEMDATA_IDENTIFIER_BALLISTA =                    0x20786838,
    D2S_ITEMDATA_IDENTIFIER_COLOSSUS_CROSSBOW =           0x20786836,
    D2S_ITEMDATA_IDENTIFIER_REPEATING_CROSSBOW =          0x20627872,
    D2S_ITEMDATA_IDENTIFIER_CHU_KO_NU =                   0x20787238,
    D2S_ITEMDATA_IDENTIFIER_DEMON_CROSSBOW =              0x20787236,
    D2S_ITEMDATA_IDENTIFIER_SHORT_STAFF =                 0x20747373,
    D2S_ITEMDATA_IDENTIFIER_JO_STAFF =                    0x20737338,
    D2S_ITEMDATA_IDENTIFIER_WALKING_STICK =               0x20737336,
    D2S_ITEMDATA_IDENTIFIER_LONG_STAFF =                  0x2074736C,
    D2S_ITEMDATA_IDENTIFIER_QUARTERSTAFF =                0x20736C38,
    D2S_ITEMDATA_IDENTIFIER_STALAGMITE =                  0x20736C36,
    D2S_ITEMDATA_IDENTIFIER_GNARLED_STAFF =               0x20747367,
    D2S_ITEMDATA_IDENTIFIER_CEDAR_STAFF =                 0x20736338,
    D2S_ITEMDATA_IDENTIFIER_ELDER_STAFF =                 0x20736336,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_STAFF =                0x20747362,
    D2S_ITEMDATA_IDENTIFIER_GOTHIC_STAFF =                0x20736238,
    D2S_ITEMDATA_IDENTIFIER_SHILLELAGH =                  0x20736236,
    D2S_ITEMDATA_IDENTIFIER_WAR_STAFF =                   0x20747377,
    D2S_ITEMDATA_IDENTIFIER_RUNE_STAFF =                  0x20737738,
    D2S_ITEMDATA_IDENTIFIER_ARCHON_STAFF =                0x20737736,
    D2S_ITEMDATA_IDENTIFIER_WAND =                        0x20646E77,
    D2S_ITEMDATA_IDENTIFIER_BURNT_WAND =                  0x206E7739,
    D2S_ITEMDATA_IDENTIFIER_POLISHED_WAND =               0x206E7737,
    D2S_ITEMDATA_IDENTIFIER_YEW_WAND =                    0x206E7779,
    D2S_ITEMDATA_IDENTIFIER_PETRIFIED_WAND =              0x20777939,
    D2S_ITEMDATA_IDENTIFIER_GHOST_WAND =                  0x20777937,
    D2S_ITEMDATA_IDENTIFIER_BONE_WAND =                   0x206E7762,
    D2S_ITEMDATA_IDENTIFIER_TOMB_WAND =                   0x20776239,
    D2S_ITEMDATA_IDENTIFIER_LICH_WAND =                   0x20776237,
    D2S_ITEMDATA_IDENTIFIER_GRIM_WAND =                   0x206E7767,
    D2S_ITEMDATA_IDENTIFIER_GRAVE_WAND =                  0x20776739,
    D2S_ITEMDATA_IDENTIFIER_UNEARTHED_WAND =              0x20776737,
    D2S_ITEMDATA_IDENTIFIER_SCEPTRE =                     0x20706373,
    D2S_ITEMDATA_IDENTIFIER_RUNE_SCEPTRE =                0x20637339,
    D2S_ITEMDATA_IDENTIFIER_MIGHTY_SCEPTRE =              0x20637337,
    D2S_ITEMDATA_IDENTIFIER_GRAND_SCEPTRE =               0x20637367,
    D2S_ITEMDATA_IDENTIFIER_HOLY_WATER_SPRINKLER =        0x20737139,
    D2S_ITEMDATA_IDENTIFIER_SERAPH_ROD =                  0x20737137,
    D2S_ITEMDATA_IDENTIFIER_WAR_SCEPTRE =                 0x20707377,
    D2S_ITEMDATA_IDENTIFIER_DIVINE_SCEPTRE =              0x20737739,
    D2S_ITEMDATA_IDENTIFIER_CADUCEUS =                    0x20737737,
    D2S_ITEMDATA_IDENTIFIER_KATAR =                       0x2072746B,
    D2S_ITEMDATA_IDENTIFIER_QUHAB =                       0x20726139,
    D2S_ITEMDATA_IDENTIFIER_SUWAYYAH =                    0x20726137,
    D2S_ITEMDATA_IDENTIFIER_WRIST_BLADE =                 0x20627277,
    D2S_ITEMDATA_IDENTIFIER_WRIST_SPIKE =                 0x20627739,
    D2S_ITEMDATA_IDENTIFIER_WRIST_SWORD =                 0x20627737,
    D2S_ITEMDATA_IDENTIFIER_HATCHET_HANDS =               0x20667861,
    D2S_ITEMDATA_IDENTIFIER_FASCIA =                      0x20667839,
    D2S_ITEMDATA_IDENTIFIER_WAR_FIST =                    0x20667837,
    D2S_ITEMDATA_IDENTIFIER_CESTUS =                      0x20736563,
    D2S_ITEMDATA_IDENTIFIER_HAND_SCYTHE =                 0x20736339,
    D2S_ITEMDATA_IDENTIFIER_BATTLE_CESTUS =               0x20736337,
    D2S_ITEMDATA_IDENTIFIER_CLAWS =                       0x20776C63,
    D2S_ITEMDATA_IDENTIFIER_GREATER_CLAWS =               0x20776C39,
    D2S_ITEMDATA_IDENTIFIER_FERAL_CLAWS =                 0x20776C37,
    D2S_ITEMDATA_IDENTIFIER_BLADE_TALONS =                0x206C7462,
    D2S_ITEMDATA_IDENTIFIER_GREATER_TALONS =              0x20776839,
    D2S_ITEMDATA_IDENTIFIER_RUNIC_TALONS =                0x20776837,
    D2S_ITEMDATA_IDENTIFIER_SCISSORS_KATAR =              0x20726B73,
    D2S_ITEMDATA_IDENTIFIER_SCISSORS_QUHAB =              0x20727139,
    D2S_ITEMDATA_IDENTIFIER_SCISSORS_SUWAYYAH =           0x20727137,
    D2S_ITEMDATA_IDENTIFIER_EAGLE_ORB =                   0x2031626F,
    D2S_ITEMDATA_IDENTIFIER_GLOWING_ORB =                 0x2036626F,
    D2S_ITEMDATA_IDENTIFIER_HEAVENLY_STONE =              0x2062626F,
    D2S_ITEMDATA_IDENTIFIER_SACRED_GLOBE =                0x2032626F,
    D2S_ITEMDATA_IDENTIFIER_CRYSTALLINE_GLB =             0x2037626F,
    D2S_ITEMDATA_IDENTIFIER_ELDRITCH_ORB =                0x2063626F,
    D2S_ITEMDATA_IDENTIFIER_SMOKED_SPHERE =               0x2033626F,
    D2S_ITEMDATA_IDENTIFIER_CLOUDY_SPHERE =               0x2038626F,
    D2S_ITEMDATA_IDENTIFIER_DEMON_HEART =                 0x2064626F,
    D2S_ITEMDATA_IDENTIFIER_CLASPED_ORB =                 0x2034626F,
    D2S_ITEMDATA_IDENTIFIER_SPARKLING_BALL =              0x2039626F,
    D2S_ITEMDATA_IDENTIFIER_VORTEX_ORB =                  0x2065626F,
    D2S_ITEMDATA_IDENTIFIER_DRAGON_STONE =                0x2035626F,
    D2S_ITEMDATA_IDENTIFIER_SWIRLING_CRYSTAL =            0x2061626F,
    D2S_ITEMDATA_IDENTIFIER_DIMENSIONAL_SHARD =           0x2066626F,
    D2S_ITEMDATA_IDENTIFIER_STAG_BOW =                    0x20316D61,
    D2S_ITEMDATA_IDENTIFIER_ASHWOOD_BOW =                 0x20366D61,
    D2S_ITEMDATA_IDENTIFIER_MATRIARCHAL_BOW =             0x20626D61,
    D2S_ITEMDATA_IDENTIFIER_REFLEX_BOW =                  0x20326D61,
    D2S_ITEMDATA_IDENTIFIER_CEREMONIAL_BOW =              0x20376D61,
    D2S_ITEMDATA_IDENTIFIER_GRAND_MATRON_BOW =            0x20636D61,
    D2S_ITEMDATA_IDENTIFIER_MAIDEN_SPEAR =                0x20336D61,
    D2S_ITEMDATA_IDENTIFIER_CEREMONIAL_SPEAR =            0x20386D61,
    D2S_ITEMDATA_IDENTIFIER_MATRIARCHAL_SPEAR =           0x20646D61,
    D2S_ITEMDATA_IDENTIFIER_MAIDEN_PIKE =                 0x20346D61,
    D2S_ITEMDATA_IDENTIFIER_CEREMONIAL_PIKE =             0x20396D61,
    D2S_ITEMDATA_IDENTIFIER_MATRIARCHAL_PIKE =            0x20656D61,
    D2S_ITEMDATA_IDENTIFIER_MAIDEN_JAVELIN =              0x20356D61,
    D2S_ITEMDATA_IDENTIFIER_CEREMONIAL_JAVELIN =          0x20616D61,
    D2S_ITEMDATA_IDENTIFIER_MATRIARCHAL_JAVELIN =         0x20666D61,
    D2S_ITEMDATA_IDENTIFIER_CIRCLET =                     0x20306963,
    D2S_ITEMDATA_IDENTIFIER_CORONET =                     0x20316963,
    D2S_ITEMDATA_IDENTIFIER_TIARA =                       0x20326963,
    D2S_ITEMDATA_IDENTIFIER_DIADEM =                      0x20336963,
    D2S_ITEMDATA_IDENTIFIER_RANCID_GAS_POTION =           0x20737067,
    D2S_ITEMDATA_IDENTIFIER_OIL_POTION =                  0x2073706F,
    D2S_ITEMDATA_IDENTIFIER_CHOKING_GAS_POTION =          0x206D7067,
    D2S_ITEMDATA_IDENTIFIER_EXPLODING_POTION =            0x206D706F,
    D2S_ITEMDATA_IDENTIFIER_STRANGLING_GAS_POTION =       0x206C7067,
    D2S_ITEMDATA_IDENTIFIER_FULMINATING_POTION =          0x206C706F,
    D2S_ITEMDATA_IDENTIFIER_WIRTS_LEG =                   0x2067656C,
    D2S_ITEMDATA_IDENTIFIER_HORADRIC_MALUS =              0x206D6468,
    D2S_ITEMDATA_IDENTIFIER_SCROLL_OF_INIFUSS1 =          0x20736B62,
    D2S_ITEMDATA_IDENTIFIER_SCROLL_OF_INIFUSS2 =          0x20646B62,
    D2S_ITEMDATA_IDENTIFIER_BOOK_OF_SKILL =               0x20737361,
    D2S_ITEMDATA_IDENTIFIER_HORADRIC_CUBE =               0x20786F62,
    D2S_ITEMDATA_IDENTIFIER_HORADRIC_SCROLL =             0x20317274,
    D2S_ITEMDATA_IDENTIFIER_STAFF_OF_KINGS =              0x2066736D,
    D2S_ITEMDATA_IDENTIFIER_VIPER_AMULET =                0x20706976,
    D2S_ITEMDATA_IDENTIFIER_HORADRIC_STAFF =              0x20747368,
    D2S_ITEMDATA_IDENTIFIER_POTION_OF_LIFE =              0x207A7978,
    D2S_ITEMDATA_IDENTIFIER_JADE_FIGURINE =               0x2034336A,
    D2S_ITEMDATA_IDENTIFIER_GOLDEN_BIRD =                 0x20343367,
    D2S_ITEMDATA_IDENTIFIER_LAM_ESENS_TOME =              0x20626262,
    D2S_ITEMDATA_IDENTIFIER_GIDBINN =                     0x20333367,
    D2S_ITEMDATA_IDENTIFIER_KHALIMS_FLAIL =               0x20316671,
    D2S_ITEMDATA_IDENTIFIER_KHALIMS_WILL =                0x20326671,
    D2S_ITEMDATA_IDENTIFIER_KHALIMS_EYE =                 0x20796571,
    D2S_ITEMDATA_IDENTIFIER_KHALIMS_HEART =               0x20726871,
    D2S_ITEMDATA_IDENTIFIER_KHALIMS_BRAIN =               0x20726271,
    D2S_ITEMDATA_IDENTIFIER_MEPHISTOS_SOULSTONE =         0x2073736D,
    D2S_ITEMDATA_IDENTIFIER_HELLFORGE_HAMMER =            0x20686668,
    D2S_ITEMDATA_IDENTIFIER_MALAH_POTION =                0x20656369,
    D2S_ITEMDATA_IDENTIFIER_SCROLL_OF_RESISTANCE =        0x20327274,
    D2S_ITEMDATA_IDENTIFIER_CHIPPED_AMETHYST =            0x20766367,
    D2S_ITEMDATA_IDENTIFIER_CHIPPED_DIAMOND =             0x20776367,
    D2S_ITEMDATA_IDENTIFIER_CHIPPED_EMERALD =             0x20676367,
    D2S_ITEMDATA_IDENTIFIER_CHIPPED_RUBY =                0x20726367,
    D2S_ITEMDATA_IDENTIFIER_CHIPPED_SAPHIRE =             0x20626367,
    D2S_ITEMDATA_IDENTIFIER_CHIPPED_SKULL =               0x20636B73,
    D2S_ITEMDATA_IDENTIFIER_CHIPPED_TOPAZ =               0x20796367,
    D2S_ITEMDATA_IDENTIFIER_FLAWED_AMETHYST =             0x20766667,
    D2S_ITEMDATA_IDENTIFIER_FLAWED_DIAMOND =              0x20776667,
    D2S_ITEMDATA_IDENTIFIER_FLAWED_EMERALD =              0x20676667,
    D2S_ITEMDATA_IDENTIFIER_FLAWED_RUBY =                 0x20726667,
    D2S_ITEMDATA_IDENTIFIER_FLAWED_SAPHIRE =              0x20626667,
    D2S_ITEMDATA_IDENTIFIER_FLAWED_SKULL =                0x20666B73,
    D2S_ITEMDATA_IDENTIFIER_FLAWED_TOPAZ =                0x20796667,
    D2S_ITEMDATA_IDENTIFIER_AMETHYST =                    0x20767367,
    D2S_ITEMDATA_IDENTIFIER_DIAMOND =                     0x20777367,
    D2S_ITEMDATA_IDENTIFIER_EMERALD =                     0x20677367,
    D2S_ITEMDATA_IDENTIFIER_RUBY =                        0x20727367,
    D2S_ITEMDATA_IDENTIFIER_SAPHIRE =                     0x20627367,
    D2S_ITEMDATA_IDENTIFIER_SKULL =                       0x20756B73,
    D2S_ITEMDATA_IDENTIFIER_TOPAZ =                       0x20797367,
    D2S_ITEMDATA_IDENTIFIER_FLAWLESS_AMETHYST =           0x20767A67,
    D2S_ITEMDATA_IDENTIFIER_FLAWLESS_DIAMOND =            0x20776C67,
    D2S_ITEMDATA_IDENTIFIER_FLAWLESS_EMERALD =            0x20676C67,
    D2S_ITEMDATA_IDENTIFIER_FLAWLESS_RUBY =               0x20726C67,
    D2S_ITEMDATA_IDENTIFIER_FLAWLESS_SAPHIRE =            0x20626C67,
    D2S_ITEMDATA_IDENTIFIER_FLAWLESS_SKULL =              0x206C6B73,
    D2S_ITEMDATA_IDENTIFIER_FLAWLESS_TOPAZ =              0x20796C67,
    D2S_ITEMDATA_IDENTIFIER_PERFECT_DIAMOND =             0x20777067,
    D2S_ITEMDATA_IDENTIFIER_PERFECT_AMETHYST =            0x20767067,
    D2S_ITEMDATA_IDENTIFIER_PERFECT_SAPPHIRE =            0x20627067,
    D2S_ITEMDATA_IDENTIFIER_PERFECT_TOPAZ =               0x20797067,
    D2S_ITEMDATA_IDENTIFIER_PERFECT_RUBY =                0x20727067,
    D2S_ITEMDATA_IDENTIFIER_PERFECT_SKULL =               0x207A6B73,
    D2S_ITEMDATA_IDENTIFIER_PERFECT_EMERALD =             0x20677067,
    D2S_ITEMDATA_IDENTIFIER_EL_RUNE =                     0x20313072,
    D2S_ITEMDATA_IDENTIFIER_ELD_RUNE =                    0x20323072,
    D2S_ITEMDATA_IDENTIFIER_TIR_RUNE =                    0x20333072,
    D2S_ITEMDATA_IDENTIFIER_NEF_RUNE =                    0x20343072,
    D2S_ITEMDATA_IDENTIFIER_ETH_RUNE =                    0x20353072,
    D2S_ITEMDATA_IDENTIFIER_ITH_RUNE =                    0x20363072,
    D2S_ITEMDATA_IDENTIFIER_TAL_RUNE =                    0x20373072,
    D2S_ITEMDATA_IDENTIFIER_RAL_RUNE =                    0x20383072,
    D2S_ITEMDATA_IDENTIFIER_ORT_RUNE =                    0x20393072,
    D2S_ITEMDATA_IDENTIFIER_THUL_RUNE =                   0x20303172,
    D2S_ITEMDATA_IDENTIFIER_AMN_RUNE =                    0x20313172,
    D2S_ITEMDATA_IDENTIFIER_SOL_RUNE =                    0x20323172,
    D2S_ITEMDATA_IDENTIFIER_SHAEL_RUNE =                  0x20333172,
    D2S_ITEMDATA_IDENTIFIER_DOL_RUNE =                    0x20343172,
    D2S_ITEMDATA_IDENTIFIER_HEL_RUNE =                    0x20353172,
    D2S_ITEMDATA_IDENTIFIER_IO_RUNE =                     0x20363172,
    D2S_ITEMDATA_IDENTIFIER_LUM_RUNE =                    0x20373172,
    D2S_ITEMDATA_IDENTIFIER_KO_RUNE =                     0x20383172,
    D2S_ITEMDATA_IDENTIFIER_FAL_RUNE =                    0x20393172,
    D2S_ITEMDATA_IDENTIFIER_LEM_RUNE =                    0x20303272,
    D2S_ITEMDATA_IDENTIFIER_PUL_RUNE =                    0x20313272,
    D2S_ITEMDATA_IDENTIFIER_UM_RUNE =                     0x20323272,
    D2S_ITEMDATA_IDENTIFIER_MAL_RUNE =                    0x20333272,
    D2S_ITEMDATA_IDENTIFIER_IST_RUNE =                    0x20343272,
    D2S_ITEMDATA_IDENTIFIER_GUL_RUNE =                    0x20353272,
    D2S_ITEMDATA_IDENTIFIER_VEX_RUNE =                    0x20363272,
    D2S_ITEMDATA_IDENTIFIER_OHM_RUNE =                    0x20373272,
    D2S_ITEMDATA_IDENTIFIER_LO_RUNE =                     0x20383272,
    D2S_ITEMDATA_IDENTIFIER_SUR_RUNE =                    0x20393272,
    D2S_ITEMDATA_IDENTIFIER_BER_RUNE =                    0x20303372,
    D2S_ITEMDATA_IDENTIFIER_JAH_RUNE =                    0x20313372,
    D2S_ITEMDATA_IDENTIFIER_CHAM_RUNE =                   0x20323372,
    D2S_ITEMDATA_IDENTIFIER_ZOD_RUNE =                    0x20333372,
    D2S_ITEMDATA_IDENTIFIER_ANTIDOTE_POTION =             0x20737079,
    D2S_ITEMDATA_IDENTIFIER_STAMINA_POTION =              0x20737076,
    D2S_ITEMDATA_IDENTIFIER_THAWING_POTION =              0x20736D77,
    D2S_ITEMDATA_IDENTIFIER_MINOR_HEALING_POTION =        0x20317068,
    D2S_ITEMDATA_IDENTIFIER_MINOR_MANA_POTION =           0x2031706D,
    D2S_ITEMDATA_IDENTIFIER_LIGHT_HEALING_POTION =        0x20327068,
    D2S_ITEMDATA_IDENTIFIER_LIGHT_MANA_POTION =           0x2032706D,
    D2S_ITEMDATA_IDENTIFIER_HEALING_POTION =              0x20337068,
    D2S_ITEMDATA_IDENTIFIER_MANA_POTION =                 0x2033706D,
    D2S_ITEMDATA_IDENTIFIER_GREATER_HEALING_POTION =      0x20347068,
    D2S_ITEMDATA_IDENTIFIER_GREATER_MANA_POTION =         0x2034706D,
    D2S_ITEMDATA_IDENTIFIER_SUPER_HEALING_POTION =        0x20357068,
    D2S_ITEMDATA_IDENTIFIER_SUPER_MANA_POTION =           0x2035706D,
    D2S_ITEMDATA_IDENTIFIER_REJUVENATION_POTION =         0x20737672,
    D2S_ITEMDATA_IDENTIFIER_FULL_REJUVENATION_POTION =    0x206C7672,
    D2S_ITEMDATA_IDENTIFIER_CHARM_SMALL =                 0x20316D63,
    D2S_ITEMDATA_IDENTIFIER_CHARM_LARGE =                 0x20326D63,
    D2S_ITEMDATA_IDENTIFIER_CHARM_GRAND =                 0x20336D63,
    D2S_ITEMDATA_IDENTIFIER_IDENTIFY_SCROLL =             0x20637369,
    D2S_ITEMDATA_IDENTIFIER_TOWN_PORTAL_SCROLL =          0x20637374,
    D2S_ITEMDATA_IDENTIFIER_TOME_OF_TOWN_PORTAL =         0x206B6274,
    D2S_ITEMDATA_IDENTIFIER_TOME_OF_IDENTIFY =            0x206B6269,
    D2S_ITEMDATA_IDENTIFIER_ARROWS =                      0x20767161,
    D2S_ITEMDATA_IDENTIFIER_BOLTS =                       0x20767163,
    D2S_ITEMDATA_IDENTIFIER_JEWEL =                       0x2077656A,
    D2S_ITEMDATA_IDENTIFIER_KEY =                         0x2079656B,
    D2S_ITEMDATA_IDENTIFIER_AMULET =                      0x20756D61,
    D2S_ITEMDATA_IDENTIFIER_GOLD =                        0x20646C67,
    D2S_ITEMDATA_IDENTIFIER_RING =                        0x206E6972,
    D2S_ITEMDATA_IDENTIFIER_EAR =                         0x20726165,
    D2S_ITEMDATA_IDENTIFIER_TORCH =                       0x20686374,
    D2S_ITEMDATA_IDENTIFIER_HEART =                       0x20747268,
    D2S_ITEMDATA_IDENTIFIER_BRAIN =                       0x207A7262,
    D2S_ITEMDATA_IDENTIFIER_JAWBONE =                     0x2077616A,
    D2S_ITEMDATA_IDENTIFIER_EYE =                         0x207A7965,
    D2S_ITEMDATA_IDENTIFIER_HORN =                        0x206E7268,
    D2S_ITEMDATA_IDENTIFIER_HERB =                        0x20627268,
    D2S_ITEMDATA_IDENTIFIER_TAIL =                        0x206C6174,
    D2S_ITEMDATA_IDENTIFIER_FLAG =                        0x20676C66,
    D2S_ITEMDATA_IDENTIFIER_FANG =                        0x20676E66,
    D2S_ITEMDATA_IDENTIFIER_QUILL =                       0x206C6C71,
    D2S_ITEMDATA_IDENTIFIER_SOUL =                        0x206C6F73,
    D2S_ITEMDATA_IDENTIFIER_SCALP =                       0x207A6373,
    D2S_ITEMDATA_IDENTIFIER_SPLEEN =                      0x20657073,
    D2S_ITEMDATA_IDENTIFIER_BLACK_TOWER_KEY =             0x2076756C,
    D2S_ITEMDATA_IDENTIFIER_ELIXIR =                      0x20786C65,
    D2S_ITEMDATA_IDENTIFIER_SCROLL_OF_KNOWLEDGE =         0x20637330
} D2S_ITEMDATA_IDENTIFIER;

typedef enum D2S_ITEMDATA_SET_IDENTIFIER {
    D2S_ITEMDATA_SETITEM_UNKNOWN = -1,
    D2S_ITEMDATA_SETITEM_CIVERBS_WARD = 0,
    D2S_ITEMDATA_SETITEM_CIVERBS_ICON,
    D2S_ITEMDATA_SETITEM_CIVERBS_CUDGEL,
    D2S_ITEMDATA_SETITEM_HSARUS_IRON_HEEL,
    D2S_ITEMDATA_SETITEM_HSARUS_IRON_FIST,
    D2S_ITEMDATA_SETITEM_HSARUS_IRON_STAY,
    D2S_ITEMDATA_SETITEM_CLEGLAWS_TOOTH,
    D2S_ITEMDATA_SETITEM_CLEGLAWS_CLAW,
    D2S_ITEMDATA_SETITEM_CLEGLAWS_PINCERS,
    D2S_ITEMDATA_SETITEM_IRATHAS_COLLAR,
    D2S_ITEMDATA_SETITEM_IRATHAS_CUFF,
    D2S_ITEMDATA_SETITEM_IRATHAS_COIL,
    D2S_ITEMDATA_SETITEM_IRATHAS_CORD,
    D2S_ITEMDATA_SETITEM_ISENHARTS_LIGHTBRAND,
    D2S_ITEMDATA_SETITEM_ISERNHARTS_PARRY,
    D2S_ITEMDATA_SETITEM_ISENHARTS_CASE,
    D2S_ITEMDATA_SETITEM_ISENHARTS_HORNS,
    D2S_ITEMDATA_SETITEM_VIDALAS_BARB,
    D2S_ITEMDATA_SETITEM_VIDALAS_FETLOCK,
    D2S_ITEMDATA_SETITEM_VIDALAS_AMBUSH,
    D2S_ITEMDATA_SETITEM_VIDALAS_SNARE,
    D2S_ITEMDATA_SETITEM_MILABREGAS_ORB,
    D2S_ITEMDATA_SETITEM_MILABREGAS_ROD,
    D2S_ITEMDATA_SETITEM_MILABREGAS_DIADEM,
    D2S_ITEMDATA_SETITEM_MILABREGAS_ROBE,
    D2S_ITEMDATA_SETITEM_CATHANS_RULE,
    D2S_ITEMDATA_SETITEM_CATHANS_MESH,
    D2S_ITEMDATA_SETITEM_CATHANS_VISAGE,
    D2S_ITEMDATA_SETITEM_CATHANS_SIGIL,
    D2S_ITEMDATA_SETITEM_CATHANS_SEAL,
    D2S_ITEMDATA_SETITEM_TANCREDS_CROWBILL,
    D2S_ITEMDATA_SETITEM_TANCREDS_SPINE,
    D2S_ITEMDATA_SETITEM_TANCREDS_HOBNAILS,
    D2S_ITEMDATA_SETITEM_TANCREDS_WEIRD,
    D2S_ITEMDATA_SETITEM_TANCREDS_SKULL,
    D2S_ITEMDATA_SETITEM_SIGONS_GAGE,
    D2S_ITEMDATA_SETITEM_SIGONS_VISOR,
    D2S_ITEMDATA_SETITEM_SIGONS_SHELTER,
    D2S_ITEMDATA_SETITEM_SIGONS_SABOT,
    D2S_ITEMDATA_SETITEM_SIGONS_WRAP,
    D2S_ITEMDATA_SETITEM_SIGONS_GUARD,
    D2S_ITEMDATA_SETITEM_INFERNAL_CRANIUM,
    D2S_ITEMDATA_SETITEM_INFERNAL_TORCH,
    D2S_ITEMDATA_SETITEM_INFERNAL_SIGN,
    D2S_ITEMDATA_SETITEM_BERSEKERS_HEADGEAR,
    D2S_ITEMDATA_SETITEM_BERSEKERS_HAUBERK,
    D2S_ITEMDATA_SETITEM_BERSEKERS_HATCHET,
    D2S_ITEMDATA_SETITEM_DEATHS_HAND,
    D2S_ITEMDATA_SETITEM_DEATHS_GUARD,
    D2S_ITEMDATA_SETITEM_DEATHS_TOUCH,
    D2S_ITEMDATA_SETITEM_ANGELIC_SICKLE,
    D2S_ITEMDATA_SETITEM_ANGELIC_MANTLE,
    D2S_ITEMDATA_SETITEM_ANGELIC_HALO,
    D2S_ITEMDATA_SETITEM_ANGELIC_WINGS,
    D2S_ITEMDATA_SETITEM_ARCTIC_HORNS,
    D2S_ITEMDATA_SETITEM_ARCTIC_FURS,
    D2S_ITEMDATA_SETITEM_ARCTIC_BINDING,
    D2S_ITEMDATA_SETITEM_ARCTIC_MITTS,
    D2S_ITEMDATA_SETITEM_ARCANNAS_SIGN,
    D2S_ITEMDATA_SETITEM_ARCANNAS_DEATHWAND,
    D2S_ITEMDATA_SETITEM_ARCANNAS_HEAD,
    D2S_ITEMDATA_SETITEM_ARCANNAS_FLESH,
    D2S_ITEMDATA_SETITEM_NATALYAS_TOTEM,
    D2S_ITEMDATA_SETITEM_NATALYAS_MARK,
    D2S_ITEMDATA_SETITEM_NATALYAS_SHADOW,
    D2S_ITEMDATA_SETITEM_NATALYAS_SOUL,
    D2S_ITEMDATA_SETITEM_ALDURS_STONY_GAZE,
    D2S_ITEMDATA_SETITEM_ALDURS_DECEPTION,
    D2S_ITEMDATA_SETITEM_ALDURS_RHYTHM,
    D2S_ITEMDATA_SETITEM_ALDURS_ADVANCE,
    D2S_ITEMDATA_SETITEM_IMMORTAL_KINGS_WILL,
    D2S_ITEMDATA_SETITEM_IMMORTAL_KINGS_SOULCAGE,
    D2S_ITEMDATA_SETITEM_IMMORTAL_KINGS_DETAIL,
    D2S_ITEMDATA_SETITEM_IMMORTAL_KINGS_FORGE,
    D2S_ITEMDATA_SETITEM_IMMORTAL_KINGS_PILLAR,
    D2S_ITEMDATA_SETITEM_IMMORTAL_KINGS_STONE_CRUSHER,
    D2S_ITEMDATA_SETITEM_TAL_RASHAS_FIRESPUN_CLOTH,
    D2S_ITEMDATA_SETITEM_TAL_RASHAS_ADJUDICATION,
    D2S_ITEMDATA_SETITEM_TAL_RASHAS_LIDLESS_EYE,
    D2S_ITEMDATA_SETITEM_TAL_RASHAS_GUARDIANSHIP,
    D2S_ITEMDATA_SETITEM_TAL_RASHAS_HORADRIC_CREST,
    D2S_ITEMDATA_SETITEM_GRISWOLDS_VALOR,
    D2S_ITEMDATA_SETITEM_GRISWOLDS_HEART,
    D2S_ITEMDATA_SETITEM_GRISWOLDS_REDEMPTION,
    D2S_ITEMDATA_SETITEM_GRISWOLDS_HONOR,
    D2S_ITEMDATA_SETITEM_TRANGOULS_GUISE,
    D2S_ITEMDATA_SETITEM_TRANGOULS_SCALES,
    D2S_ITEMDATA_SETITEM_TRANGOULS_WING,
    D2S_ITEMDATA_SETITEM_TRANGOULS_CLAWS,
    D2S_ITEMDATA_SETITEM_TRANGOULS_GIRTH,
    D2S_ITEMDATA_SETITEM_MAVINAS_TRUE_SIGHT,
    D2S_ITEMDATA_SETITEM_MAVINAS_EMBRACE,
    D2S_ITEMDATA_SETITEM_MAVINAS_ICY_CLUTCH,
    D2S_ITEMDATA_SETITEM_MAVINAS_TENET,
    D2S_ITEMDATA_SETITEM_MAVINAS_CASTER,
    D2S_ITEMDATA_SETITEM_TELLING_OF_BEADS,
    D2S_ITEMDATA_SETITEM_LAYING_OF_HANDS,
    D2S_ITEMDATA_SETITEM_RITE_OF_PASSAGE,
    D2S_ITEMDATA_SETITEM_DARK_ADHERENT,
    D2S_ITEMDATA_SETITEM_CREDENDUM,
    D2S_ITEMDATA_SETITEM_DRAGOONS_TEACHING,
    D2S_ITEMDATA_SETITEM_TAEBEKS_GLORY,
    D2S_ITEMDATA_SETITEM_HAEMOSUS_ADAMENT,
    D2S_ITEMDATA_SETITEM_ONDALS_ALMIGHTY,
    D2S_ITEMDATA_SETITEM_GUILLAUMES_FACE,
    D2S_ITEMDATA_SETITEM_WILHELMS_PRIDE,
    D2S_ITEMDATA_SETITEM_MAGNUSS_SKIN,
    D2S_ITEMDATA_SETITEM_WIHTSTANS_GUARD,
    D2S_ITEMDATA_SETITEM_HWANINS_SPLENDOR,
    D2S_ITEMDATA_SETITEM_HWANINS_REFUGE,
    D2S_ITEMDATA_SETITEM_HWANINS_BLESSING,
    D2S_ITEMDATA_SETITEM_HWANINS_JUSTICE,
    D2S_ITEMDATA_SETITEM_SAZABIS_COBALT_REDEEMER,
    D2S_ITEMDATA_SETITEM_SAZABIS_GHOST_LIBERATOR,
    D2S_ITEMDATA_SETITEM_SAZABIS_MENTAL_SHEATH,
    D2S_ITEMDATA_SETITEM_BULKATHOSS_SACRED_CHARGE,
    D2S_ITEMDATA_SETITEM_BULKATHOSS_TRIBAL_GUARDIAN,
    D2S_ITEMDATA_SETITEM_COW_KING_HORNS,
    D2S_ITEMDATA_SETITEM_COW_KING_HIDE,
    D2S_ITEMDATA_SETITEM_COW_KING_HOOVES,
    D2S_ITEMDATA_SETITEM_NAJS_PUZZLER,
    D2S_ITEMDATA_SETITEM_NAJS_LIGHT_PLATE,
    D2S_ITEMDATA_SETITEM_NAJS_CIRCLET,
    D2S_ITEMDATA_SETITEM_SANDERS_PARAGON,
    D2S_ITEMDATA_SETITEM_SANDERS_RIPRAP,
    D2S_ITEMDATA_SETITEM_SANDERS_TABOO,
    D2S_ITEMDATA_SETITEM_SANDERS_SUPERSTITION
} D2S_ITEMDATA_SET_IDENTIFIER;

const char* const setNames[] = {
    D2S_ITEMDATA_SETITEM_IDENTIFIER_0,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_1,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_2,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_3,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_4,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_5,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_6,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_7,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_8,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_9,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_10,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_11,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_12,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_13,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_14,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_15,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_16,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_17,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_18,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_19,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_20,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_21,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_22,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_23,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_24,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_25,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_26,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_27,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_28,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_29,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_30,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_31,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_32,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_33,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_34,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_35,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_36,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_37,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_38,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_39,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_40,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_41,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_42,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_43,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_44,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_45,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_46,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_47,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_48,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_49,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_50,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_51,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_52,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_53,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_54,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_55,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_56,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_57,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_58,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_59,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_60,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_61,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_62,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_63,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_64,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_65,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_66,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_67,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_68,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_69,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_70,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_71,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_72,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_73,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_74,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_75,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_76,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_77,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_78,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_79,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_80,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_81,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_82,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_83,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_84,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_85,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_86,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_87,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_88,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_89,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_90,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_91,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_92,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_93,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_94,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_95,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_96,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_97,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_98,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_99,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_100,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_101,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_102,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_103,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_104,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_105,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_106,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_107,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_108,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_109,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_110,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_111,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_112,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_113,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_114,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_115,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_116,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_117,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_118,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_119,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_120,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_121,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_122,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_123,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_124,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_125,
    D2S_ITEMDATA_SETITEM_IDENTIFIER_126
};

typedef enum D2S_ITEMDATA_UNIQUE_IDENTIFIER {
    D2S_ITEMDATA_UNIQUEITEM_UNKNOWN = -1,
    D2S_ITEMDATA_UNIQUEITEM_THE_GNASHER = 0,
    D2S_ITEMDATA_UNIQUEITEM_DEATHSPADE,
    D2S_ITEMDATA_UNIQUEITEM_BLADEBONE,
    D2S_ITEMDATA_UNIQUEITEM_SKULL_SPLITTER,
    D2S_ITEMDATA_UNIQUEITEM_RAKESCAR,
    D2S_ITEMDATA_UNIQUEITEM_AXE_OF_FECHMAR,
    D2S_ITEMDATA_UNIQUEITEM_GORESHOVEL,
    D2S_ITEMDATA_UNIQUEITEM_THE_CHIEFTHAN,
    D2S_ITEMDATA_UNIQUEITEM_BRAINHEW,
    D2S_ITEMDATA_UNIQUEITEM_HUMONGOUS,
    D2S_ITEMDATA_UNIQUEITEM_TORCH_OF_IROS,
    D2S_ITEMDATA_UNIQUEITEM_MAELSTORM,
    D2S_ITEMDATA_UNIQUEITEM_GRAVENSPINE,
    D2S_ITEMDATA_UNIQUEITEM_UMES_LAMENT,
    D2S_ITEMDATA_UNIQUEITEM_FELLOAK,
    D2S_ITEMDATA_UNIQUEITEM_KNELL_STRIKER,
    D2S_ITEMDATA_UNIQUEITEM_RUSTHANDLE,
    D2S_ITEMDATA_UNIQUEITEM_STORMEYE,
    D2S_ITEMDATA_UNIQUEITEM_STOUTNAIL,
    D2S_ITEMDATA_UNIQUEITEM_CRUSHFLANGE,
    D2S_ITEMDATA_UNIQUEITEM_BLOODRISE,
    D2S_ITEMDATA_UNIQUEITEM_THE_GENERALS_TAN_DO_LI_GA,
    D2S_ITEMDATA_UNIQUEITEM_IRONSTONE,
    D2S_ITEMDATA_UNIQUEITEM_BONESNAP,
    D2S_ITEMDATA_UNIQUEITEM_STEELDRIVER,
    D2S_ITEMDATA_UNIQUEITEM_RIXOTS_KEEN,
    D2S_ITEMDATA_UNIQUEITEM_BLOOD_CRESCENT,
    D2S_ITEMDATA_UNIQUEITEM_SKEWER_OF_KRINTIZ,
    D2S_ITEMDATA_UNIQUEITEM_GLEAMSCYTHE,
    D2S_ITEMDATA_UNIQUEITEM_AZUREWRATH_109,
    D2S_ITEMDATA_UNIQUEITEM_GRISWOLDS_EDGE,
    D2S_ITEMDATA_UNIQUEITEM_HELLPLAGUE,
    D2S_ITEMDATA_UNIQUEITEM_CULWENS_POINT,
    D2S_ITEMDATA_UNIQUEITEM_SHADOWFANG,
    D2S_ITEMDATA_UNIQUEITEM_SOULFLAY,
    D2S_ITEMDATA_UNIQUEITEM_KINEMILS_AWL,
    D2S_ITEMDATA_UNIQUEITEM_BLACKTONGUE,
    D2S_ITEMDATA_UNIQUEITEM_RIPSAW,
    D2S_ITEMDATA_UNIQUEITEM_THE_PATRIARCH,
    D2S_ITEMDATA_UNIQUEITEM_GULL,
    D2S_ITEMDATA_UNIQUEITEM_THE_DIGGLER,
    D2S_ITEMDATA_UNIQUEITEM_THE_JADE_TAN_DO,
    D2S_ITEMDATA_UNIQUEITEM_SPECTRAL_SHARD,
    D2S_ITEMDATA_UNIQUEITEM_THE_DRAGON_CHANG,
    D2S_ITEMDATA_UNIQUEITEM_RAZORTINE,
    D2S_ITEMDATA_UNIQUEITEM_BLOODTHIEF,
    D2S_ITEMDATA_UNIQUEITEM_LANCE_OF_YAGGAI,
    D2S_ITEMDATA_UNIQUEITEM_THE_TANNR_GOREROD,
    D2S_ITEMDATA_UNIQUEITEM_DIMOAKS_HEW,
    D2S_ITEMDATA_UNIQUEITEM_STEELGOAD,
    D2S_ITEMDATA_UNIQUEITEM_SOUL_HARVEST,
    D2S_ITEMDATA_UNIQUEITEM_THE_BATTLEBRANCH,
    D2S_ITEMDATA_UNIQUEITEM_WOESTAVE,
    D2S_ITEMDATA_UNIQUEITEM_THE_GRIM_REAPER,
    D2S_ITEMDATA_UNIQUEITEM_BANE_ASH,
    D2S_ITEMDATA_UNIQUEITEM_SERPENT_LORD,
    D2S_ITEMDATA_UNIQUEITEM_SPIRE_OF_LAZARUS,
    D2S_ITEMDATA_UNIQUEITEM_THE_SALAMANDER,
    D2S_ITEMDATA_UNIQUEITEM_THE_IRON_JANG_BONG,
    D2S_ITEMDATA_UNIQUEITEM_PLUCKEYE,
    D2S_ITEMDATA_UNIQUEITEM_WITHERSTRING,
    D2S_ITEMDATA_UNIQUEITEM_RAVEN_CLAW,
    D2S_ITEMDATA_UNIQUEITEM_ROGUES_BOW,
    D2S_ITEMDATA_UNIQUEITEM_STORMSTRIKE,
    D2S_ITEMDATA_UNIQUEITEM_WIZENDRAW,
    D2S_ITEMDATA_UNIQUEITEM_HELLCLAP,
    D2S_ITEMDATA_UNIQUEITEM_BLASTBARK,
    D2S_ITEMDATA_UNIQUEITEM_LEADCROW,
    D2S_ITEMDATA_UNIQUEITEM_ICHORSTING,
    D2S_ITEMDATA_UNIQUEITEM_HELLCAST,
    D2S_ITEMDATA_UNIQUEITEM_DOOMSLINGER,
    D2S_ITEMDATA_UNIQUEITEM_BIGGINS_BONNET,
    D2S_ITEMDATA_UNIQUEITEM_TARNHELM,
    D2S_ITEMDATA_UNIQUEITEM_COIF_OF_GLORY,
    D2S_ITEMDATA_UNIQUEITEM_DUSKDEEP,
    D2S_ITEMDATA_UNIQUEITEM_WORMSKULL,
    D2S_ITEMDATA_UNIQUEITEM_HOWLTUSK,
    D2S_ITEMDATA_UNIQUEITEM_UNDEAD_CROWN,
    D2S_ITEMDATA_UNIQUEITEM_THE_FACE_OF_HORROR,
    D2S_ITEMDATA_UNIQUEITEM_GREYFORM,
    D2S_ITEMDATA_UNIQUEITEM_BLINKBATS_FORM,
    D2S_ITEMDATA_UNIQUEITEM_THE_CENTURION,
    D2S_ITEMDATA_UNIQUEITEM_TWITCHTHROE,
    D2S_ITEMDATA_UNIQUEITEM_DARKGLOW,
    D2S_ITEMDATA_UNIQUEITEM_HAWKMAIL,
    D2S_ITEMDATA_UNIQUEITEM_SPARKING_MAIL,
    D2S_ITEMDATA_UNIQUEITEM_VENOM_WARD,
    D2S_ITEMDATA_UNIQUEITEM_ICEBLINK,
    D2S_ITEMDATA_UNIQUEITEM_BONEFLESH,
    D2S_ITEMDATA_UNIQUEITEM_ROCKFLEECE,
    D2S_ITEMDATA_UNIQUEITEM_RATTLECAGE,
    D2S_ITEMDATA_UNIQUEITEM_GOLDSKIN,
    D2S_ITEMDATA_UNIQUEITEM_VICTORS_SILK,
    D2S_ITEMDATA_UNIQUEITEM_HEAVENLY_GARB,
    D2S_ITEMDATA_UNIQUEITEM_PELTA_LUNATA,
    D2S_ITEMDATA_UNIQUEITEM_UMBRAL_DISK,
    D2S_ITEMDATA_UNIQUEITEM_STORMGUILD,
    D2S_ITEMDATA_UNIQUEITEM_WALL_OF_THE_EYELESS,
    D2S_ITEMDATA_UNIQUEITEM_SWORDBACK_HOLD,
    D2S_ITEMDATA_UNIQUEITEM_STEELCLASH,
    D2S_ITEMDATA_UNIQUEITEM_BVERRIT_KEEP,
    D2S_ITEMDATA_UNIQUEITEM_THE_WARD,
    D2S_ITEMDATA_UNIQUEITEM_THE_HAND_OF_BROC,
    D2S_ITEMDATA_UNIQUEITEM_BLOODFIST,
    D2S_ITEMDATA_UNIQUEITEM_CHANCE_GUARDS,
    D2S_ITEMDATA_UNIQUEITEM_MAGEFIST,
    D2S_ITEMDATA_UNIQUEITEM_FROSTBURN,
    D2S_ITEMDATA_UNIQUEITEM_HOTSPUR,
    D2S_ITEMDATA_UNIQUEITEM_GOREFOOT,
    D2S_ITEMDATA_UNIQUEITEM_TREADS_OF_CTHON,
    D2S_ITEMDATA_UNIQUEITEM_GOBLIN_TOE,
    D2S_ITEMDATA_UNIQUEITEM_TEARHAUNCH,
    D2S_ITEMDATA_UNIQUEITEM_LENYMO,
    D2S_ITEMDATA_UNIQUEITEM_SNAKECORD,
    D2S_ITEMDATA_UNIQUEITEM_NIGHTSMOKE,
    D2S_ITEMDATA_UNIQUEITEM_GOLDWRAP,
    D2S_ITEMDATA_UNIQUEITEM_BLADEBUCKLE,
    D2S_ITEMDATA_UNIQUEITEM_NOKOZAN_RELIC,
    D2S_ITEMDATA_UNIQUEITEM_THE_EYE_OF_ETLICH,
    D2S_ITEMDATA_UNIQUEITEM_THE_MAHIM_OAK_CURIO,
    D2S_ITEMDATA_UNIQUEITEM_NAGELRING,
    D2S_ITEMDATA_UNIQUEITEM_MANALD_HEAL,
    D2S_ITEMDATA_UNIQUEITEM_THE_STONE_OF_JORDAN,
    D2S_ITEMDATA_UNIQUEITEM_AMULET_OF_THE_VIPER,
    D2S_ITEMDATA_UNIQUEITEM_STAFF_OF_KINGS,
    D2S_ITEMDATA_UNIQUEITEM_HORADRIC_STAFF,
    D2S_ITEMDATA_UNIQUEITEM_HELL_FORGE_HAMMER,
    D2S_ITEMDATA_UNIQUEITEM_KHALIMS_FLAIL,
    D2S_ITEMDATA_UNIQUEITEM_SUPER_KHALIMS_FLAIL,
    D2S_ITEMDATA_UNIQUEITEM_COLDKILL,
    D2S_ITEMDATA_UNIQUEITEM_BUTCHERS_PUPIL,
    D2S_ITEMDATA_UNIQUEITEM_ISLESTRIKE,
    D2S_ITEMDATA_UNIQUEITEM_POMPES_WRATH,
    D2S_ITEMDATA_UNIQUEITEM_GUARDIAN_NAGA,
    D2S_ITEMDATA_UNIQUEITEM_WARLORDS_TRUST,
    D2S_ITEMDATA_UNIQUEITEM_SPELLSTEEL,
    D2S_ITEMDATA_UNIQUEITEM_STORMRIDER,
    D2S_ITEMDATA_UNIQUEITEM_BONESLAYER_BLADE,
    D2S_ITEMDATA_UNIQUEITEM_THE_MINATAUR,
    D2S_ITEMDATA_UNIQUEITEM_SUICIDE_BRANCH,
    D2S_ITEMDATA_UNIQUEITEM_CARIN_SHARD,
    D2S_ITEMDATA_UNIQUEITEM_ARM_OF_KING_LEORIC,
    D2S_ITEMDATA_UNIQUEITEM_BLACKHAND_KEY,
    D2S_ITEMDATA_UNIQUEITEM_DARK_CLAN_CRUSHER,
    D2S_ITEMDATA_UNIQUEITEM_ZAKARUMS_HAND,
    D2S_ITEMDATA_UNIQUEITEM_THE_FETID_SPRINKLER,
    D2S_ITEMDATA_UNIQUEITEM_HAND_OF_BLESSED_LIGHT,
    D2S_ITEMDATA_UNIQUEITEM_FLESHRENDER,
    D2S_ITEMDATA_UNIQUEITEM_SURESHRILL_FROST,
    D2S_ITEMDATA_UNIQUEITEM_MOONFALL,
    D2S_ITEMDATA_UNIQUEITEM_BAEZILS_VORTEX,
    D2S_ITEMDATA_UNIQUEITEM_EARTHSHAKER,
    D2S_ITEMDATA_UNIQUEITEM_BLOODTREE_STUMP,
    D2S_ITEMDATA_UNIQUEITEM_THE_GAVEL_OF_PAIN,
    D2S_ITEMDATA_UNIQUEITEM_BLOODLETTER,
    D2S_ITEMDATA_UNIQUEITEM_COLDSTEEL_EYE,
    D2S_ITEMDATA_UNIQUEITEM_HEXFIRE,
    D2S_ITEMDATA_UNIQUEITEM_BLADE_OF_ALI_BABA,
    D2S_ITEMDATA_UNIQUEITEM_GINTHERS_RIFT,
    D2S_ITEMDATA_UNIQUEITEM_HEADSTRIKER,
    D2S_ITEMDATA_UNIQUEITEM_PLAGUE_BEARER,
    D2S_ITEMDATA_UNIQUEITEM_THE_ATLANTIAN,
    D2S_ITEMDATA_UNIQUEITEM_CRAINTE_VOMIR,
    D2S_ITEMDATA_UNIQUEITEM_BING_SZ_WANG,
    D2S_ITEMDATA_UNIQUEITEM_THE_VILE_HUSK,
    D2S_ITEMDATA_UNIQUEITEM_CLOUDCRACK,
    D2S_ITEMDATA_UNIQUEITEM_TODESFAELLE_FLAMME,
    D2S_ITEMDATA_UNIQUEITEM_SWORDGUARD,
    D2S_ITEMDATA_UNIQUEITEM_SPINERIPPER,
    D2S_ITEMDATA_UNIQUEITEM_HEART_CARVER,
    D2S_ITEMDATA_UNIQUEITEM_BLACKBOGS_SHARP,
    D2S_ITEMDATA_UNIQUEITEM_STORMSPIKE,
    D2S_ITEMDATA_UNIQUEITEM_THE_IMPALER,
    D2S_ITEMDATA_UNIQUEITEM_KELPIE_SNARE,
    D2S_ITEMDATA_UNIQUEITEM_SOULFEAST_TINE,
    D2S_ITEMDATA_UNIQUEITEM_HONE_SUNDAN,
    D2S_ITEMDATA_UNIQUEITEM_SPIRE_OF_HONOR,
    D2S_ITEMDATA_UNIQUEITEM_THE_MEAT_SCRAPER,
    D2S_ITEMDATA_UNIQUEITEM_BLACKLEACH_BLADE,
    D2S_ITEMDATA_UNIQUEITEM_ATHENAS_WRATH,
    D2S_ITEMDATA_UNIQUEITEM_PIERRE_TOMBALE_COUANT,
    D2S_ITEMDATA_UNIQUEITEM_HUSOLDAL_EVO,
    D2S_ITEMDATA_UNIQUEITEM_GRIMS_BURNING_DEAD,
    D2S_ITEMDATA_UNIQUEITEM_RAZORSWITCH,
    D2S_ITEMDATA_UNIQUEITEM_RIBCRACKER,
    D2S_ITEMDATA_UNIQUEITEM_CHROMATIC_IRE,
    D2S_ITEMDATA_UNIQUEITEM_WARPSPEAR,
    D2S_ITEMDATA_UNIQUEITEM_SKULLCOLLECTOR,
    D2S_ITEMDATA_UNIQUEITEM_SKYSTRIKE,
    D2S_ITEMDATA_UNIQUEITEM_RIPHOOK,
    D2S_ITEMDATA_UNIQUEITEM_KUKO_SHAKAKU,
    D2S_ITEMDATA_UNIQUEITEM_ENDLESSHAIL,
    D2S_ITEMDATA_UNIQUEITEM_WHICHWILD_STRING,
    D2S_ITEMDATA_UNIQUEITEM_CLIFFKILLER,
    D2S_ITEMDATA_UNIQUEITEM_MAGEWRATH,
    D2S_ITEMDATA_UNIQUEITEM_GODSTRIKE_ARCH,
    D2S_ITEMDATA_UNIQUEITEM_LANGER_BRISER,
    D2S_ITEMDATA_UNIQUEITEM_PUS_SPITER,
    D2S_ITEMDATA_UNIQUEITEM_BURIZA_DO_KYANON,
    D2S_ITEMDATA_UNIQUEITEM_DEMON_MACHINE,
    D2S_ITEMDATA_UNIQUEITEM_ARMOR_UNKNOWN,
    D2S_ITEMDATA_UNIQUEITEM_PEASENT_CROWN,
    D2S_ITEMDATA_UNIQUEITEM_ROCKSTOPPER,
    D2S_ITEMDATA_UNIQUEITEM_STEALSKULL,
    D2S_ITEMDATA_UNIQUEITEM_DARKSIGHT_HELM,
    D2S_ITEMDATA_UNIQUEITEM_VALKYRIE_WING,
    D2S_ITEMDATA_UNIQUEITEM_CROWN_OF_THIEVES,
    D2S_ITEMDATA_UNIQUEITEM_BLCKHORNS_FACE,
    D2S_ITEMDATA_UNIQUEITEM_VAMPIRE_GAZE,
    D2S_ITEMDATA_UNIQUEITEM_THE_SPIRIT_SHROUD,
    D2S_ITEMDATA_UNIQUEITEM_SKIN_OF_THE_VIPERMAGI,
    D2S_ITEMDATA_UNIQUEITEM_SKIN_OF_THE_FLAYED_ONE,
    D2S_ITEMDATA_UNIQUEITEM_IRONPELT,
    D2S_ITEMDATA_UNIQUEITEM_SPIRITFORGE,
    D2S_ITEMDATA_UNIQUEITEM_CROW_CAW,
    D2S_ITEMDATA_UNIQUEITEM_SHAFTSTOP,
    D2S_ITEMDATA_UNIQUEITEM_DURIELS_SHELL,
    D2S_ITEMDATA_UNIQUEITEM_SKULLDERS_IRE,
    D2S_ITEMDATA_UNIQUEITEM_GUARDIAN_ANGEL,
    D2S_ITEMDATA_UNIQUEITEM_TOOTHROW,
    D2S_ITEMDATA_UNIQUEITEM_ATMAS_WAIL,
    D2S_ITEMDATA_UNIQUEITEM_BLACK_HADES,
    D2S_ITEMDATA_UNIQUEITEM_CORPSEMOURN,
    D2S_ITEMDATA_UNIQUEITEM_QUE_HEGANS_WISDOM,
    D2S_ITEMDATA_UNIQUEITEM_VISCERATUANT,
    D2S_ITEMDATA_UNIQUEITEM_MOSERS_BLESSED_CIRCLE,
    D2S_ITEMDATA_UNIQUEITEM_STORMCHASER,
    D2S_ITEMDATA_UNIQUEITEM_TIAMATS_REBUKE,
    D2S_ITEMDATA_UNIQUEITEM_GERKES_SANCTUARY,
    D2S_ITEMDATA_UNIQUEITEM_RADIMANTS_SPHERE,
    D2S_ITEMDATA_UNIQUEITEM_LIDLESS_WALL,
    D2S_ITEMDATA_UNIQUEITEM_LANCE_GUARD,
    D2S_ITEMDATA_UNIQUEITEM_VENOM_GRIP,
    D2S_ITEMDATA_UNIQUEITEM_GRAVEPALM,
    D2S_ITEMDATA_UNIQUEITEM_GHOULHIDE,
    D2S_ITEMDATA_UNIQUEITEM_LAVAGOUT,
    D2S_ITEMDATA_UNIQUEITEM_HELLMOUTH,
    D2S_ITEMDATA_UNIQUEITEM_INFERNOSTRIDE,
    D2S_ITEMDATA_UNIQUEITEM_WATERWALK,
    D2S_ITEMDATA_UNIQUEITEM_SILKWEAVE,
    D2S_ITEMDATA_UNIQUEITEM_WARTRAVELER,
    D2S_ITEMDATA_UNIQUEITEM_GORERIDER,
    D2S_ITEMDATA_UNIQUEITEM_STRING_OF_EARS,
    D2S_ITEMDATA_UNIQUEITEM_RAZORTAIL,
    D2S_ITEMDATA_UNIQUEITEM_GLOOMSTRAP,
    D2S_ITEMDATA_UNIQUEITEM_SNOWCLASH,
    D2S_ITEMDATA_UNIQUEITEM_THUNDERGODS_VIGOR,
    D2S_ITEMDATA_UNIQUEITEM_ELITE_UNIQUE,
    D2S_ITEMDATA_UNIQUEITEM_HARLEQUIN_CREST,
    D2S_ITEMDATA_UNIQUEITEM_VEIL_OF_STEEL,
    D2S_ITEMDATA_UNIQUEITEM_THE_GLADIATORS_BANE,
    D2S_ITEMDATA_UNIQUEITEM_ARKAINES_VALOR,
    D2S_ITEMDATA_UNIQUEITEM_BLACKOAK_SHIELD,
    D2S_ITEMDATA_UNIQUEITEM_STORMSHIELD,
    D2S_ITEMDATA_UNIQUEITEM_HELLSLAYER,
    D2S_ITEMDATA_UNIQUEITEM_MESSERSCHMIDTS_REAVER,
    D2S_ITEMDATA_UNIQUEITEM_BARANARS_STAR,
    D2S_ITEMDATA_UNIQUEITEM_SCHAEFERS_HAMMER,
    D2S_ITEMDATA_UNIQUEITEM_THE_CRANIUM_BASHER,
    D2S_ITEMDATA_UNIQUEITEM_LIGHTSABRE,
    D2S_ITEMDATA_UNIQUEITEM_DOOMBRINGER,
    D2S_ITEMDATA_UNIQUEITEM_THE_GRANDFATHER,
    D2S_ITEMDATA_UNIQUEITEM_WIZARDSPIKE,
    D2S_ITEMDATA_UNIQUEITEM_CONSTRICTING_RING,
    D2S_ITEMDATA_UNIQUEITEM_STORMSPIRE,
    D2S_ITEMDATA_UNIQUEITEM_EAGLEHORN,
    D2S_ITEMDATA_UNIQUEITEM_WINDFORCE,
    D2S_ITEMDATA_UNIQUEITEM_RING,
    D2S_ITEMDATA_UNIQUEITEM_BUL_KATHOS_WEDDING_BAND,
    D2S_ITEMDATA_UNIQUEITEM_THE_CATS_EYE,
    D2S_ITEMDATA_UNIQUEITEM_THE_RISING_SUN,
    D2S_ITEMDATA_UNIQUEITEM_CRESCENT_MOON,
    D2S_ITEMDATA_UNIQUEITEM_MARAS_KALEIDOSCOPE,
    D2S_ITEMDATA_UNIQUEITEM_ATMAS_SCARAB,
    D2S_ITEMDATA_UNIQUEITEM_DWARF_STAR,
    D2S_ITEMDATA_UNIQUEITEM_RAVEN_FROST,
    D2S_ITEMDATA_UNIQUEITEM_HIGHLORDS_WRATH,
    D2S_ITEMDATA_UNIQUEITEM_SARACENS_CHANCE,
    D2S_ITEMDATA_UNIQUEITEM_CLASS_SPECIFIC,
    D2S_ITEMDATA_UNIQUEITEM_ARREATS_FACE,
    D2S_ITEMDATA_UNIQUEITEM_HOMUNCULUS,
    D2S_ITEMDATA_UNIQUEITEM_TITANS_REVENGE,
    D2S_ITEMDATA_UNIQUEITEM_LYCANDERS_AIM,
    D2S_ITEMDATA_UNIQUEITEM_LYCANDERS_FLANK,
    D2S_ITEMDATA_UNIQUEITEM_THE_OCULUS,
    D2S_ITEMDATA_UNIQUEITEM_HERALD_OF_ZAKARUM,
    D2S_ITEMDATA_UNIQUEITEM_BARTUCS_CUT_THROAT,
    D2S_ITEMDATA_UNIQUEITEM_JALALS_MANE,
    D2S_ITEMDATA_UNIQUEITEM_THE_SCALPER,
    D2S_ITEMDATA_UNIQUEITEM_BLOODMOON,
    D2S_ITEMDATA_UNIQUEITEM_DJINNSLAYER,
    D2S_ITEMDATA_UNIQUEITEM_DEATHBIT,
    D2S_ITEMDATA_UNIQUEITEM_WARSHRIKE,
    D2S_ITEMDATA_UNIQUEITEM_GUTSIPHON,
    D2S_ITEMDATA_UNIQUEITEM_RAZOREDGE,
    D2S_ITEMDATA_UNIQUEITEM_GORE_RIPPER,
    D2S_ITEMDATA_UNIQUEITEM_DEMON_LIMB,
    D2S_ITEMDATA_UNIQUEITEM_STEEL_SHADE,
    D2S_ITEMDATA_UNIQUEITEM_TOMB_REAVER,
    D2S_ITEMDATA_UNIQUEITEM_DEATHS_WEB,
    D2S_ITEMDATA_UNIQUEITEM_NATURES_PEACE,
    D2S_ITEMDATA_UNIQUEITEM_AZUREWRATH,
    D2S_ITEMDATA_UNIQUEITEM_SERAPHS_HYMN,
    D2S_ITEMDATA_UNIQUEITEM_ZAKARUMS_SALVATION,
    D2S_ITEMDATA_UNIQUEITEM_FLESHRIPPER,
    D2S_ITEMDATA_UNIQUEITEM_ODIUM,
    D2S_ITEMDATA_UNIQUEITEM_HORIZONS_TORNADO,
    D2S_ITEMDATA_UNIQUEITEM_STONE_CRUSHER,
    D2S_ITEMDATA_UNIQUEITEM_JADE_TALON,
    D2S_ITEMDATA_UNIQUEITEM_SHADOW_DANCER,
    D2S_ITEMDATA_UNIQUEITEM_CEREBUS_BITE,
    D2S_ITEMDATA_UNIQUEITEM_TYRAELS_MIGHT,
    D2S_ITEMDATA_UNIQUEITEM_SOUL_DRAINER,
    D2S_ITEMDATA_UNIQUEITEM_RUNE_MASTER,
    D2S_ITEMDATA_UNIQUEITEM_DEATH_CLEAVER,
    D2S_ITEMDATA_UNIQUEITEM_EXECUTIONERS_JUSTICE,
    D2S_ITEMDATA_UNIQUEITEM_STONERAVEN,
    D2S_ITEMDATA_UNIQUEITEM_LEVIATHAN,
    D2S_ITEMDATA_UNIQUEITEM_LARZUKS_CHAMPION,
    D2S_ITEMDATA_UNIQUEITEM_WISP_PROJECTOR,
    D2S_ITEMDATA_UNIQUEITEM_GARGOYLES_BITE,
    D2S_ITEMDATA_UNIQUEITEM_LACERATOR,
    D2S_ITEMDATA_UNIQUEITEM_MANG_SONGS_LESSON,
    D2S_ITEMDATA_UNIQUEITEM_VIPERFORK,
    D2S_ITEMDATA_UNIQUEITEM_ETHEREAL_EDGE,
    D2S_ITEMDATA_UNIQUEITEM_DEMONHORNS_EDGE,
    D2S_ITEMDATA_UNIQUEITEM_THE_REAPERS_TOLL,
    D2S_ITEMDATA_UNIQUEITEM_SPIRITKEEPER,
    D2S_ITEMDATA_UNIQUEITEM_HELLRACK,
    D2S_ITEMDATA_UNIQUEITEM_ALMA_NEGRA,
    D2S_ITEMDATA_UNIQUEITEM_DARKFORGE_SPAWN,
    D2S_ITEMDATA_UNIQUEITEM_WIDOWMAKER,
    D2S_ITEMDATA_UNIQUEITEM_BLOODRAVENS_CHARGE,
    D2S_ITEMDATA_UNIQUEITEM_GHOSTFLAME,
    D2S_ITEMDATA_UNIQUEITEM_SHADOWKILLER,
    D2S_ITEMDATA_UNIQUEITEM_GIMMERSHRED,
    D2S_ITEMDATA_UNIQUEITEM_GRIFFONS_EYE,
    D2S_ITEMDATA_UNIQUEITEM_WINDHAMMER,
    D2S_ITEMDATA_UNIQUEITEM_THUNDERSTROKE,
    D2S_ITEMDATA_UNIQUEITEM_GIANT_MAIMER,
    D2S_ITEMDATA_UNIQUEITEM_DEMONS_ARCH,
    D2S_ITEMDATA_UNIQUEITEM_BONEFLAME,
    D2S_ITEMDATA_UNIQUEITEM_STEELPILLAR,
    D2S_ITEMDATA_UNIQUEITEM_NIGHTWINGS_VEIL,
    D2S_ITEMDATA_UNIQUEITEM_CROWN_OF_AGES,
    D2S_ITEMDATA_UNIQUEITEM_ANDARIELS_VISAGE,
    D2S_ITEMDATA_UNIQUEITEM_DARKFEAR,
    D2S_ITEMDATA_UNIQUEITEM_DRAGONSCALE,
    D2S_ITEMDATA_UNIQUEITEM_STEEL_CARAPICE,
    D2S_ITEMDATA_UNIQUEITEM_MEDUSAS_GAZE,
    D2S_ITEMDATA_UNIQUEITEM_RAVENLORE,
    D2S_ITEMDATA_UNIQUEITEM_BONESHADE,
    D2S_ITEMDATA_UNIQUEITEM_NETHERCROW,
    D2S_ITEMDATA_UNIQUEITEM_FLAMEBELLOW,
    D2S_ITEMDATA_UNIQUEITEM_FATHOM,
    D2S_ITEMDATA_UNIQUEITEM_WOLFHOWL,
    D2S_ITEMDATA_UNIQUEITEM_SPIRIT_WARD,
    D2S_ITEMDATA_UNIQUEITEM_KIRAS_GUARDIAN,
    D2S_ITEMDATA_UNIQUEITEM_ORMUS_ROBES,
    D2S_ITEMDATA_UNIQUEITEM_GHEEDS_FORTUNE,
    D2S_ITEMDATA_UNIQUEITEM_STORMLASH,
    D2S_ITEMDATA_UNIQUEITEM_HALABERDS_REIGN,
    D2S_ITEMDATA_UNIQUEITEM_WARRIVS_WARDER,
    D2S_ITEMDATA_UNIQUEITEM_SPIKE_THORN,
    D2S_ITEMDATA_UNIQUEITEM_DRACULS_GRASP,
    D2S_ITEMDATA_UNIQUEITEM_FROSTWIND,
    D2S_ITEMDATA_UNIQUEITEM_TEMPLARS_MIGHT,
    D2S_ITEMDATA_UNIQUEITEM_ESCHUTAS_TEMPER,
    D2S_ITEMDATA_UNIQUEITEM_FIRELIZARDS_TALONS,
    D2S_ITEMDATA_UNIQUEITEM_SANDSTORM_TREK,
    D2S_ITEMDATA_UNIQUEITEM_MARROWWALK,
    D2S_ITEMDATA_UNIQUEITEM_HEAVENS_LIGHT,
    D2S_ITEMDATA_UNIQUEITEM_MERMANS_SPEED,
    D2S_ITEMDATA_UNIQUEITEM_ARACHNID_MESH,
    D2S_ITEMDATA_UNIQUEITEM_NOSFERATUS_COIL,
    D2S_ITEMDATA_UNIQUEITEM_METALGRID,
    D2S_ITEMDATA_UNIQUEITEM_VERDUGOS_HEARTY_CORD,
    D2S_ITEMDATA_UNIQUEITEM_SIGURDS_STAUNCH,
    D2S_ITEMDATA_UNIQUEITEM_CARRION_WIND,
    D2S_ITEMDATA_UNIQUEITEM_GIANTSKULL,
    D2S_ITEMDATA_UNIQUEITEM_IRONWARD,
    D2S_ITEMDATA_UNIQUEITEM_ANNIHILUS,
    D2S_ITEMDATA_UNIQUEITEM_ARIOCS_NEEDLE,
    D2S_ITEMDATA_UNIQUEITEM_CRANEBEAK,
    D2S_ITEMDATA_UNIQUEITEM_NORDS_TENDERIZER,
    D2S_ITEMDATA_UNIQUEITEM_EARTHSHIFTER,
    D2S_ITEMDATA_UNIQUEITEM_WRAITHFLIGHT,
    D2S_ITEMDATA_UNIQUEITEM_BONEHEW,
    D2S_ITEMDATA_UNIQUEITEM_ONDALS_WISDOM,
    D2S_ITEMDATA_UNIQUEITEM_THE_REEDEEMER,
    D2S_ITEMDATA_UNIQUEITEM_HEADHUNTERS_GLORY,
    D2S_ITEMDATA_UNIQUEITEM_STEELREND,
    D2S_ITEMDATA_UNIQUEITEM_RAINBOW_FACET1,
    D2S_ITEMDATA_UNIQUEITEM_RAINBOW_FACET2,
    D2S_ITEMDATA_UNIQUEITEM_RAINBOW_FACET3,
    D2S_ITEMDATA_UNIQUEITEM_RAINBOW_FACET4,
    D2S_ITEMDATA_UNIQUEITEM_RAINBOW_FACET5,
    D2S_ITEMDATA_UNIQUEITEM_RAINBOW_FACET6,
    D2S_ITEMDATA_UNIQUEITEM_RAINBOW_FACET7,
    D2S_ITEMDATA_UNIQUEITEM_RAINBOW_FACET8,
    D2S_ITEMDATA_UNIQUEITEM_HELLFIRE_TORCH
} D2S_ITEMDATA_UNIQUE_IDENTIFIER;

const char* const uniqueNames[] = {
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_0,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_1,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_2,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_3,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_4,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_5,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_6,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_7,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_8,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_9,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_10,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_11,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_12,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_13,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_14,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_15,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_16,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_17,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_18,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_19,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_20,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_21,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_22,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_23,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_24,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_25,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_26,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_27,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_28,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_29,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_30,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_31,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_32,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_33,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_34,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_35,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_36,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_37,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_38,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_39,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_40,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_41,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_42,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_43,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_44,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_45,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_46,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_47,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_48,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_49,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_50,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_51,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_52,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_53,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_54,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_55,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_56,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_57,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_58,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_59,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_60,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_61,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_62,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_63,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_64,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_65,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_66,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_67,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_68,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_69,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_70,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_71,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_72,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_73,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_74,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_75,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_76,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_77,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_78,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_79,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_80,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_81,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_82,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_83,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_84,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_85,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_86,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_87,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_88,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_89,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_90,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_91,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_92,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_93,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_94,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_95,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_96,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_97,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_98,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_99,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_100,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_101,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_102,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_103,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_104,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_105,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_106,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_107,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_108,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_109,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_110,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_111,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_112,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_113,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_114,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_115,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_116,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_117,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_118,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_119,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_120,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_121,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_122,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_123,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_124,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_125,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_126,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_127,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_128,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_129,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_130,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_131,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_132,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_133,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_134,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_135,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_136,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_137,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_138,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_139,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_140,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_141,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_142,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_143,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_144,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_145,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_146,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_147,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_148,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_149,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_150,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_151,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_152,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_153,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_154,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_155,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_156,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_157,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_158,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_159,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_160,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_161,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_162,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_163,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_164,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_165,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_166,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_167,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_168,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_169,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_170,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_171,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_172,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_173,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_174,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_175,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_176,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_177,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_178,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_179,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_180,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_181,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_182,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_183,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_184,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_185,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_186,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_187,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_188,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_189,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_190,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_191,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_192,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_193,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_194,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_195,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_196,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_197,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_198,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_199,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_200,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_201,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_202,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_203,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_204,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_205,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_206,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_207,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_208,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_209,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_210,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_211,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_212,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_213,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_214,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_215,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_216,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_217,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_218,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_219,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_220,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_221,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_222,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_223,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_224,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_225,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_226,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_227,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_228,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_229,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_230,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_231,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_232,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_233,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_234,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_235,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_236,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_237,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_238,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_239,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_240,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_241,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_242,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_243,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_244,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_245,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_246,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_247,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_248,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_249,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_250,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_251,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_252,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_253,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_254,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_255,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_256,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_257,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_258,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_259,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_260,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_261,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_262,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_263,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_264,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_265,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_266,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_267,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_268,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_269,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_270,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_271,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_272,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_273,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_274,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_275,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_276,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_277,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_278,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_279,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_280,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_281,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_282,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_283,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_284,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_285,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_286,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_287,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_288,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_289,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_290,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_291,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_292,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_293,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_294,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_295,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_296,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_297,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_298,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_299,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_300,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_301,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_302,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_303,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_304,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_305,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_306,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_307,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_308,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_309,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_310,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_311,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_312,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_313,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_314,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_315,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_316,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_317,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_318,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_319,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_320,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_321,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_322,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_323,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_324,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_325,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_326,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_327,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_328,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_329,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_330,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_331,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_332,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_333,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_334,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_335,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_336,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_337,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_338,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_339,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_340,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_341,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_342,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_343,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_344,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_345,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_346,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_347,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_348,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_349,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_350,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_351,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_352,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_353,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_354,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_355,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_356,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_357,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_358,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_359,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_360,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_361,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_362,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_363,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_364,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_365,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_366,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_367,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_368,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_369,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_370,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_371,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_372,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_373,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_374,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_375,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_376,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_377,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_378,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_379,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_380,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_381,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_382,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_383,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_384,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_385,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_386,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_387,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_388,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_389,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_390,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_391,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_392,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_393,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_394,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_395,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_396,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_397,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_398,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_399,
    D2S_ITEMDATA_UNIQUEITEM_IDENTIFIER_400
};

typedef enum D2S_ITEMDATA_RUNEWORD_IDENTIFIER {
    D2S_ITEMDATA_RUNEWORD_UNKNOWN = -1,
    D2S_ITEMDATA_RUNEWORD_ANCIENTS_PLEDGE = 27,
    D2S_ITEMDATA_RUNEWORD_BEAST = 30,
    D2S_ITEMDATA_RUNEWORD_BLACK = 32,
    D2S_ITEMDATA_RUNEWORD_BONE = 34,
    D2S_ITEMDATA_RUNEWORD_BRAMBLE = 35,
    D2S_ITEMDATA_RUNEWORD_BRAND = 36,
    D2S_ITEMDATA_RUNEWORD_BREATH_OF_THE_DYING = 37,
    D2S_ITEMDATA_RUNEWORD_CALL_TO_ARMS = 39,
    D2S_ITEMDATA_RUNEWORD_CHAINS_OF_HONOR = 40,
    D2S_ITEMDATA_RUNEWORD_CHAOS = 42,
    D2S_ITEMDATA_RUNEWORD_CRESCENT_MOON = 43,
    D2S_ITEMDATA_RUNEWORD_DEATH = 46,
    D2S_ITEMDATA_RUNEWORD_DESTRUCTION = 51,
    D2S_ITEMDATA_RUNEWORD_DOOM = 52,
    D2S_ITEMDATA_RUNEWORD_DRAGON = 53,
    D2S_ITEMDATA_RUNEWORD_DREAM = 55,
    D2S_ITEMDATA_RUNEWORD_DURESS = 56,
    D2S_ITEMDATA_RUNEWORD_EDGE = 57,
    D2S_ITEMDATA_RUNEWORD_ENIGMA = 59,
    D2S_ITEMDATA_RUNEWORD_ENLIGHTENMENT = 60,
    D2S_ITEMDATA_RUNEWORD_ETERNITY = 62,
    D2S_ITEMDATA_RUNEWORD_EXILE = 63,
    D2S_ITEMDATA_RUNEWORD_FAITH = 64,
    D2S_ITEMDATA_RUNEWORD_FAMINE = 65,
    D2S_ITEMDATA_RUNEWORD_FORTITUDE = 67,
    D2S_ITEMDATA_RUNEWORD_FURY = 70,
    D2S_ITEMDATA_RUNEWORD_GLOOM = 71,
    D2S_ITEMDATA_RUNEWORD_GRIEF = 73,
    D2S_ITEMDATA_RUNEWORD_HAND_OF_JUSTICE = 74,
    D2S_ITEMDATA_RUNEWORD_HARMORY = 75,
    D2S_ITEMDATA_RUNEWORD_HEART_OF_THE_OAK = 77,
    D2S_ITEMDATA_RUNEWORD_HOLY_THUNDER = 80,
    D2S_ITEMDATA_RUNEWORD_HONOR = 81,
    D2S_ITEMDATA_RUNEWORD_ICE = 85,
    D2S_ITEMDATA_RUNEWORD_INFINITY = 86,
    D2S_ITEMDATA_RUNEWORD_INSIGHT = 88,
    D2S_ITEMDATA_RUNEWORD_KINGS_GRACE = 91,
    D2S_ITEMDATA_RUNEWORD_KINGSLAYER = 92,
    D2S_ITEMDATA_RUNEWORD_LAST_WISH = 95,
    D2S_ITEMDATA_RUNEWORD_LAWBRINGER = 97,
    D2S_ITEMDATA_RUNEWORD_LEAF = 98,
    D2S_ITEMDATA_RUNEWORD_LIONHEART = 100,
    D2S_ITEMDATA_RUNEWORD_LORE = 101,
    D2S_ITEMDATA_RUNEWORD_MALICE = 106,
    D2S_ITEMDATA_RUNEWORD_MELODY = 107,
    D2S_ITEMDATA_RUNEWORD_MEMORY = 108,
    D2S_ITEMDATA_RUNEWORD_MYTH = 112,
    D2S_ITEMDATA_RUNEWORD_NADIR = 113,
    D2S_ITEMDATA_RUNEWORD_OATH = 116,
    D2S_ITEMDATA_RUNEWORD_OBEDIENCE = 117,
    D2S_ITEMDATA_RUNEWORD_PASSION = 120,
    D2S_ITEMDATA_RUNEWORD_PEACE = 123,
    D2S_ITEMDATA_RUNEWORD_WINTER = 124,
    D2S_ITEMDATA_RUNEWORD_PHOENIX = 128,
    D2S_ITEMDATA_RUNEWORD_PRIDE = 134,
    D2S_ITEMDATA_RUNEWORD_PRINCIPLE = 135,
    D2S_ITEMDATA_RUNEWORD_PRUDENCE = 137,
    D2S_ITEMDATA_RUNEWORD_RADIANCE = 141,
    D2S_ITEMDATA_RUNEWORD_RAIN = 142,
    D2S_ITEMDATA_RUNEWORD_RHYME = 145,
    D2S_ITEMDATA_RUNEWORD_RIFT = 146,
    D2S_ITEMDATA_RUNEWORD_SANCTUARY = 147,
    D2S_ITEMDATA_RUNEWORD_SILENCE = 151,
    D2S_ITEMDATA_RUNEWORD_SMOKE = 153,
    D2S_ITEMDATA_RUNEWORD_SPIRIT = 155,
    D2S_ITEMDATA_RUNEWORD_SPLENDOR = 156,
    D2S_ITEMDATA_RUNEWORD_STEALTH = 158,
    D2S_ITEMDATA_RUNEWORD_STEEL = 159,
    D2S_ITEMDATA_RUNEWORD_STONE = 162,
    D2S_ITEMDATA_RUNEWORD_STRENGTH = 164,
    D2S_ITEMDATA_RUNEWORD_TREACHERY = 173,
    D2S_ITEMDATA_RUNEWORD_VENOM = 179,
    D2S_ITEMDATA_RUNEWORD_WEALTH = 185,
    D2S_ITEMDATA_RUNEWORD_WHITE = 187,
    D2S_ITEMDATA_RUNEWORD_WIND = 188,
    D2S_ITEMDATA_RUNEWORD_WRATH = 193,
    D2S_ITEMDATA_RUNEWORD_ZEPHYR = 195,
    D2S_ITEMDATA_RUNEWORD_DELIRIUM = 2718
} D2S_ITEMDATA_RUNEWORD_IDENTIFIER;

const char* const runewordNames[] = {
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_0,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_1,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_2,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_3,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_4,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_5,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_6,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_7,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_8,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_9,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_10,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_11,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_12,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_13,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_14,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_15,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_16,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_17,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_18,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_19,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_20,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_21,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_22,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_23,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_24,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_25,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_26,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_27,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_28,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_29,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_30,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_31,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_32,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_33,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_34,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_35,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_36,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_37,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_38,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_39,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_40,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_41,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_42,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_43,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_44,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_45,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_46,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_47,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_48,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_49,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_50,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_51,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_52,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_53,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_54,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_55,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_56,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_57,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_58,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_59,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_60,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_61,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_62,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_63,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_64,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_65,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_66,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_67,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_68,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_69,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_70,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_71,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_72,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_73,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_74,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_75,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_76,
    D2S_ITEMDATA_RUNEWORD_IDENTIFIER_77
};

/*
var magicalPrefixes = map[uint64]string{
	2:   "Sturdy",
	3:   "Strong",
	4:   "Glorious",
	5:   "Blessed",
	6:   "Saintly",
	7:   "Holy",
	8:   "Devious",
	9:   "Fortified",
	13:  "Jagged",
	14:  "Deadly",
	15:  "Vicious",
	16:  "Brutal",
	17:  "Massive",
	18:  "Savage",
	19:  "Merciless",
	20:  "Vulpine",
	25:  "Tireless",
	26:  "Rugged",
	27:  "Bronze",
	28:  "Iron",
	29:  "Steel",
	30:  "Silver",
	32:  "Gold",
	33:  "Platinum",
	34:  "Meteoric",
	35:  "Sharp",
	36:  "Fine",
	37:  "Warrior's",
	38:  "Soldier's",
	39:  "Knight's",
	40:  "Lord's",
	41:  "King's",
	42:  "Howling",
	43:  "Fortuitous",
	49:  "Glimmering",
	50:  "Glowing",
	53:  "Lizard's",
	55:  "Snake's",
	56:  "Serpent's",
	57:  "Serpent's",
	58:  "Drake's",
	59:  "Dragon's",
	60:  "Dragon's",
	61:  "Wyrm's",
	64:  "Prismatic",
	65:  "Prismatic",
	66:  "Azure",
	67:  "Lapis",
	68:  "Lapis",
	69:  "Cobalt",
	70:  "Cobalt",
	72:  "Sapphire",
	75:  "Crimson",
	76:  "Burgundy",
	77:  "Burgundy",
	78:  "Garnet",
	79:  "Garnet",
	81:  "Ruby",
	84:  "Ocher",
	85:  "Tangerine",
	86:  "Tangerine",
	87:  "Coral",
	88:  "Coral",
	90:  "Amber",
	93:  "Beryl",
	94:  "Jade",
	95:  "Jade",
	96:  "Viridian",
	97:  "Viridian",
	99:  "Emerald",
	101: "Fletcher's",
	102: "Archer's",
	103: "Archer's",
	104: "Monk's",
	105: "Priest's",
	106: "Priest's",
	107: "Summoner's",
	108: "Necromancer's",
	109: "Necromancer's",
	110: "Angel's",
	111: "Arch-Angel's",
	112: "Arch-Angel's",
	113: "Slayer's",
	114: "Berserker's",
	115: "Berserker's",
	118: "Triumphant",
	119: "Stout",
	120: "Stout",
	121: "Stout",
	122: "Burly",
	123: "Burly",
	124: "Burly",
	125: "Stalwart",
	126: "Stalwart",
	127: "Stalwart",
	128: "Stout",
	129: "Stout",
	130: "Stout",
	131: "Burly",
	132: "Burly",
	133: "Stalwart",
	134: "Stalwart",
	135: "Stout",
	136: "Stout",
	137: "Burly",
	138: "Stalwart",
	139: "Blanched",
	140: "Eburin",
	141: "Bone",
	142: "Ivory",
	143: "Sturdy",
	144: "Sturdy",
	145: "Strong",
	146: "Glorious",
	147: "Blessed",
	148: "Saintly",
	149: "Holy",
	150: "Godly",
	151: "Devious",
	152: "Blank",
	153: "Null",
	154: "Antimagic",
	155: "Red",
	156: "Red",
	157: "Sanguinary",
	158: "Sanguinary",
	159: "Bloody",
	160: "Red",
	161: "Sanguinary",
	162: "Bloody",
	163: "Red",
	164: "Sanguinary",
	165: "Bloody",
	166: "Scarlet",
	167: "Crimson",
	168: "Jagged",
	169: "Jagged",
	170: "Jagged",
	171: "Forked",
	172: "Forked",
	173: "Serrated",
	174: "Serrated",
	175: "Jagged",
	176: "Jagged",
	177: "Forked",
	178: "Forked",
	179: "Serrated",
	180: "Jagged",
	181: "Forked",
	182: "Serrated",
	183: "Carbuncle",
	184: "Carmine",
	185: "Vermillion",
	186: "Jagged",
	187: "Deadly",
	188: "Vicious",
	189: "Brutal",
	190: "Massive",
	191: "Savage",
	192: "Merciless",
	193: "Ferocious",
	194: "Cruel",
	195: "Cinnabar",
	196: "Rusty",
	197: "Realgar",
	198: "Ruby",
	199: "Vulpine",
	200: "Dun",
	201: "Tireless",
	202: "Tireless",
	203: "Brown",
	204: "Rugged",
	205: "Rugged",
	206: "Rugged",
	207: "Rugged",
	208: "Rugged",
	209: "Rugged",
	210: "Rugged",
	211: "Rugged",
	212: "Rugged",
	213: "Rugged",
	214: "Rugged",
	215: "Vigorous",
	216: "Chestnut",
	217: "Maroon",
	218: "Bronze",
	219: "Bronze",
	220: "Bronze",
	221: "Iron",
	222: "Iron",
	223: "Iron",
	224: "Steel",
	225: "Steel",
	226: "Steel",
	227: "Bronze",
	228: "Bronze",
	229: "Bronze",
	230: "Iron",
	231: "Iron",
	232: "Steel",
	233: "Steel",
	234: "Bronze",
	235: "Bronze",
	236: "Iron",
	237: "Steel",
	238: "Bronze",
	239: "Iron",
	240: "Steel",
	241: "Silver",
	242: "Gold",
	243: "Platinum",
	244: "Meteoric",
	245: "Strange",
	246: "Weird",
	247: "Nickel",
	248: "Tin",
	249: "Silver",
	250: "Argent",
	251: "Fine",
	252: "Fine",
	253: "Sharp",
	254: "Fine",
	255: "Sharp",
	256: "Fine",
	257: "Sharp",
	258: "Fine",
	259: "Warrior's",
	260: "Soldier's",
	261: "Knight's",
	262: "Lord's",
	263: "King's",
	264: "Master's",
	265: "Grandmaster's",
	266: "Glimmering",
	267: "Glowing",
	268: "Bright",
	269: "Screaming",
	270: "Howling",
	271: "Wailing",
	272: "Screaming",
	273: "Howling",
	274: "Wailing",
	275: "Lucky",
	276: "Lucky",
	277: "Lucky",
	278: "Lucky",
	279: "Lucky",
	280: "Lucky",
	281: "Felicitous",
	282: "Fortuitous",
	283: "Emerald",
	284: "Lizard's",
	285: "Lizard's",
	286: "Lizard's",
	287: "Snake's",
	288: "Snake's",
	289: "Snake's",
	290: "Serpent's",
	291: "Serpent's",
	292: "Serpent's",
	293: "Lizard's",
	294: "Lizard's",
	295: "Lizard's",
	296: "Snake's",
	297: "Snake's",
	298: "Serpent's",
	299: "Serpent's",
	300: "Lizard's",
	301: "Lizard's",
	302: "Snake's",
	303: "Serpent's",
	304: "Lizard's",
	305: "Snake's",
	306: "Serpent's",
	307: "Serpent's",
	308: "Drake's",
	309: "Dragon's",
	310: "Dragon's",
	311: "Wyrm's",
	312: "Great Wyrm's",
	313: "Bahamut's",
	314: "Zircon",
	315: "Jacinth",
	316: "Turquoise",
	317: "Shimmering",
	318: "Shimmering",
	319: "Shimmering",
	320: "Shimmering",
	321: "Shimmering",
	322: "Shimmering",
	323: "Shimmering",
	324: "Rainbow",
	325: "Scintillating",
	326: "Prismatic",
	327: "Chromatic",
	328: "Shimmering",
	329: "Rainbow",
	330: "Scintillating",
	331: "Prismatic",
	332: "Chromatic",
	333: "Shimmering",
	334: "Rainbow",
	335: "Scintillating",
	336: "Shimmering",
	337: "Scintillating",
	338: "Azure",
	339: "Lapis",
	340: "Cobalt",
	341: "Sapphire",
	342: "Azure",
	343: "Lapis",
	344: "Cobalt",
	345: "Sapphire",
	346: "Azure",
	347: "Lapis",
	348: "Cobalt",
	349: "Sapphire",
	350: "Azure",
	351: "Lapis",
	352: "Lapis",
	353: "Cobalt",
	354: "Cobalt",
	355: "Sapphire",
	356: "Lapis Lazuli",
	357: "Sapphire",
	358: "Crimson",
	359: "Russet",
	360: "Garnet",
	361: "Ruby",
	362: "Crimson",
	363: "Russet",
	364: "Garnet",
	365: "Ruby",
	366: "Crimson",
	367: "Russet",
	368: "Garnet",
	369: "Ruby",
	370: "Russet",
	371: "Russet",
	372: "Garnet",
	373: "Garnet",
	374: "Ruby",
	375: "Garnet",
	376: "Ruby",
	377: "Tangerine",
	378: "Ocher",
	379: "Coral",
	380: "Amber",
	381: "Tangerine",
	382: "Ocher",
	383: "Coral",
	384: "Amber",
	385: "Tangerine",
	386: "Ocher",
	387: "Coral",
	388: "Amber",
	389: "Tangerine",
	390: "Ocher",
	391: "Ocher",
	392: "Coral",
	393: "Coral",
	394: "Amber",
	395: "Camphor",
	396: " Ambergris",
	397: "Beryl",
	398: "Viridian",
	399: "Jade",
	400: "Emerald",
	401: "Beryl",
	402: "Viridian",
	403: "Jade",
	404: "Emerald",
	405: "Beryl",
	406: "Viridian",
	407: "Jade",
	408: "Emerald",
	409: "Beryl",
	410: "Viridian",
	411: "Viridian",
	412: "Jade",
	413: "Jade",
	414: "Emerald",
	415: "Beryl",
	416: "Jade",
	417: "Triumphant",
	418: "Victorious",
	419: "Aureolin",
	420: "Mechanist's",
	421: "Artificer's",
	422: "Jeweler's",
	423: "Assamic",
	424: "Arcadian",
	425: "Unearthly",
	426: "Astral",
	427: "Elysian",
	428: "Celestial",
	429: "Diamond",
	430: "Fletcher's",
	431: "Acrobat's",
	432: "Harpoonist's",
	433: "Fletcher's",
	434: "Bowyer's",
	435: "Archer's",
	436: "Acrobat's",
	437: "Gymnast's",
	438: "Athlete's",
	439: "Harpoonist's",
	440: "Spearmaiden's",
	441: "Lancer's",
	442: "Burning",
	443: "Sparking",
	444: "Chilling",
	445: "Burning",
	446: "Blazing",
	447: "Volcanic",
	448: "Sparking",
	449: "Charged",
	450: "Powered",
	451: "Chilling",
	452: "Freezing",
	453: "Glacial",
	454: "Hexing",
	455: "Fungal",
	456: "Graverobber's",
	457: "Hexing",
	458: "Blighting",
	459: "Accursed",
	460: "Fungal",
	461: "Noxious",
	462: "Venomous",
	463: "Graverobber's",
	464: "Vodoun",
	465: "Golemlord's",
	466: "Lion Branded",
	467: "Captain's",
	468: "Preserver's",
	469: "Lion Branded",
	470: "Hawk Branded",
	471: "Rose Branded",
	472: "Captain's",
	473: "Commander's",
	474: "Marshal's",
	475: "Preserver's",
	476: "Warder's",
	477: "Guardian's",
	478: "Expert's",
	479: "Fanatic",
	480: "Sounding",
	481: "Expert's",
	482: "Veteran's",
	483: "Master's",
	484: "Fanatic",
	485: "Raging",
	486: "Furious",
	487: "Sounding",
	488: "Resonant",
	489: "Echoing",
	490: "Trainer's",
	491: "Spiritual",
	492: "Nature's",
	493: "Trainer's",
	494: "Caretaker's",
	495: "Keeper's",
	496: "Spiritual",
	497: "Feral",
	498: "Communal",
	499: "Nature's",
	500: "Terra's",
	501: "Gaea's",
	502: "Entrapping",
	503: "Mentalist's",
	504: "Shogukusha's",
	505: "Entrapping",
	506: "Trickster's",
	507: "Cunning",
	508: "Mentalist's",
	509: "Psychic",
	510: "Shadow",
	511: "Shogukusha's",
	512: "Sensei's",
	513: "Kenshi's",
	514: "Miocene",
	515: "Miocene",
	516: "Oligocene",
	517: "Oligocene",
	518: "Eocene",
	519: "Eocene",
	520: "Paleocene",
	521: "Paleocene",
	522: "Knave's",
	523: "Jack's",
	524: "Jester's",
	525: "Joker's",
	526: "Trump",
	527: "Loud",
	528: "Calling",
	529: "Yelling",
	530: "Shouting",
	531: "Screaming",
	532: "Paradox",
	533: "Paradox",
	534: "Robineye",
	535: "Sparroweye",
	536: "Falconeye",
	537: "Hawkeye",
	538: "Eagleeye",
	539: "Visionary",
	540: "Mnemonic",
	541: "Snowflake",
	542: "Shivering",
	543: "Boreal",
	544: "Hibernal",
	545: "Ember",
	546: "Smoldering",
	547: "Smoking",
	548: "Flaming",
	549: "Scorching",
	550: "Static",
	551: "Glowing",
	552: "Buzzing",
	553: "Arcing",
	554: "Shocking",
	555: "Septic",
	556: "Envenomed",
	557: "Corosive",
	558: "Toxic",
	559: "Pestilent",
	560: "Maiden's",
	561: "Valkyrie's",
	562: "Maiden's",
	563: "Valkyrie's",
	564: "Monk's",
	565: "Priest's",
	566: "Monk's",
	567: "Priest's",
	568: "Monk's",
	569: "Priest's",
	570: "Summoner's",
	571: "Necromancer's",
	572: "Summoner's",
	573: "Necromancer's",
	574: "Angel's",
	575: "Arch-Angel's",
	576: "Angel's",
	577: "Arch-Angel's",
	578: "Slayer's",
	579: "Berserker's",
	580: "Slayer's",
	581: "Berserker's",
	582: "Slayer's",
	583: "Berserker's",
	584: "Shaman's",
	585: "Hierophant's",
	586: "Shaman's",
	587: "Hierophant's",
	588: "Magekiller's",
	589: "Witch-hunter's",
	590: "Magekiller's",
	591: "Witch-hunter's",
	592: "Compact",
	593: "Thin",
	594: "Dense",
	595: "Consecrated",
	596: "Pure",
	597: "Sacred",
	598: "Hallowed",
	599: "Divine",
	600: "Pearl",
	601: "Crimson",
	602: "Red",
	603: "Sanguinary",
	604: "Bloody",
	605: "Red",
	606: "Sanguinary",
	607: "Red",
	608: "Jagged",
	609: "Forked",
	610: "Serrated",
	611: "Jagged",
	612: "Forked",
	613: "Jagged",
	614: "Snowflake",
	615: "Shivering",
	616: "Boreal",
	617: "Hibernal",
	618: "Snowflake",
	619: "Shivering",
	620: "Boreal",
	621: "Hibernal",
	622: "Snowflake",
	623: "Shivering",
	624: "Boreal",
	625: "Hibernal",
	626: "Ember",
	627: "Smoldering",
	628: "Smoking",
	629: "Flaming",
	630: "Ember",
	631: "Smoldering",
	632: "Smoking",
	633: "Flaming",
	634: "Ember",
	635: "Smoldering",
	636: "Smoking",
	637: "Flaming",
	638: "Static",
	639: "Glowing",
	640: "Arcing",
	641: "Shocking",
	642: "Static",
	643: "Glowing",
	644: "Arcing",
	645: "Shocking",
	646: "Static",
	647: "Glowing",
	648: "Arcing",
	649: "Shocking",
	650: "Septic",
	651: "Envenomed",
	652: "Toxic",
	653: "Pestilent",
	654: "Septic",
	655: "Envenomed",
	656: "Toxic",
	657: "Pestilent",
	658: "Septic",
	659: "Envenomed",
	660: "Toxic",
	661: "Pestilent",
	662: "Tireless",
	663: "Lizard's",
	664: "Azure",
	665: "Crimson",
	666: "Tangerine",
	667: "Beryl",
	668: "Godly",
	669: "Cruel",
}

var magicalSuffixes = map[uint64]string{
	1:   "Health",
	2:   "Protection",
	3:   "Absorption",
	4:   "Life",
	5:   "(nothing?)",
	6:   "Warding",
	7:   "the Sentinel",
	8:   "Guarding",
	9:   "Negation",
	10:  "(nothing?)",
	11:  "Piercing",
	12:  "Bashing",
	13:  "Puncturing",
	14:  "Thorns",
	15:  "Spikes",
	16:  "Fleadiness",
	17:  "Alacrity",
	18:  "Swiitness ",
	19:  "Quickness",
	20:  "Blocking",
	21:  "Deilecting",
	22:  "the Apprentice",
	23:  "the Magus",
	24:  "Frost",
	25:  "the Glacier",
	26:  "Frost",
	27:  "Warmth",
	28:  "Flame",
	29:  "Fire",
	30:  "Burning",
	31:  "Flame",
	32:  "Shook",
	33:  "Lightning",
	34:  "Thunder",
	35:  "Shock",
	36:  "Craftsmanship",
	37:  "Quality",
	38:  "Maiming",
	39:  "Slaying",
	40:  "Gore",
	41:  "Carnage",
	42:  "Slaughter",
	43:  "Maiming",
	44:  "Worth",
	45:  "Measure",
	46:  "Excellence",
	47:  "Petlctmance",
	48:  "Measure",
	49:  "Blight",
	50:  "Venom",
	51:  "Pestilence",
	52:  "Blight",
	53:  "Dextetity",
	54:  "Dextetity",
	55:  "Skill",
	56:  "Skill",
	57:  "Accuracy",
	58:  "Precision",
	59:  "Precision",
	60:  "Petlection",
	61:  "Balance",
	62:  "Stability",
	63:  "(nothing?)",
	64:  "Regenetation",
	65:  "Regenetation",
	66:  "Regenetation",
	67:  "Regrowth",
	68:  "Regrowth",
	69:  "Vileness",
	70:  "(nothing?)",
	71:  "Greed",
	72:  "Wealth",
	73:  "Chance",
	74:  "Fortune",
	75:  "Energy",
	76:  "Energy",
	77:  "the Mind",
	78:  "Brilliance",
	79:  "Sorcery",
	80:  "Wizardry",
	81:  "the Beat",
	82:  "Light",
	83:  "Radiance",
	84:  "the Sun",
	85:  "Life",
	86:  "the Jackal",
	87:  "the Fox",
	88:  "the Wolf",
	89:  "the Wolf",
	90:  "the Tiget",
	91:  "the Mammoth",
	92:  "the Mammoth",
	93:  "the Colosuss",
	94:  "the Leech",
	95:  "the Locust",
	96:  "the Bat",
	97:  "the Vampire",
	98:  "Defiance",
	99:  "Amelioration",
	100: "Remedy",
	101: "(nothing?)",
	102: "Simplicity",
	103: "Ease",
	104: "(nothing?)",
	105: "Strength",
	106: "Might",
	107: "the Ox",
	108: "the Ox",
	109: "the Giant",
	110: "the Giant",
	111: "the Titan",
	112: "Pacing",
	113: "Haste",
	114: "Speed",
	115: "Health",
	116: "Protection",
	117: "Absorption",
	118: "Life",
	119: "Life Everlasting",
	120: "Protection",
	121: "Absorption",
	122: "Life",
	123: "Anima",
	124: "Warding",
	125: "the Sentinel",
	126: "Guarding",
	127: "Negation",
	128: "the Sentinel",
	129: "Guarding",
	130: "Negation",
	131: "Coolness",
	132: "Incombustibility",
	133: "Amianthus",
	134: "Fire Quenching",
	135: "Coolness",
	136: "Incombustibility",
	137: "Amianthus",
	138: "Fire Quenching",
	139: "Faith",
	140: "Resistance",
	141: "Insulation",
	142: "Grounding",
	143: "the Dynamo",
	144: "Resistance",
	145: "Insulation",
	146: "Grounding",
	147: "the Dynamo",
	148: "Stoicism",
	149: "Warming",
	150: "Thawing",
	151: "the Dunes",
	152: "the Sirocco",
	153: "Warming",
	154: "Thawing",
	155: "the Dunes",
	156: "the Sirocco",
	157: "Desire",
	158: "Piercing",
	159: "Bashing",
	160: "Puncturing",
	161: "Thorns",
	162: "Spikes",
	163: "Razors",
	164: "Swords",
	165: "Malice",
	166: "Readiness",
	167: "Alacrity",
	168: "Swiftness",
	169: "Quickness",
	170: "Alacrity",
	171: "Fewer",
	172: "Blocking",
	173: "Deflecting",
	174: "the Apprentice",
	175: "the Magus",
	176: "Frost",
	177: "the Icicle",
	178: "the Glacier",
	179: "Winter",
	180: "Frost",
	181: "Frigidity",
	182: "Warmth",
	183: "Flame",
	184: "Fire",
	185: "Burning",
	186: "Incineration",
	187: "Flame",
	188: "Passion",
	189: "Shock",
	190: "Lightning",
	191: "Thunder",
	192: "Storms",
	193: "Shock",
	194: "Ennui",
	195: "Craftsmanship",
	196: "Quality",
	197: "Maiming",
	198: "Slaying",
	199: "Gore",
	200: "Damage",
	201: "Slaughter",
	202: "Butchery",
	203: "Evisceration",
	204: "Maiming",
	205: "Craftsmanship",
	206: "Craftsmanship",
	207: "Craftsmanship",
	208: "Quality",
	209: "Quality",
	210: "Maiming",
	211: "Maiming",
	212: "Craftsmanship",
	213: "Craftsmanship",
	214: "Quality",
	215: "Quality",
	216: "Maiming",
	217: "Craftsmanship",
	218: "Quality",
	219: "Maiming",
	220: "Ire",
	221: "Wrath",
	222: "Damage",
	223: "Worth",
	224: "Measure",
	225: "Excellence",
	226: "Performance",
	227: "Transcendence",
	228: "Worth",
	229: "Measure",
	230: "Excellence",
	231: "Performance",
	232: "Joyfulness",
	233: "Bliss",
	234: "Blight",
	235: "Venom",
	236: "Pestilence",
	237: "Anthrax",
	238: "Blight",
	239: "Envy",
	240: "Dexterity",
	241: "Skill",
	242: "Accuracy",
	243: "Precision",
	244: "Perfection",
	245: "Nirvana",
	246: "Dexterity",
	247: "Skill",
	248: "Accuracy",
	249: "Precision",
	250: "Perfection",
	251: "Dexterity",
	252: "Skill",
	253: "Accuracy",
	254: "Precision",
	255: "Dexterity",
	256: "Dexterity",
	257: "Dexterity",
	258: "Dexterity",
	259: "Dexterity",
	260: "Dexterity",
	261: "Daring",
	262: "Balance",
	263: "Equilibrium",
	264: "Stability",
	265: "Balance",
	266: "Balance",
	267: "Balance",
	268: "Truth",
	269: "Regeneration",
	270: "Regeneration",
	271: "Regeneration",
	272: "Regrowth",
	273: "Regrowth",
	274: "Revivification",
	275: "Honor",
	276: "Vileness",
	277: "Greed",
	278: "Wealth",
	279: "Greed",
	280: "Greed",
	281: "Greed",
	282: "Greed",
	283: "Greed",
	284: "Greed",
	285: "Avarice",
	286: "Chance",
	287: "Fortune",
	288: "Fortune",
	289: "Luck",
	290: "Fortune",
	291: "Good Luck",
	292: "Prosperity",
	293: "Energy",
	294: "the Mind",
	295: "Brilliance",
	296: "Sorcery",
	297: "Wizardry",
	298: "Enlightenment",
	299: "Energy",
	300: "the Mind",
	301: "Brilliance",
	302: "Sorcery",
	303: "Wizardry",
	304: "Energy",
	305: "the Mind",
	306: "Brilliance",
	307: "Sorcery",
	308: "Knowledge",
	309: "the Bear",
	310: "Light",
	311: "Radiance",
	312: "the Sun",
	313: "the Jackal",
	314: "the Fox",
	315: "the Wolf",
	316: "the Tiger",
	317: "the Mammoth",
	318: "the Colosuss",
	319: "the Squid",
	320: "the Whale",
	321: "the Jackal",
	322: "the Fox",
	323: "the Wolf",
	324: "the Tiger",
	325: "the Mammoth",
	326: "the Colosuss",
	327: "the Jackal",
	328: "the Fox",
	329: "the Wolf",
	330: "the Tiger",
	331: "the Mammoth",
	332: "Life",
	333: "Life",
	334: "Life",
	335: "Substinence",
	336: "Substinence",
	337: "Substinence",
	338: "Vita",
	339: "Vita",
	340: "Vita",
	341: "Life",
	342: "Life",
	343: "Substinence",
	344: "Substinence",
	345: "Vita",
	346: "Vita",
	347: "Life",
	348: "Substinence",
	349: "Vita",
	350: "Spirit",
	351: "Hope",
	352: "the Leech",
	353: "the Locust",
	354: "the Lamprey",
	355: "the Leech",
	356: "the Locust",
	357: "the Lamprey",
	358: "the Leech",
	359: "the Bat",
	360: "the Wraith",
	361: "the Vampire",
	362: "the Bat",
	363: "the Wraith",
	364: "the Vampire",
	365: "the Bat",
	366: "Defiance",
	367: "Amelioration",
	368: "Remedy",
	369: "Simplicity",
	370: "Ease",
	371: "Freedom",
	372: "Strength",
	373: "Might",
	374: "the Ox",
	375: "the Giant",
	376: "the Titan",
	377: "Atlus",
	378: "Strength",
	379: "Might",
	380: "the Us",
	381: "the Giant",
	382: "the Titan",
	383: "Strength",
	384: "Might",
	385: "the Us",
	386: "the Giant",
	387: "Strength",
	388: "Strength",
	389: "Strength",
	390: "Strength",
	391: "Strength",
	392: "Strength",
	393: "Virility",
	394: "Pacing",
	395: "Haste",
	396: "Speed",
	397: "Traveling",
	398: "Acceleration",
	399: "Inertia",
	400: "Inertia",
	401: "Inertia",
	402: "Self-Repair",
	403: "Fast Repair",
	404: "Ages",
	405: "Heplenishing",
	406: "Propagation",
	407: "the Kraken",
	408: "Memory",
	409: "the Elephant",
	410: "Power",
	411: "Grace",
	412: "Grace and Power",
	413: "the Yeti",
	414: "the Phoenix",
	415: "the Efreeti",
	416: "the Cobra",
	417: "the Elements",
	418: "Firebolts",
	419: "Firebolts",
	420: "Firebolts",
	421: "Charged Shield",
	422: "Charged Shield",
	423: "Charged Shield",
	424: "Icebolt",
	425: "Frozen Armor",
	426: "Static Field",
	427: "Telekinesis",
	428: "Frost Shield",
	429: "Ice Blast",
	430: "Blaze",
	431: "Fire Ball",
	432: "Nova",
	433: "Nova",
	434: "Nova Shield",
	435: "Nova Shield",
	436: "Nova Shield",
	437: "Lightning",
	438: "Lightning",
	439: "Shiver Armor",
	440: "Fire Wall",
	441: "Enchant",
	442: "Chain Lightning",
	443: "Chain Lightning",
	444: "Chain Lightning",
	445: "Teleport Shield",
	446: "Teleport Shield",
	447: "Teleport Shield",
	448: "Glacial Spike",
	449: "Meteor",
	450: "Thunder Storm",
	451: "Energy Shield",
	452: "Blizzard",
	453: "Chilling Armor",
	454: "Hydra Shield",
	455: "Frozen ler",
	456: "Dawn",
	457: "Sunlight",
	458: "Magic Arrows",
	459: "Magic Arrows",
	460: "Fire Arrows",
	461: "Fire Arrows",
	462: "lnner Sight",
	463: "Inner Sight",
	464: "Jabbing",
	465: "Jabbing",
	466: "Cold Arrows",
	467: "Cold Arrows",
	468: "Multiple Shot",
	469: "Multiple Shot",
	470: "Power Strike",
	471: "Power Strike",
	472: "Poison Jab",
	473: "Poison Jab",
	474: "Exploding Arrows",
	475: "Exploding Arrows",
	476: "Slow Missiles",
	477: "Slow Missiles",
	478: "lmpaling Strike",
	479: "lmpaling Strike",
	480: "Lightning Javelin",
	481: "Lightning Javelin",
	482: "Ice Arrows",
	483: "Ice Arrows",
	484: "Guided Arrows",
	485: "Guided Arrows",
	486: "Charged Strike",
	487: "Charged Strike",
	488: "Plague Jab",
	489: "Plague Jab",
	490: "lmmolating Arrows",
	491: "lmmolating Arrows",
	492: "Fending",
	493: "Fending",
	494: "Freezing Arrows",
	495: "Freezing Arrows",
	496: "Lightning Strike",
	497: "Lightning Strike",
	498: "Lightning Fury",
	499: "Lightning Fury",
	500: "Fire Bolts",
	501: "Fire Bolts",
	502: "Charged Bolts",
	503: "Charged Bolts",
	504: "Ice Bolts",
	505: "Ice Bolts",
	506: "Frozen Armor",
	507: "Frozen Armor",
	508: "Static Field",
	509: "Static Field",
	510: "Telekinesis",
	511: "Telekinesis",
	512: "Frost Novas",
	513: "Frost Novas",
	514: "Ice Blasts",
	515: "Ice Blasts",
	516: "Blazing",
	517: "Blazing",
	518: "Fire Balls",
	519: "Fire Balls",
	520: "Novas",
	521: "Novas",
	522: "Lightning",
	523: "Lightning",
	524: "Shiver Armor",
	525: "Shiver Armor",
	526: "Fire Walls",
	527: "Fire Walls",
	528: "Enchantment",
	529: "Enchantment",
	530: "Chain Lightning",
	531: "Chain Lightning",
	532: "Teleportation",
	533: "Teleportation",
	534: "Glacial Spikes",
	535: "Glacial Spikes",
	536: "Meteors",
	537: "Meteors",
	538: "Thunder Storm",
	539: "Thunder Storm",
	540: "Energy Shield",
	541: "Energy Shield",
	542: "Blizzards",
	543: "Blizzards",
	544: "Chilling Armor",
	545: "Chilling Armor",
	546: "Hydras",
	547: "Hydras",
	548: "Frozen Orbs",
	549: "Frozen Orbs",
	550: "Amplify Damage",
	551: "Amplify Damage",
	552: "Teeth",
	553: "Teeth",
	554: "Bone Armor",
	555: "Bone Armor",
	556: "Raise Skeletons",
	557: "Raise Skeletons",
	558: "Dim Vision",
	559: "Dim Vision",
	560: "Weaken",
	561: "Weaken",
	562: "Poison Dagger",
	563: "Poison Dagger",
	564: "Corpse Explosions",
	565: "Corpse Explosions",
	566: "Clay Golem Summoning",
	567: "Clay Golem Summoning",
	568: "Iron Maiden",
	569: "Iron Maiden",
	570: "Terror",
	571: "Terror",
	572: "Bone Walls",
	573: "Bone Walls",
	574: "Raise Skeletal Mages",
	575: "Raise Skeletal Mages",
	576: "Confusion",
	577: "Confusion",
	578: "Life Tap",
	579: "Life Tap",
	580: "Poison Explosion",
	581: "Poison Explosion",
	582: "Bone Spears",
	583: "Bone Spears",
	584: "Blood Golem Summoning",
	585: "Blood Golem Summoning",
	586: "Attraction",
	587: "Attraction",
	588: "Decrepification",
	589: "Decrepification",
	590: "Bone Imprisonment",
	591: "Bone Imprisonment",
	592: "Iron Golem Creation",
	593: "Iron Golem Creation",
	594: "Lower Resistance",
	595: "Lower Flesistance",
	596: "Poison Novas",
	597: "Poison Novas",
	598: "Bone Spirits",
	599: "Bone Spirits",
	600: "Fire Golem Summoning",
	601: "Fire Golem Summoning",
	602: "Revivification",
	603: "Revivification",
	604: "Sacrifice",
	605: "Sacrifice",
	606: "Holy Bolts",
	607: "Holy Bolts",
	608: "Zeal",
	609: "Zeal",
	610: "Vengeance",
	611: "Vengeance",
	612: "Blessed Hammers",
	613: "Blessed Hammers",
	614: "Conversion",
	615: "Conversion",
	616: "Fist of the Heavens",
	617: "Fist of the Heavens",
	618: "Bashing",
	619: "Bashing",
	620: "Howling",
	621: "Howling",
	622: "Potion Finding",
	623: "Potion Finding",
	624: "Taunting",
	625: "Taunting",
	626: "Shouting",
	627: "Shouting",
	628: "Stunning",
	629: "Stunning",
	630: "Item Finding",
	631: "Item Finding",
	632: "Concentration",
	633: "Concentration",
	634: "Battle Cry",
	635: "Battle Cry",
	636: "Battle Orders",
	637: "Battle Orders",
	638: "Grim Ward",
	639: "Grim Ward",
	640: "War Cry",
	641: "War Cry",
	642: "Battle Command",
	643: "Battle Command",
	644: "Firestorms",
	645: "Firestorms",
	646: "Molten Boulders",
	647: "Molten Boulders",
	648: "Eruption",
	649: "Eruption",
	650: "Cyclone Armor",
	651: "Cyclone Armor",
	652: "Twister",
	653: "Twister",
	654: "Volcano",
	655: "Volcano",
	656: "Tornado",
	657: "Tornado",
	658: "Armageddon",
	659: "Armageddon",
	660: "Hurricane",
	661: "Hurricane",
	662: "Damage Amplification",
	663: "the Icicle",
	664: "the Glacier",
	665: "Fire",
	666: "Burning",
	667: "Lightning",
	668: "Thunder",
	669: "Daring",
	670: "Daring",
	671: "Knowledge",
	672: "Knowledge",
	673: "Virility",
	674: "Virility",
	675: "Readiness",
	676: "Craftsmanship",
	677: "Quality",
	678: "Maiming",
	679: "Craftsmanship",
	680: "Quality",
	681: "Craftsmanship",
	682: "Blight",
	683: "Venom",
	684: "Pestilence",
	685: "Anthrax",
	686: "Blight",
	687: "Venom",
	688: "Pestilence",
	689: "Anthrax",
	690: "Blight",
	691: "Venom",
	692: "Pestilence",
	693: "Anthrax",
	694: "Frost",
	695: "the Icicle",
	696: "the Glacier",
	697: "Winter",
	698: "Frost",
	699: "the Icicle",
	700: "the Glacier",
	701: "Winter",
	702: "Frost",
	703: "the Icicle",
	704: "the Glacier",
	705: "Winter",
	706: "Flame",
	707: "Fire",
	708: "Burning",
	709: "Incineration",
	710: "Flame",
	711: "Fire",
	712: "Burning",
	713: "Incineration",
	714: "Flame",
	715: "Fire",
	716: "Burning",
	717: "Incineration",
	718: "Shock",
	719: "Lightning",
	720: "Thunder",
	721: "Storms",
	722: "Shock",
	723: "Lightning",
	724: "Thunder",
	725: "Storms",
	726: "Shock",
	727: "Lightning",
	728: "Thunder",
	729: "Storms",
	730: "Dexterity",
	731: "Dexterity",
	732: "Strength",
	733: "Strength",
	734: "Thorns",
	735: "Frost",
	736: "Flame",
	737: "Blight",
	738: "Shock",
	739: "Regeneration",
	740: "Energy",
	741: "Light",
	742: "the Leech",
	743: "the Locust",
	744: "the Lamprey",
	745: "the Bat",
	746: "the Wraith",
	747: "the Vampire",
*/

typedef enum D2S_ITEMDATA_PREFIX_IDENTIFIER {
    TODO = 0
} D2S_ITEMDATA_PREFIX_IDENTIFIER;

typedef enum D2S_ITEMDATA_SUFFIX_IDENTIFIER {
    TODO = 0
} D2S_ITEMDATA_SUFFIX_IDENTIFIER;

typedef enum D2S_ITEMDATA_RARENAME_IDENTIFIER {
    D2s_ITEMDATA_RAREITEM_NAME_UNKNOWN = -1,
    D2S_ITEMDATA_RAREITEM_NAME_BITE = 0,
    D2S_ITEMDATA_RAREITEM_NAME_SCRATCH,
    D2S_ITEMDATA_RAREITEM_NAME_SCALPEL,
    D2S_ITEMDATA_RAREITEM_NAME_FANG,
    D2S_ITEMDATA_RAREITEM_NAME_GUTTER,
    D2S_ITEMDATA_RAREITEM_NAME_THIRST,
    D2S_ITEMDATA_RAREITEM_NAME_RAZOR,
    D2S_ITEMDATA_RAREITEM_NAME_SCYTHE,
    D2S_ITEMDATA_RAREITEM_NAME_EDGE,
    D2S_ITEMDATA_RAREITEM_NAME_SAW,
    D2S_ITEMDATA_RAREITEM_NAME_SPLITTER,
    D2S_ITEMDATA_RAREITEM_NAME_CLEAVER,
    D2S_ITEMDATA_RAREITEM_NAME_SEVER,
    D2S_ITEMDATA_RAREITEM_NAME_SUNDER,
    D2S_ITEMDATA_RAREITEM_NAME_REND,
    D2S_ITEMDATA_RAREITEM_NAME_MANGLER,
    D2S_ITEMDATA_RAREITEM_NAME_SLAYER,
    D2S_ITEMDATA_RAREITEM_NAME_REAVER,
    D2S_ITEMDATA_RAREITEM_NAME_SPAWN,
    D2S_ITEMDATA_RAREITEM_NAME_GNASH,
    D2S_ITEMDATA_RAREITEM_NAME_STAR,
    D2S_ITEMDATA_RAREITEM_NAME_BLOW,
    D2S_ITEMDATA_RAREITEM_NAME_SMASHER,
    D2S_ITEMDATA_RAREITEM_NAME_BANE,
    D2S_ITEMDATA_RAREITEM_NAME_CRUSHER,
    D2S_ITEMDATA_RAREITEM_NAME_BREAKER,
    D2S_ITEMDATA_RAREITEM_NAME_GRINDER,
    D2S_ITEMDATA_RAREITEM_NAME_CRACK,
    D2S_ITEMDATA_RAREITEM_NAME_MALLET,
    D2S_ITEMDATA_RAREITEM_NAME_KNELL,
    D2S_ITEMDATA_RAREITEM_NAME_LANCE,
    D2S_ITEMDATA_RAREITEM_NAME_SPIKE,
    D2S_ITEMDATA_RAREITEM_NAME_IMPALER,
    D2S_ITEMDATA_RAREITEM_NAME_SKEWER,
    D2S_ITEMDATA_RAREITEM_NAME_PROD,
    D2S_ITEMDATA_RAREITEM_NAME_SCOURGE,
    D2S_ITEMDATA_RAREITEM_NAME_WAND,
    D2S_ITEMDATA_RAREITEM_NAME_WRACK,
    D2S_ITEMDATA_RAREITEM_NAME_BARB,
    D2S_ITEMDATA_RAREITEM_NAME_NEEDLE,
    D2S_ITEMDATA_RAREITEM_NAME_DART,
    D2S_ITEMDATA_RAREITEM_NAME_BOLT,
    D2S_ITEMDATA_RAREITEM_NAME_QUARREL,
    D2S_ITEMDATA_RAREITEM_NAME_FLETCH,
    D2S_ITEMDATA_RAREITEM_NAME_FLIGHT,
    D2S_ITEMDATA_RAREITEM_NAME_NOCK,
    D2S_ITEMDATA_RAREITEM_NAME_HORN,
    D2S_ITEMDATA_RAREITEM_NAME_STINGER,
    D2S_ITEMDATA_RAREITEM_NAME_QUILL,
    D2S_ITEMDATA_RAREITEM_NAME_GOAD,
    D2S_ITEMDATA_RAREITEM_NAME_BRANCH,
    D2S_ITEMDATA_RAREITEM_NAME_SPIRE,
    D2S_ITEMDATA_RAREITEM_NAME_SONG,
    D2S_ITEMDATA_RAREITEM_NAME_CALL,
    D2S_ITEMDATA_RAREITEM_NAME_CRY,
    D2S_ITEMDATA_RAREITEM_NAME_SPELL,
    D2S_ITEMDATA_RAREITEM_NAME_CHANT,
    D2S_ITEMDATA_RAREITEM_NAME_WEAVER,
    D2S_ITEMDATA_RAREITEM_NAME_GNARL,
    D2S_ITEMDATA_RAREITEM_NAME_VISAGE,
    D2S_ITEMDATA_RAREITEM_NAME_CREST,
    D2S_ITEMDATA_RAREITEM_NAME_CIRCLET,
    D2S_ITEMDATA_RAREITEM_NAME_VEIL,
    D2S_ITEMDATA_RAREITEM_NAME_HOOD,
    D2S_ITEMDATA_RAREITEM_NAME_MASK,
    D2S_ITEMDATA_RAREITEM_NAME_BROW,
    D2S_ITEMDATA_RAREITEM_NAME_CASQUE,
    D2S_ITEMDATA_RAREITEM_NAME_VISOR,
    D2S_ITEMDATA_RAREITEM_NAME_COWL,
    D2S_ITEMDATA_RAREITEM_NAME_HIDE,
    D2S_ITEMDATA_RAREITEM_NAME_PELT,
    D2S_ITEMDATA_RAREITEM_NAME_CARAPACE,
    D2S_ITEMDATA_RAREITEM_NAME_COAT,
    D2S_ITEMDATA_RAREITEM_NAME_WRAP,
    D2S_ITEMDATA_RAREITEM_NAME_SUIT,
    D2S_ITEMDATA_RAREITEM_NAME_CLOAK,
    D2S_ITEMDATA_RAREITEM_NAME_SHROUD,
    D2S_ITEMDATA_RAREITEM_NAME_JACK,
    D2S_ITEMDATA_RAREITEM_NAME_MANTLE,
    D2S_ITEMDATA_RAREITEM_NAME_GUARD,
    D2S_ITEMDATA_RAREITEM_NAME_BADGE,
    D2S_ITEMDATA_RAREITEM_NAME_ROCK,
    D2S_ITEMDATA_RAREITEM_NAME_AEGIS,
    D2S_ITEMDATA_RAREITEM_NAME_WARD,
    D2S_ITEMDATA_RAREITEM_NAME_TOWER,
    D2S_ITEMDATA_RAREITEM_NAME_SHIELD,
    D2S_ITEMDATA_RAREITEM_NAME_WING,
    D2S_ITEMDATA_RAREITEM_NAME_MARK,
    D2S_ITEMDATA_RAREITEM_NAME_EMBLEM,
    D2S_ITEMDATA_RAREITEM_NAME_HAND,
    D2S_ITEMDATA_RAREITEM_NAME_FIST,
    D2S_ITEMDATA_RAREITEM_NAME_CLAW,
    D2S_ITEMDATA_RAREITEM_NAME_CLUTCHES,
    D2S_ITEMDATA_RAREITEM_NAME_GRIP,
    D2S_ITEMDATA_RAREITEM_NAME_GRASP,
    D2S_ITEMDATA_RAREITEM_NAME_HOLD,
    D2S_ITEMDATA_RAREITEM_NAME_TORCH,
    D2S_ITEMDATA_RAREITEM_NAME_FINGER,
    D2S_ITEMDATA_RAREITEM_NAME_KNUCKLE,
    D2S_ITEMDATA_RAREITEM_NAME_SHANK,
    D2S_ITEMDATA_RAREITEM_NAME_SPUR,
    D2S_ITEMDATA_RAREITEM_NAME_TREAD,
    D2S_ITEMDATA_RAREITEM_NAME_STALKER,
    D2S_ITEMDATA_RAREITEM_NAME_GREAVE,
    D2S_ITEMDATA_RAREITEM_NAME_BLAZER,
    D2S_ITEMDATA_RAREITEM_NAME_NAILS,
    D2S_ITEMDATA_RAREITEM_NAME_TRAMPLE,
    D2S_ITEMDATA_RAREITEM_NAME_BROGUES,
    D2S_ITEMDATA_RAREITEM_NAME_TRACK,
    D2S_ITEMDATA_RAREITEM_NAME_SLIPPERS,
    D2S_ITEMDATA_RAREITEM_NAME_CLASP,
    D2S_ITEMDATA_RAREITEM_NAME_BUCKLE,
    D2S_ITEMDATA_RAREITEM_NAME_HARNESS,
    D2S_ITEMDATA_RAREITEM_NAME_LOCK,
    D2S_ITEMDATA_RAREITEM_NAME_FRINGE,
    D2S_ITEMDATA_RAREITEM_NAME_WINDING,
    D2S_ITEMDATA_RAREITEM_NAME_CHAIN,
    D2S_ITEMDATA_RAREITEM_NAME_STRAP,
    D2S_ITEMDATA_RAREITEM_NAME_LASH,
    D2S_ITEMDATA_RAREITEM_NAME_CORD,
    D2S_ITEMDATA_RAREITEM_NAME_KNOT,
    D2S_ITEMDATA_RAREITEM_NAME_CIRCLE,
    D2S_ITEMDATA_RAREITEM_NAME_LOOP,
    D2S_ITEMDATA_RAREITEM_NAME_EYE,
    D2S_ITEMDATA_RAREITEM_NAME_TURN,
    D2S_ITEMDATA_RAREITEM_NAME_SPIRAL,
    D2S_ITEMDATA_RAREITEM_NAME_COIL,
    D2S_ITEMDATA_RAREITEM_NAME_GYRE,
    D2S_ITEMDATA_RAREITEM_NAME_BAND,
    D2S_ITEMDATA_RAREITEM_NAME_WHORL,
    D2S_ITEMDATA_RAREITEM_NAME_TALISMAN,
    D2S_ITEMDATA_RAREITEM_NAME_HEART,
    D2S_ITEMDATA_RAREITEM_NAME_NOOSE,
    D2S_ITEMDATA_RAREITEM_NAME_NECKLACE,
    D2S_ITEMDATA_RAREITEM_NAME_COLLAR,
    D2S_ITEMDATA_RAREITEM_NAME_BEADS,
    D2S_ITEMDATA_RAREITEM_NAME_TORC,
    D2S_ITEMDATA_RAREITEM_NAME_GORGET,
    D2S_ITEMDATA_RAREITEM_NAME_SCARAB,
    D2S_ITEMDATA_RAREITEM_NAME_WOOD,
    D2S_ITEMDATA_RAREITEM_NAME_BRAND,
    D2S_ITEMDATA_RAREITEM_NAME_BLUDGEON,
    D2S_ITEMDATA_RAREITEM_NAME_CUDGEL,
    D2S_ITEMDATA_RAREITEM_NAME_LOOM,
    D2S_ITEMDATA_RAREITEM_NAME_HARP,
    D2S_ITEMDATA_RAREITEM_NAME_MASTER,
    D2S_ITEMDATA_RAREITEM_NAME_BARL,
    D2S_ITEMDATA_RAREITEM_NAME_HEW,
    D2S_ITEMDATA_RAREITEM_NAME_CROOK,
    D2S_ITEMDATA_RAREITEM_NAME_MAR,
    D2S_ITEMDATA_RAREITEM_NAME_SHELL,
    D2S_ITEMDATA_RAREITEM_NAME_STAKE,
    D2S_ITEMDATA_RAREITEM_NAME_PICKET,
    D2S_ITEMDATA_RAREITEM_NAME_PALE,
    D2S_ITEMDATA_RAREITEM_NAME_FLANGE,
    D2S_ITEMDATA_RAREITEM_NAME_BEAST,
    D2S_ITEMDATA_RAREITEM_NAME_EAGLE,
    D2S_ITEMDATA_RAREITEM_NAME_RAVEN,
    D2S_ITEMDATA_RAREITEM_NAME_VIPER,
    D2S_ITEMDATA_RAREITEM_NAME_GHOUL,
    D2S_ITEMDATA_RAREITEM_NAME_SKULL,
    D2S_ITEMDATA_RAREITEM_NAME_BLOOD,
    D2S_ITEMDATA_RAREITEM_NAME_DREAD,
    D2S_ITEMDATA_RAREITEM_NAME_DOOM,
    D2S_ITEMDATA_RAREITEM_NAME_GRIM,
    D2S_ITEMDATA_RAREITEM_NAME_BONE,
    D2S_ITEMDATA_RAREITEM_NAME_DEATH,
    D2S_ITEMDATA_RAREITEM_NAME_SHADOW,
    D2S_ITEMDATA_RAREITEM_NAME_STORM1,
    D2S_ITEMDATA_RAREITEM_NAME_RUNE,
    D2S_ITEMDATA_RAREITEM_NAME_PLAGUE,
    D2S_ITEMDATA_RAREITEM_NAME_STONE,
    D2S_ITEMDATA_RAREITEM_NAME_WRAITH,
    D2S_ITEMDATA_RAREITEM_NAME_SPIRIT,
    D2S_ITEMDATA_RAREITEM_NAME_STORM2,
    D2S_ITEMDATA_RAREITEM_NAME_DEMON,
    D2S_ITEMDATA_RAREITEM_NAME_CRUEL,
    D2S_ITEMDATA_RAREITEM_NAME_EMPYRION,
    D2S_ITEMDATA_RAREITEM_NAME_BRAMBLE,
    D2S_ITEMDATA_RAREITEM_NAME_PAIN,
    D2S_ITEMDATA_RAREITEM_NAME_LOATH,
    D2S_ITEMDATA_RAREITEM_NAME_GLYPH,
    D2S_ITEMDATA_RAREITEM_NAME_IMP,
    D2S_ITEMDATA_RAREITEM_NAME_FIENDRA,
    D2S_ITEMDATA_RAREITEM_NAME_HAILSTONE,
    D2S_ITEMDATA_RAREITEM_NAME_GALE,
    D2S_ITEMDATA_RAREITEM_NAME_DIRE,
    D2S_ITEMDATA_RAREITEM_NAME_SOUL,
    D2S_ITEMDATA_RAREITEM_NAME_BRIMSTONE,
    D2S_ITEMDATA_RAREITEM_NAME_CORPSE,
    D2S_ITEMDATA_RAREITEM_NAME_CARRION,
    D2S_ITEMDATA_RAREITEM_NAME_ARMAGEDDON,
    D2S_ITEMDATA_RAREITEM_NAME_HAVOC,
    D2S_ITEMDATA_RAREITEM_NAME_BITTER,
    D2S_ITEMDATA_RAREITEM_NAME_ENTROPY,
    D2S_ITEMDATA_RAREITEM_NAME_CHAOS,
    D2S_ITEMDATA_RAREITEM_NAME_ORDER,
    D2S_ITEMDATA_RAREITEM_NAME_RULE,
    D2S_ITEMDATA_RAREITEM_NAME_WARP,
    D2S_ITEMDATA_RAREITEM_NAME_RIFT,
    D2S_ITEMDATA_RAREITEM_NAME_CORRUPTION
} D2S_ITEMDATA_RARENAME_IDENTIFIER;

const char* const rareNames[] = {
    D2S_ITEMDATA_RAREITEM_NAME_0,
    D2S_ITEMDATA_RAREITEM_NAME_1,
    D2S_ITEMDATA_RAREITEM_NAME_2,
    D2S_ITEMDATA_RAREITEM_NAME_3,
    D2S_ITEMDATA_RAREITEM_NAME_4,
    D2S_ITEMDATA_RAREITEM_NAME_5,
    D2S_ITEMDATA_RAREITEM_NAME_6,
    D2S_ITEMDATA_RAREITEM_NAME_7,
    D2S_ITEMDATA_RAREITEM_NAME_8,
    D2S_ITEMDATA_RAREITEM_NAME_9,
    D2S_ITEMDATA_RAREITEM_NAME_10,
    D2S_ITEMDATA_RAREITEM_NAME_11,
    D2S_ITEMDATA_RAREITEM_NAME_12,
    D2S_ITEMDATA_RAREITEM_NAME_13,
    D2S_ITEMDATA_RAREITEM_NAME_14,
    D2S_ITEMDATA_RAREITEM_NAME_15,
    D2S_ITEMDATA_RAREITEM_NAME_16,
    D2S_ITEMDATA_RAREITEM_NAME_17,
    D2S_ITEMDATA_RAREITEM_NAME_18,
    D2S_ITEMDATA_RAREITEM_NAME_19,
    D2S_ITEMDATA_RAREITEM_NAME_20,
    D2S_ITEMDATA_RAREITEM_NAME_21,
    D2S_ITEMDATA_RAREITEM_NAME_22,
    D2S_ITEMDATA_RAREITEM_NAME_23,
    D2S_ITEMDATA_RAREITEM_NAME_24,
    D2S_ITEMDATA_RAREITEM_NAME_25,
    D2S_ITEMDATA_RAREITEM_NAME_26,
    D2S_ITEMDATA_RAREITEM_NAME_27,
    D2S_ITEMDATA_RAREITEM_NAME_28,
    D2S_ITEMDATA_RAREITEM_NAME_29,
    D2S_ITEMDATA_RAREITEM_NAME_30,
    D2S_ITEMDATA_RAREITEM_NAME_31,
    D2S_ITEMDATA_RAREITEM_NAME_32,
    D2S_ITEMDATA_RAREITEM_NAME_33,
    D2S_ITEMDATA_RAREITEM_NAME_34,
    D2S_ITEMDATA_RAREITEM_NAME_35,
    D2S_ITEMDATA_RAREITEM_NAME_36,
    D2S_ITEMDATA_RAREITEM_NAME_37,
    D2S_ITEMDATA_RAREITEM_NAME_38,
    D2S_ITEMDATA_RAREITEM_NAME_39,
    D2S_ITEMDATA_RAREITEM_NAME_40,
    D2S_ITEMDATA_RAREITEM_NAME_41,
    D2S_ITEMDATA_RAREITEM_NAME_42,
    D2S_ITEMDATA_RAREITEM_NAME_43,
    D2S_ITEMDATA_RAREITEM_NAME_44,
    D2S_ITEMDATA_RAREITEM_NAME_45,
    D2S_ITEMDATA_RAREITEM_NAME_46,
    D2S_ITEMDATA_RAREITEM_NAME_47,
    D2S_ITEMDATA_RAREITEM_NAME_48,
    D2S_ITEMDATA_RAREITEM_NAME_49,
    D2S_ITEMDATA_RAREITEM_NAME_50,
    D2S_ITEMDATA_RAREITEM_NAME_51,
    D2S_ITEMDATA_RAREITEM_NAME_52,
    D2S_ITEMDATA_RAREITEM_NAME_53,
    D2S_ITEMDATA_RAREITEM_NAME_54,
    D2S_ITEMDATA_RAREITEM_NAME_55,
    D2S_ITEMDATA_RAREITEM_NAME_56,
    D2S_ITEMDATA_RAREITEM_NAME_57,
    D2S_ITEMDATA_RAREITEM_NAME_58,
    D2S_ITEMDATA_RAREITEM_NAME_59,
    D2S_ITEMDATA_RAREITEM_NAME_60,
    D2S_ITEMDATA_RAREITEM_NAME_61,
    D2S_ITEMDATA_RAREITEM_NAME_62,
    D2S_ITEMDATA_RAREITEM_NAME_63,
    D2S_ITEMDATA_RAREITEM_NAME_64,
    D2S_ITEMDATA_RAREITEM_NAME_65,
    D2S_ITEMDATA_RAREITEM_NAME_66,
    D2S_ITEMDATA_RAREITEM_NAME_67,
    D2S_ITEMDATA_RAREITEM_NAME_68,
    D2S_ITEMDATA_RAREITEM_NAME_69,
    D2S_ITEMDATA_RAREITEM_NAME_70,
    D2S_ITEMDATA_RAREITEM_NAME_71,
    D2S_ITEMDATA_RAREITEM_NAME_72,
    D2S_ITEMDATA_RAREITEM_NAME_73,
    D2S_ITEMDATA_RAREITEM_NAME_74,
    D2S_ITEMDATA_RAREITEM_NAME_75,
    D2S_ITEMDATA_RAREITEM_NAME_76,
    D2S_ITEMDATA_RAREITEM_NAME_77,
    D2S_ITEMDATA_RAREITEM_NAME_78,
    D2S_ITEMDATA_RAREITEM_NAME_79,
    D2S_ITEMDATA_RAREITEM_NAME_80,
    D2S_ITEMDATA_RAREITEM_NAME_81,
    D2S_ITEMDATA_RAREITEM_NAME_82,
    D2S_ITEMDATA_RAREITEM_NAME_83,
    D2S_ITEMDATA_RAREITEM_NAME_84,
    D2S_ITEMDATA_RAREITEM_NAME_85,
    D2S_ITEMDATA_RAREITEM_NAME_86,
    D2S_ITEMDATA_RAREITEM_NAME_87,
    D2S_ITEMDATA_RAREITEM_NAME_88,
    D2S_ITEMDATA_RAREITEM_NAME_89,
    D2S_ITEMDATA_RAREITEM_NAME_90,
    D2S_ITEMDATA_RAREITEM_NAME_91,
    D2S_ITEMDATA_RAREITEM_NAME_92,
    D2S_ITEMDATA_RAREITEM_NAME_93,
    D2S_ITEMDATA_RAREITEM_NAME_94,
    D2S_ITEMDATA_RAREITEM_NAME_95,
    D2S_ITEMDATA_RAREITEM_NAME_96,
    D2S_ITEMDATA_RAREITEM_NAME_97,
    D2S_ITEMDATA_RAREITEM_NAME_98,
    D2S_ITEMDATA_RAREITEM_NAME_99,
    D2S_ITEMDATA_RAREITEM_NAME_100,
    D2S_ITEMDATA_RAREITEM_NAME_101,
    D2S_ITEMDATA_RAREITEM_NAME_102,
    D2S_ITEMDATA_RAREITEM_NAME_103,
    D2S_ITEMDATA_RAREITEM_NAME_104,
    D2S_ITEMDATA_RAREITEM_NAME_105,
    D2S_ITEMDATA_RAREITEM_NAME_106,
    D2S_ITEMDATA_RAREITEM_NAME_107,
    D2S_ITEMDATA_RAREITEM_NAME_108,
    D2S_ITEMDATA_RAREITEM_NAME_109,
    D2S_ITEMDATA_RAREITEM_NAME_110,
    D2S_ITEMDATA_RAREITEM_NAME_111,
    D2S_ITEMDATA_RAREITEM_NAME_112,
    D2S_ITEMDATA_RAREITEM_NAME_113,
    D2S_ITEMDATA_RAREITEM_NAME_114,
    D2S_ITEMDATA_RAREITEM_NAME_115,
    D2S_ITEMDATA_RAREITEM_NAME_116,
    D2S_ITEMDATA_RAREITEM_NAME_117,
    D2S_ITEMDATA_RAREITEM_NAME_118,
    D2S_ITEMDATA_RAREITEM_NAME_119,
    D2S_ITEMDATA_RAREITEM_NAME_120,
    D2S_ITEMDATA_RAREITEM_NAME_121,
    D2S_ITEMDATA_RAREITEM_NAME_122,
    D2S_ITEMDATA_RAREITEM_NAME_123,
    D2S_ITEMDATA_RAREITEM_NAME_124,
    D2S_ITEMDATA_RAREITEM_NAME_125,
    D2S_ITEMDATA_RAREITEM_NAME_126,
    D2S_ITEMDATA_RAREITEM_NAME_127,
    D2S_ITEMDATA_RAREITEM_NAME_128,
    D2S_ITEMDATA_RAREITEM_NAME_129,
    D2S_ITEMDATA_RAREITEM_NAME_130,
    D2S_ITEMDATA_RAREITEM_NAME_131,
    D2S_ITEMDATA_RAREITEM_NAME_132,
    D2S_ITEMDATA_RAREITEM_NAME_133,
    D2S_ITEMDATA_RAREITEM_NAME_134,
    D2S_ITEMDATA_RAREITEM_NAME_135,
    D2S_ITEMDATA_RAREITEM_NAME_136,
    D2S_ITEMDATA_RAREITEM_NAME_137,
    D2S_ITEMDATA_RAREITEM_NAME_138,
    D2S_ITEMDATA_RAREITEM_NAME_139,
    D2S_ITEMDATA_RAREITEM_NAME_140,
    D2S_ITEMDATA_RAREITEM_NAME_141,
    D2S_ITEMDATA_RAREITEM_NAME_142,
    D2S_ITEMDATA_RAREITEM_NAME_143,
    D2S_ITEMDATA_RAREITEM_NAME_144,
    D2S_ITEMDATA_RAREITEM_NAME_145,
    D2S_ITEMDATA_RAREITEM_NAME_146,
    D2S_ITEMDATA_RAREITEM_NAME_147,
    D2S_ITEMDATA_RAREITEM_NAME_148,
    D2S_ITEMDATA_RAREITEM_NAME_149,
    D2S_ITEMDATA_RAREITEM_NAME_150,
    D2S_ITEMDATA_RAREITEM_NAME_151,
    D2S_ITEMDATA_RAREITEM_NAME_152,
    D2S_ITEMDATA_RAREITEM_NAME_153,
    D2S_ITEMDATA_RAREITEM_NAME_154,
    D2S_ITEMDATA_RAREITEM_NAME_155,
    D2S_ITEMDATA_RAREITEM_NAME_156,
    D2S_ITEMDATA_RAREITEM_NAME_157,
    D2S_ITEMDATA_RAREITEM_NAME_158,
    D2S_ITEMDATA_RAREITEM_NAME_159,
    D2S_ITEMDATA_RAREITEM_NAME_160,
    D2S_ITEMDATA_RAREITEM_NAME_161,
    D2S_ITEMDATA_RAREITEM_NAME_162,
    D2S_ITEMDATA_RAREITEM_NAME_163,
    D2S_ITEMDATA_RAREITEM_NAME_164,
    D2S_ITEMDATA_RAREITEM_NAME_165,
    D2S_ITEMDATA_RAREITEM_NAME_166,
    D2S_ITEMDATA_RAREITEM_NAME_167,
    D2S_ITEMDATA_RAREITEM_NAME_168,
    D2S_ITEMDATA_RAREITEM_NAME_169,
    D2S_ITEMDATA_RAREITEM_NAME_170,
    D2S_ITEMDATA_RAREITEM_NAME_171,
    D2S_ITEMDATA_RAREITEM_NAME_172,
    D2S_ITEMDATA_RAREITEM_NAME_173,
    D2S_ITEMDATA_RAREITEM_NAME_174,
    D2S_ITEMDATA_RAREITEM_NAME_175,
    D2S_ITEMDATA_RAREITEM_NAME_176,
    D2S_ITEMDATA_RAREITEM_NAME_177,
    D2S_ITEMDATA_RAREITEM_NAME_178,
    D2S_ITEMDATA_RAREITEM_NAME_179,
    D2S_ITEMDATA_RAREITEM_NAME_180,
    D2S_ITEMDATA_RAREITEM_NAME_181,
    D2S_ITEMDATA_RAREITEM_NAME_182,
    D2S_ITEMDATA_RAREITEM_NAME_183,
    D2S_ITEMDATA_RAREITEM_NAME_184,
    D2S_ITEMDATA_RAREITEM_NAME_185,
    D2S_ITEMDATA_RAREITEM_NAME_186,
    D2S_ITEMDATA_RAREITEM_NAME_187,
    D2S_ITEMDATA_RAREITEM_NAME_188,
    D2S_ITEMDATA_RAREITEM_NAME_189,
    D2S_ITEMDATA_RAREITEM_NAME_190,
    D2S_ITEMDATA_RAREITEM_NAME_191,
    D2S_ITEMDATA_RAREITEM_NAME_192,
    D2S_ITEMDATA_RAREITEM_NAME_193,
    D2S_ITEMDATA_RAREITEM_NAME_194,
    D2S_ITEMDATA_RAREITEM_NAME_195,
    D2S_ITEMDATA_RAREITEM_NAME_196,
    D2S_ITEMDATA_RAREITEM_NAME_197,
    D2S_ITEMDATA_RAREITEM_NAME_198,
    D2S_ITEMDATA_RAREITEM_NAME_199,
    D2S_ITEMDATA_RAREITEM_NAME_200
};

typedef struct D2ItemMagicalAttribute {
    unsigned int numBits;
    int bias;
    const char* nameFmt;
} D2ItemMagicalAttribute;

typedef struct D2ItemMagicalAttributeList {
    unsigned int numAttrs;
    D2ItemMagicalAttribute* attrs;
} D2ItemMagicalAttributeList;

/*
var magicalProperties = map[uint64]magicalProperty{
	0:  {Bits: []uint{8}, Bias: 32, Name: "+{0} to Strength"},
	1:  {Bits: []uint{7}, Bias: 32, Name: "+{0} to Energy"},
	2:  {Bits: []uint{7}, Bias: 32, Name: "+{0} to Dexterity"},
	3:  {Bits: []uint{7}, Bias: 32, Name: "+{0} to Vitality"},
	7:  {Bits: []uint{9}, Bias: 32, Name: "+{0} to Life"},
	9:  {Bits: []uint{8}, Bias: 32, Name: "+{0} to Mana"},
	11: {Bits: []uint{8}, Bias: 32, Name: "+{0} to Maximum Stamina"},
	16: {Bits: []uint{9}, Name: "+{0}% Enhanced Defense"},

	// It's weird that there's two bit fields here, but it seems like
	// the first bit field enhanced min damage, and the second enchances
	// maxium damage.
	17: {Bits: []uint{9, 9}, Name: "+{0}% Enhanced Damage"},
	19: {Bits: []uint{10}, Name: "+{0} to Attack rating"},
	20: {Bits: []uint{6}, Name: "+{0}% Increased chance of blocking"},
	21: {Bits: []uint{6}, Name: "+{0} to Minimum 1-handed damage"},
	22: {Bits: []uint{7}, Name: "+{0} to Maximum 1-handed damage"},
	23: {Bits: []uint{6}, Name: "+{0} to Minimum 2-handed damage"},
	24: {Bits: []uint{7}, Name: "+{0} to Maximum 2-handed damage"},
	25: {Bits: []uint{8}, Name: "Unknown (Invisible)"}, // damagepercent
	26: {Bits: []uint{8}, Name: "Unknown (Invisible)"}, // manarecovery
	27: {Bits: []uint{8}, Name: "Regenerate Mana {0}%"},
	28: {Bits: []uint{8}, Name: "Heal Stamina {0}%"},
	31: {Bits: []uint{11}, Bias: 10, Name: "+{0} Defense"},
	32: {Bits: []uint{9}, Name: "+{0} vs. Missile"},
	33: {Bits: []uint{8}, Bias: 10, Name: "+{0} vs. Melee"},
	34: {Bits: []uint{6}, Name: "Damage Reduced by {0}"},
	35: {Bits: []uint{6}, Name: "Magic Damage Reduced by {0}"},
	36: {Bits: []uint{8}, Name: "Damage Reduced by {0}%"},
	37: {Bits: []uint{8}, Name: "Magic Resist +{0}%"},
	38: {Bits: []uint{8}, Name: "+{0}% to Maximum Magic Resist"},
	39: {Bits: []uint{8}, Bias: 50, Name: "Fire Resist +{0}%"},
	40: {Bits: []uint{5}, Name: "+{0}% to Maximum Fire Resist"},
	41: {Bits: []uint{8}, Bias: 50, Name: "Lightning Resist +{0}%"},
	42: {Bits: []uint{5}, Name: "+{0}% to Maximum Lightning Resist"},
	43: {Bits: []uint{8}, Bias: 50, Name: "Cold Resist +{0}%"},
	44: {Bits: []uint{5}, Name: "+{0}% to Maximum Cold Resist"},
	45: {Bits: []uint{8}, Bias: 50, Name: "Poison Resist +{0}%"},
	46: {Bits: []uint{5}, Name: "+{0}% to Maximum Poison Resist"},
	48: {Bits: []uint{8, 9}, Name: "Adds {0}-{1} Fire Damage"},
	49: {Bits: []uint{9}, Name: "+{0} to Maximum Fire Damage"},
	50: {Bits: []uint{6, 10}, Name: "Adds {0}-{1} Lightning Damage"},
	52: {Bits: []uint{8, 9}, Name: "Adds {0}-{1} Magic Damage"},
	54: {Bits: []uint{8, 9, 8}, Name: "Adds {0}-{1} Cold Damage"},
	57: {Bits: []uint{10, 10, 9}, Name: "Adds {0}-{1} Poison Damage over {2} Seconds"},
	60: {Bits: []uint{7}, Name: "{0}% Life Stolen Per Hit"},
	62: {Bits: []uint{7}, Name: "{0}% Mana Stolen Per Hit"},
	67: {Bits: []uint{7}, Bias: 30, Name: "Unknown (Invisible)"},  // velocitypercent
	68: {Bits: []uint{7}, Bias: 30, Name: "Unknown (Invisible)"},  // attackrate
	71: {Bits: []uint{8}, Bias: 100, Name: "Unknown (Invisible)"}, // value
	72: {Bits: []uint{9}, Name: "Unknown (Invisible)"},            // durability
	73: {Bits: []uint{8}, Name: "+{0} Maximum Durability"},
	74: {Bits: []uint{6}, Bias: 30, Name: "Replenish Life +{0}"},
	75: {Bits: []uint{7}, Bias: 20, Name: "Increase Maximum Durability {0}%"},
	76: {Bits: []uint{6}, Bias: 10, Name: "Increase Maximum Life {0}%"},
	77: {Bits: []uint{6}, Bias: 10, Name: "Increase Maximum Mana {0}%"},
	78: {Bits: []uint{7}, Name: "Attacker Takes Damage of {0}"},
	79: {Bits: []uint{9}, Bias: 100, Name: "{0}% Extra Gold from Monsters"},
	80: {Bits: []uint{8}, Bias: 100, Name: "{0}% Better Chance of Getting Magic Items"},
	81: {Bits: []uint{7}, Name: "Knockback"},
	82: {Bits: []uint{9}, Bias: 20, Name: "Unknown (Invisible)"}, // item_timeduration

	// First value is class, second is skill level, but they're printed in reverse
	// e.g. "+3 To Sorceress Skill Levels"
	83: {Bits: []uint{3, 3}, Name: "+{1} to {0} Skill Levels"},
	84: {Bits: []uint{3, 3}, Name: "+{1} to {0} Skill Levels"},

	// TODO: Check if experience gained really have a bias of 50.
	85: {Bits: []uint{9}, Bias: 50, Name: "{0}% To Experience Gained"},
	86: {Bits: []uint{7}, Name: "+{0} Life After Each Kill"},
	87: {Bits: []uint{7}, Name: "Reduces Prices {0}%"},
	88: {Bits: []uint{1}, Name: "Unknown (Invisible)"}, // item_doubleherbduration
	89: {Bits: []uint{4}, Bias: 4, Name: "+{0} to Light Radius"},
	// This property is not displayed on the item, but its effect is to alter
	// the color of the ambient light.
	90: {Bits: []uint{5}, Name: "Ambient light"},
	// After subtracting the bias, this is usually a negative number.
	91: {Bits: []uint{8}, Bias: 100, Name: "Requirements {0}%"},
	92: {Bits: []uint{7}, Name: "Level requirements +{0} (Invisible)"},
	93: {Bits: []uint{7}, Bias: 20, Name: "{0}% Increased Attack Speed"},
	94: {Bits: []uint{7}, Bias: 64, Name: "Unknown (Invisible)"}, // item_levelreqpct
	96: {Bits: []uint{7}, Bias: 20, Name: "{0}% Faster Run/Walk"},

	// Number of levels to a certain skill, e.g. +1 To Teleport.
	97: {Bits: []uint{9, 6}, Name: "+{1} To {0}"},

	// NVSTATE Charm attributes. ID 98 only occurs on charms of a special
	// type, called NV state charms, they're basically for visual effects.
	// They're imported charms and does not occur naturally in the game.
	98: {Bits: []uint{8, 1}, Name: "{1}+ to {0} (Visual effect only)"},

	99:  {Bits: []uint{7}, Bias: 20, Name: "{0}% Faster Hit Recovery"},
	102: {Bits: []uint{7}, Bias: 20, Name: "{0}% Faster Block Rate"},
	105: {Bits: []uint{7}, Bias: 20, Name: "{0}% Faster Cast Rate"},

	// These properties usually applied to class specific items,
	// first value selects the skill, the second determines how many
	// additional skill points are given.
	107: {Bits: []uint{9, 3}, Name: "+{1} To {0}"},
	108: {Bits: []uint{1}, Name: "Rest In Peace"},
	109: {Bits: []uint{9, 5}, Name: "+{1} to spell {0} (char_class Only)"},
	181: {Bits: []uint{9, 5}, Name: "+{1} to spell {0} (char_class Only)"},
	182: {Bits: []uint{9, 5}, Name: "+{1} to spell {0} (char_class Only)"},
	183: {Bits: []uint{9, 5}, Name: "+{1} to spell {0} (char_class Only)"},
	184: {Bits: []uint{9, 5}, Name: "+{1} to spell {0} (char_class Only)"},
	185: {Bits: []uint{9, 5}, Name: "+{1} to spell {0} (char_class Only)"},
	186: {Bits: []uint{9, 5}, Name: "+{1} to spell {0} (char_class Only)"},
	187: {Bits: []uint{9, 5}, Name: "+{1} to spell {0} (char_class Only)"},

	110: {Bits: []uint{8}, Bias: 20, Name: "Poison Length Reduced by {0}%"},
	111: {Bits: []uint{9}, Bias: 20, Name: "Damage +{0}"},
	112: {Bits: []uint{7}, Name: "Hit Causes Monsters to Flee {0}%"},
	113: {Bits: []uint{7}, Name: "Hit Blinds Target +{0}"},
	114: {Bits: []uint{6}, Name: "{0}% Damage Taken Goes to Mana"},
	// The value of the data field is always 1.
	115: {Bits: []uint{1}, Name: "Ignore Target Defense"},
	116: {Bits: []uint{7}, Name: "{0}% Target Defense"},
	// The value of the data field is always 1.
	117: {Bits: []uint{7}, Name: "Prevent Monster Heal"},
	// The value of the data field is always 1.
	118: {Bits: []uint{1}, Name: "Half Freeze Duration"},
	119: {Bits: []uint{9}, Bias: 20, Name: "{0}% Bonus to Attack Rating"},
	120: {Bits: []uint{7}, Bias: 128, Name: "{0} to Monster Defense Per Hit"},
	121: {Bits: []uint{9}, Bias: 20, Name: "+{0}% Damage to Demons"},
	122: {Bits: []uint{9}, Bias: 20, Name: "+{0}% Damage to Undead"},
	123: {Bits: []uint{10}, Bias: 128, Name: "+{0} to Attack Rating against Demons"},
	124: {Bits: []uint{10}, Bias: 128, Name: "+{0} to Attack Rating against Undead"},
	125: {Bits: []uint{1}, Name: "Throwable"},
	// First value is class id, the next one is skill tree
	126: {Bits: []uint{3, 3}, Name: "+{0} to Fire Skills"},
	127: {Bits: []uint{3}, Name: "+{0} to All Skill Levels"},
	128: {Bits: []uint{5}, Name: "Attacker Takes Lightning Damage of {0}"},
	134: {Bits: []uint{5}, Name: "Freezes Target +{0}"},
	135: {Bits: []uint{7}, Name: "{0}% Chance of Open Wounds"},
	136: {Bits: []uint{7}, Name: "{0}% Chance of Crushing Blow"},
	137: {Bits: []uint{7}, Name: "+{0} Kick Damage"},
	138: {Bits: []uint{7}, Name: "+{0} to Mana After Each Kill"},
	139: {Bits: []uint{7}, Name: "+{0} Life after each Demon Kill"},
	// Unknown property, shows up on Swordback Hold Spiked Shield.
	140: {Bits: []uint{7}, Name: "Extra Blood (Invisible)"}, // item_extrablood
	141: {Bits: []uint{7}, Name: "{0}% Deadly Strike"},
	142: {Bits: []uint{7}, Name: "Fire Absorb {0}%"},
	143: {Bits: []uint{7}, Name: "+{0} Fire Absorb"},
	144: {Bits: []uint{7}, Name: "Lightning Absorb {0}%"},
	145: {Bits: []uint{7}, Name: "+{0} Lightning Absorb"},
	146: {Bits: []uint{7}, Name: "Magic Absorb {0}%"},
	147: {Bits: []uint{7}, Name: "+{0} Magic Absorb"},
	148: {Bits: []uint{7}, Name: "Cold Absorb {0}%"},
	149: {Bits: []uint{7}, Name: "+{0} Cold Absorb"},
	150: {Bits: []uint{7}, Name: "Slows Target by {0}%"},
	151: {Bits: []uint{9, 5}, Name: "Level +{1} {0} When Equipped"},
	152: {Bits: []uint{1}, Name: "Indestructible"},
	153: {Bits: []uint{1}, Name: "Cannot Be Frozen"},
	154: {Bits: []uint{7}, Bias: 20, Name: "{0}% Slower Stamina Drain"},
	155: {Bits: []uint{10, 7}, Name: "{0}% Chance to Reanimate Target"},
	156: {Bits: []uint{7}, Name: "Piercing Attack"},
	157: {Bits: []uint{7}, Name: "Fires Magic Arrows"},
	158: {Bits: []uint{7}, Name: "Fires Explosive Arrows or Bolts"},
	159: {Bits: []uint{6}, Name: "+{0} to Minimum Throw Damage"},
	160: {Bits: []uint{7}, Name: "+{0} to Maximum Throw Damage"},
	179: {Bits: []uint{3}, Name: "+{0} to Druid Skill Levels"},
	180: {Bits: []uint{3}, Name: "+{0} to Assassin Skill Levels"},

	// Ok so get this, this is quite complicated, the id 188 is for items with
	// + x to a certain skill tree, e.g. 1 + to defensive auras (paladin).
	//
	// So here's how it works, the field is 19 bits long, here's the bits for
	// the defensive auras skiller.
	//
	// 001             0000000000             011              010
	//  ^                  ^                   ^                ^
	// levels        unknown padding        class id       skill tree offset
	//
	// So in the above example, the first 3 bits 001 are the + levels (1), we'll
	// ignore the padding, the second interesting set of 3 bits is the class id.
	// Refer to the class.go for class ids, but paladin is 011 (3), and the
	// last 3 bits 010 (2) is the offset from the start of the class skill tree.
	// Refer to skills.go to find the different tree offsets. Paladin offset is
	// 9. So remember the last 3 bits 010 (2), that means the skill tree is
	// 9 + 2 = 11, aka the defensive auras tree.
	//
	// When reading the values, remember the bits are read from the right,
	// so the values will be [2 3 1], offset 2, class id 3, 1 + to skills.
	188: {Bits: []uint{3, 13, 3}, Name: "+{2} to {0} Skills ({1} only)"},

	189: {Bits: []uint{10, 9}, Name: "+{0} to {1} Skills (char_class Only)"},
	190: {Bits: []uint{10, 9}, Name: "+{0} to {1} Skills (char_class Only)"},
	191: {Bits: []uint{10, 9}, Name: "+{0} to {1} Skills (char_class Only)"},
	192: {Bits: []uint{10, 9}, Name: "+{0} to {1} Skills (char_class Only)"},
	193: {Bits: []uint{10, 9}, Name: "+{0} to {1} Skills (char_class Only)"},

	194: {Bits: []uint{4}, Name: "Adds {0} extra sockets to the item"},

	// Order is spell id, level, % chance.
	195: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} When you die"},
	196: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} When you die"},
	197: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} When you die"},

	// Order is spell id, level, % chance.
	198: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} On Striking"},
	199: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} On Striking"},
	200: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} On Striking"},

	// Order is spell id, level, % chance.
	201: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} When Struck"},
	202: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} When Struck"},
	203: {Bits: []uint{6, 10, 7}, Name: "{2}% Chance to Cast Level {0} {1} When Struck"},

	// First value selects the spell id, second value is level, third is remaining charges
	// and the last is the total number of charges.
	204: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	205: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	206: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	207: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	208: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	209: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	210: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	211: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	212: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},
	213: {Bits: []uint{6, 10, 8, 8}, Name: "Level {0} {1} ({2}/{3} Charges)"},

	// All values based on character level are stored in eights, so take
	// the number divide by 8 and multiply by the character level and round down.
	// Or, just do (value * 0.125)% per level.
	214: {Bits: []uint{6}, Name: "+{0} to Defense (Based on Character Level)"},
	215: {Bits: []uint{6}, Name: "{0}% Enhanced Defense (Based on Character Level)"},
	216: {Bits: []uint{6}, Name: "+{0} to Life (Based on Character Level)"},
	217: {Bits: []uint{6}, Name: "+{0} to Mana (Based on Character Level)"},
	218: {Bits: []uint{6}, Name: "+{0} to Maximum Damage (Based on Character Level)"},
	219: {Bits: []uint{6}, Name: "{0}% Enhanced Maximum Damage (Based on Character Level)"},
	220: {Bits: []uint{6}, Name: "+{0} to Strength (Based on Character Level)"},
	221: {Bits: []uint{6}, Name: "+{0} to Dexterity (Based on Character Level)"},
	222: {Bits: []uint{6}, Name: "+{0} to Energy (Based on Character Level)"},
	223: {Bits: []uint{6}, Name: "+{0} to Vitality (Based on Character Level)"},
	224: {Bits: []uint{6}, Name: "+{0} to Attack Rating (Based on Character Level)"},
	225: {Bits: []uint{6}, Name: "{0}% Bonus to Attack Rating (Based on Character Level)"},
	226: {Bits: []uint{6}, Name: "+{0} Cold Damage (Based on Character Level)"},
	227: {Bits: []uint{6}, Name: "+{0} Fire Damage (Based on Character Level)"},
	228: {Bits: []uint{6}, Name: "+{0} Lightning Damage (Based on Character Level)"},
	229: {Bits: []uint{6}, Name: "+{0} Poison Damage (Based on Character Level)"},
	230: {Bits: []uint{6}, Name: "Cold Resist +{0}% (Based on Character Level)"},
	231: {Bits: []uint{6}, Name: "Fire Resist +{0}% (Based on Character Level)"},
	232: {Bits: []uint{6}, Name: "Lightning Resist +{0}% (Based on Character Level)"},
	233: {Bits: []uint{6}, Name: "Poison Resist +{0}% (Based on Character Level)"},
	234: {Bits: []uint{6}, Name: "+{0} Cold Absorb (Based on Character Level)"},
	235: {Bits: []uint{6}, Name: "+{0} Fire Absorb (Based on Character Level)"},
	236: {Bits: []uint{6}, Name: "+{0} Lightning Absorb (Based on Character Level)"},
	237: {Bits: []uint{6}, Name: "{0} Poison Absorb (Based on Character Level)"},
	238: {Bits: []uint{5}, Name: "Attacker Takes Damage of {0} (Based on Character Level)"},
	239: {Bits: []uint{6}, Name: "{0}% Extra Gold from Monsters (Based on Character Level)"},
	240: {Bits: []uint{6}, Name: "{0}% Better Chance of Getting Magic Items (Based on Character Level)"},
	241: {Bits: []uint{6}, Name: "Heal Stamina Plus {0}% (Based on Character Level)"},
	242: {Bits: []uint{6}, Name: "+{0} Maxmium Stamina (Based on Character Level)"},
	243: {Bits: []uint{6}, Name: "{0}% Damage to Demons (Based on Character Level)"},
	244: {Bits: []uint{6}, Name: "{0}% Damage to Undead (Based on Character Level)"},
	245: {Bits: []uint{6}, Name: "+{0} to Attack Rating against Demons (Based on Character Level)"},
	246: {Bits: []uint{6}, Name: "+{0} to Attack Rating against Undead (Based on Character Level)"},
	247: {Bits: []uint{6}, Name: "{0}% Chance of Crushing Blow (Based on Character Level)"},
	248: {Bits: []uint{6}, Name: "{0}% Chance of Open Wounds (Based on Character Level)"},
	249: {Bits: []uint{6}, Name: "+{0} Kick Damage (Based on Character Level)"},
	250: {Bits: []uint{6}, Name: "{0}% to Deadly Strike (Based on Character Level)"},

	// The value of the data field is not actually a time period, but a frequency in terms
	// of the number of times durability is repaired over a period of 100 seconds.
	// For example, if the value is 5, then this property repairs 1 durability in 100 / 5 = 20 seconds.
	252: {Bits: []uint{6}, Name: "Repairs 1 Durability in {0} Seconds"},

	// As in the previous property, the value of the data field is a frequency in terms of the number
	// replenished over a period of 100 seconds. For example if the value is 4, then this property
	// replenishes 1 item in 100 / 4 = 25 seconds.
	253: {Bits: []uint{6}, Name: "Replenishes Quantity"},

	// Number of additional items beyond the base limit, for example if the base
	// is 50 and additional is 30, then the total is 50 + 30.
	254: {Bits: []uint{8}, Name: "Increased Stack Size"},

	// IDs 268 - 303 are some weird values that were never used in the actual game.
	// These values change depending on the time of day in the game.
	// The format of the bit fields are the same in all cases, the first 2 bits
	// specifies the the of time when the value is at its maximum.
	//
	// The second and third are respectively the minimum and maximum values of the property.
	// The maximum value at the time specified and the minimum at the opposite.

	305: {Bits: []uint{8}, Bias: 50, Name: "{0} Pierce Cold"},
	306: {Bits: []uint{8}, Bias: 50, Name: "{0} Pierce Fire"},
	307: {Bits: []uint{8}, Bias: 50, Name: "{0} Pierce Lightning"},
	308: {Bits: []uint{8}, Bias: 50, Name: "{0} Pierce Poision"},

	324: {Bits: []uint{6}, Name: "Unknown (Invisible)"}, // item_extra_charges
	329: {Bits: []uint{9}, Bias: 50, Name: "{0}% To Fire Skill Damage"},
	330: {Bits: []uint{9}, Bias: 50, Name: "{0}% To Lightning Skill Damage"},
	331: {Bits: []uint{9}, Bias: 50, Name: "{0}% To Cold Skill Damage"},
	332: {Bits: []uint{9}, Bias: 50, Name: "{0}% To Poison Skill Damage"},
	333: {Bits: []uint{8}, Name: "-{0}% To Enemy Fire Resistance"},
	334: {Bits: []uint{8}, Name: "-{0}% To Enemy Lightning Resistance"},
	335: {Bits: []uint{8}, Name: "-{0}% To Enemy Cold Resistance"},
	336: {Bits: []uint{8}, Name: "-{0}% To Enemy Poison Resistance"},
	356: {Bits: []uint{2}, Name: "Quest Item Difficulty +{0} (Invisible)"},
*/

typedef enum D2S_ITEMDATA_MAGIC_ATTRIBUTE {
    TODO = 0
} D2S_ITEMDATA_MAGIC_ATTRIBUTE;

typedef struct D2Ear {
    D2S_CHARCLASS class;
    unsigned int level;
    char name[D2S_CHARNAME_LENGTH];
} D2Ear;

/*
var weaponDamageMap = map[string]weaponDamage{
	//Axes
	"hax": {Min: 3, Max: 6},
	"axe": {Min: 4, Max: 11},
	"2ax": {Min: 5, Max: 13},
	"mpi": {Min: 7, Max: 11},
	"wax": {Min: 10, Max: 18},
	"lax": {Min: 6, Max: 13},
	"bax": {Min: 10, Max: 18},
	"btx": {Min: 12, Max: 32},
	"gax": {Min: 9, Max: 30},
	"gix": {Min: 22, Max: 45},
	"9ha": {Min: 10, Max: 21},
	"9ax": {Min: 10, Max: 33},
	"92a": {Min: 13, Max: 38},
	"9mp": {Min: 14, Max: 34},
	"9wa": {Min: 16, Max: 45},
	"9la": {Min: 14, Max: 34},
	"9ba": {Min: 21, Max: 49},
	"9bt": {Min: 24, Max: 77},
	"9ga": {Min: 18, Max: 70},
	"9gi": {Min: 43, Max: 85},
	"7ha": {Min: 33, Max: 58},
	"7ax": {Min: 38, Max: 60},
	"72a": {Min: 33, Max: 66},
	"7mp": {Min: 30, Max: 48},
	"7wa": {Min: 24, Max: 71},
	"7la": {Min: 25, Max: 123},
	"7ba": {Min: 62, Max: 110},
	"7bt": {Min: 49, Max: 137},
	"7ga": {Min: 59, Max: 94},
	"7gi": {Min: 60, Max: 124},

	//Maces
	"clb": {Min: 1, Max: 6},
	"spc": {Min: 5, Max: 8},
	"mac": {Min: 3, Max: 10},
	"mst": {Min: 7, Max: 16},
	"fla": {Min: 1, Max: 24},
	"whm": {Min: 19, Max: 29},
	"mau": {Min: 30, Max: 43},
	"gma": {Min: 38, Max: 58},
	"9cl": {Min: 6, Max: 21},
	"9sp": {Min: 13, Max: 25},
	"9ma": {Min: 15, Max: 23},
	"9mt": {Min: 20, Max: 31},
	"9fl": {Min: 13, Max: 35},
	"9wh": {Min: 35, Max: 58},
	"9m9": {Min: 53, Max: 78},
	"9gm": {Min: 61, Max: 99},
	"7cl": {Min: 35, Max: 43},
	"7sp": {Min: 32, Max: 58},
	"7ma": {Min: 41, Max: 49},
	"7mt": {Min: 42, Max: 53},
	"7fl": {Min: 3, Max: 80},
	"7wh": {Min: 50, Max: 61},
	"7m7": {Min: 77, Max: 106},
	"7gm": {Min: 33, Max: 180},

	//Polearms
	"bar": {TwoMin: 1, TwoMax: 27},
	"vou": {TwoMin: 6, TwoMax: 21},
	"scy": {TwoMin: 8, TwoMax: 20},
	"pax": {TwoMin: 18, TwoMax: 39},
	"hal": {TwoMin: 21, TwoMax: 45},
	"wsc": {TwoMin: 15, TwoMax: 36},
	"9b7": {TwoMin: 6, TwoMax: 58},
	"9vo": {TwoMin: 14, TwoMax: 53},
	"9s8": {TwoMin: 18, TwoMax: 45},
	"9pa": {TwoMin: 34, TwoMax: 75},
	"9h9": {TwoMin: 13, TwoMax: 85},
	"9wc": {TwoMin: 30, TwoMax: 70},
	"7o7": {TwoMin: 28, TwoMax: 145},
	"7vo": {TwoMin: 17, TwoMax: 165},
	"7s8": {TwoMin: 12, TwoMax: 141},
	"7pa": {TwoMin: 33, TwoMax: 150},
	"7h7": {TwoMin: 46, TwoMax: 127},
	"7wc": {TwoMin: 40, TwoMax: 127},

	//Swords
	"ssd": {Min: 2, Max: 7},
	"scm": {Min: 2, Max: 6},
	"sbr": {Min: 3, Max: 8},
	"flc": {Min: 9, Max: 17},
	"crs": {Min: 5, Max: 15},
	"bsd": {Min: 7, Max: 14},
	"lsd": {Min: 3, Max: 19},
	"wsd": {Min: 8, Max: 20},
	"9ss": {Min: 8, Max: 22},
	"9sm": {Min: 8, Max: 21},
	"9sb": {Min: 10, Max: 24},
	"9fc": {Min: 16, Max: 35},
	"9cr": {Min: 13, Max: 35},
	"9bs": {Min: 16, Max: 34},
	"9ls": {Min: 10, Max: 42},
	"9wd": {Min: 18, Max: 43},
	"7ss": {Min: 31, Max: 59},
	"7sm": {Min: 26, Max: 46},
	"7sb": {Min: 33, Max: 45},
	"7fc": {Min: 28, Max: 68},
	"7cr": {Min: 31, Max: 35},
	"7bs": {Min: 37, Max: 53},
	"7ls": {Min: 5, Max: 77},
	"7wd": {Min: 40, Max: 50},

	// Two handed swords
	"2hs": {Min: 2, Max: 9, TwoMin: 5, TwoMax: 17},
	"clm": {Min: 5, Max: 12, TwoMin: 13, TwoMax: 30},
	"gis": {Min: 3, Max: 16, TwoMin: 9, TwoMax: 28},
	"bsw": {Min: 7, Max: 19, TwoMin: 20, TwoMax: 28},
	"flb": {Min: 9, Max: 15, TwoMin: 13, TwoMax: 26},
	"gsd": {Min: 12, Max: 20, TwoMin: 25, TwoMax: 42},
	"92h": {Min: 8, Max: 26, TwoMin: 18, TwoMax: 40},
	"9cm": {Min: 13, Max: 30, TwoMin: 26, TwoMax: 61},
	"9gs": {Min: 10, Max: 37, TwoMin: 19, TwoMax: 58},
	"9b9": {Min: 14, Max: 40, TwoMin: 39, TwoMax: 60},
	"9fb": {Min: 19, Max: 35, TwoMin: 29, TwoMax: 54},
	"9gd": {Min: 24, Max: 40, TwoMin: 47, TwoMax: 80},
	"7sh": {Min: 22, Max: 56, TwoMin: 50, TwoMax: 94},
	"7cm": {Min: 22, Max: 62, TwoMin: 67, TwoMax: 96},
	"7gs": {Min: 15, Max: 75, TwoMin: 55, TwoMax: 118},
	"7b7": {Min: 24, Max: 54, TwoMin: 71, TwoMax: 83},
	"7fb": {Min: 26, Max: 70, TwoMin: 61, TwoMax: 121},
	"7gd": {Min: 25, Max: 65, TwoMin: 58, TwoMax: 115},

	//Bows
	"sbw": {TwoMin: 1, TwoMax: 4},
	"hbw": {TwoMin: 2, TwoMax: 6},
	"lbw": {TwoMin: 3, TwoMax: 10},
	"cbw": {TwoMin: 4, TwoMax: 8},
	"sbb": {TwoMin: 3, TwoMax: 18},
	"swb": {TwoMin: 6, TwoMax: 14},
	"lwb": {TwoMin: 3, TwoMax: 23},
	"8sb": {TwoMin: 6, TwoMax: 19},
	"8hb": {TwoMin: 8, TwoMax: 22},
	"8lb": {TwoMin: 10, TwoMax: 29},
	"8cb": {TwoMin: 11, TwoMax: 26},
	"8s8": {TwoMin: 13, TwoMax: 30},
	"8l8": {TwoMin: 10, TwoMax: 42},
	"8sw": {TwoMin: 14, TwoMax: 35},
	"8lw": {TwoMin: 10, TwoMax: 50},
	"6sb": {TwoMin: 23, TwoMax: 50},
	"6hb": {TwoMin: 21, TwoMax: 41},
	"6lb": {TwoMin: 15, TwoMax: 59},
	"6cb": {TwoMin: 12, TwoMax: 52},
	"6s7": {TwoMin: 33, TwoMax: 40},
	"6l7": {TwoMin: 15, TwoMax: 63},
	"6sw": {TwoMin: 20, TwoMax: 53},
	"6lw": {TwoMin: 10, TwoMax: 68},

	//Crossbows
	"lxb": {TwoMin: 6, TwoMax: 9},
	"mxb": {TwoMin: 9, TwoMax: 16},
	"hxb": {TwoMin: 14, TwoMax: 26},
	"rxb": {TwoMin: 6, TwoMax: 12},
	"8lx": {TwoMin: 14, TwoMax: 27},
	"8mx": {TwoMin: 20, TwoMax: 42},
	"8hx": {TwoMin: 33, TwoMax: 55},
	"8rx": {TwoMin: 14, TwoMax: 32},
	"6lx": {TwoMin: 28, TwoMax: 73},
	"6mx": {TwoMin: 25, TwoMax: 87},
	"6hx": {TwoMin: 32, TwoMax: 91},
	"6rx": {TwoMin: 26, TwoMax: 40},

	//Javelins (throw damage, should update fields)
	"jav": {Min: 6, Max: 14},
	"pil": {Min: 7, Max: 20},
	"ssp": {Min: 10, Max: 22},
	"glv": {Min: 16, Max: 22},
	"tsp": {Min: 12, Max: 30},
	"9ja": {Min: 14, Max: 32},
	"9pi": {Min: 16, Max: 42},
	"9s9": {Min: 27, Max: 50},
	"9gl": {Min: 32, Max: 60},
	"9ts": {Min: 18, Max: 54},
	"7ja": {Min: 28, Max: 55},
	"7pi": {Min: 21, Max: 75},
	"7s7": {Min: 40, Max: 62},
	"7gl": {Min: 30, Max: 85},
	"7ts": {Min: 11, Max: 77},

	// Amazon-only Weapons (throw damage, should update fields)
	"am1": {Min: 7, Max: 12},
	"am2": {Min: 9, Max: 19},
	"am3": {Min: 18, Max: 24},
	"am4": {Min: 23, Max: 55},
	"am5": {Min: 6, Max: 22},
	"am6": {Min: 16, Max: 29},
	"am7": {Min: 19, Max: 41},
	"am8": {Min: 34, Max: 51},
	"am9": {Min: 42, Max: 101},
	"ama": {Min: 18, Max: 54},
	"amb": {Min: 20, Max: 47},
	"amc": {Min: 14, Max: 72},
	"amd": {Min: 65, Max: 95},
	"ame": {Min: 37, Max: 153},
	"amf": {Min: 35, Max: 66},

	//Scepters
	"scp": {Min: 6, Max: 11},
	"gsc": {Min: 8, Max: 18},
	"wsp": {Min: 10, Max: 17},
	"9sc": {Min: 13, Max: 24},
	"9qs": {Min: 14, Max: 36},
	"9ws": {Min: 16, Max: 38},
	"7sc": {Min: 40, Max: 52},
	"7qs": {Min: 45, Max: 54},
	"7ws": {Min: 37, Max: 43},

	//Spears
	"spr": {TwoMin: 3, TwoMax: 15},
	"tri": {TwoMin: 9, TwoMax: 15},
	"brn": {TwoMin: 7, TwoMax: 17},
	"spt": {TwoMin: 15, TwoMax: 23},
	"pik": {TwoMin: 14, TwoMax: 63},
	"9sr": {TwoMin: 10, TwoMax: 37},
	"9tr": {TwoMin: 19, TwoMax: 37},
	"9br": {TwoMin: 16, TwoMax: 40},
	"9st": {TwoMin: 29, TwoMax: 59},
	"9p9": {TwoMin: 27, TwoMax: 114},
	"7sr": {TwoMin: 35, TwoMax: 119},
	"7tr": {TwoMin: 29, TwoMax: 144},
	"7br": {TwoMin: 42, TwoMax: 92},
	"7st": {TwoMin: 18, TwoMax: 155},
	"7p7": {TwoMin: 33, TwoMax: 178},

	//Throwing
	"tkf": {Min: 4, Max: 9},
	"tax": {Min: 6, Max: 11},
	"bkf": {Min: 8, Max: 12},
	"bal": {Min: 12, Max: 15},
	"9tk": {Min: 11, Max: 24},
	"9ta": {Min: 14, Max: 27},
	"9bk": {Min: 18, Max: 33},
	"9b8": {Min: 24, Max: 34},
	"7tk": {Min: 23, Max: 54},
	"7bk": {Min: 23, Max: 39},
	"7ta": {Min: 15, Max: 66},
	"7b8": {Min: 7, Max: 60},

	//Daggers
	"dgr": {Min: 1, Max: 4},
	"dir": {Min: 3, Max: 9},
	"kri": {Min: 2, Max: 11},
	"bld": {Min: 4, Max: 15},
	"9dg": {Min: 6, Max: 18},
	"9di": {Min: 10, Max: 26},
	"9kr": {Min: 15, Max: 31},
	"9bl": {Min: 19, Max: 36},
	"7dg": {Min: 23, Max: 49},
	"7di": {Min: 37, Max: 53},
	"7kr": {Min: 15, Max: 57},
	"7bl": {Min: 32, Max: 47},

	//Staves
	"sst": {TwoMin: 1, TwoMax: 5},
	"lst": {TwoMin: 2, TwoMax: 8},
	"cst": {TwoMin: 4, TwoMax: 12},
	"bst": {TwoMin: 6, TwoMax: 13},
	"wst": {TwoMin: 12, TwoMax: 28},
	"8ss": {TwoMin: 6, TwoMax: 21},
	"8ls": {TwoMin: 8, TwoMax: 26},
	"8cs": {TwoMin: 11, TwoMax: 32},
	"8bs": {TwoMin: 14, TwoMax: 34},
	"8ws": {TwoMin: 24, TwoMax: 58},
	"6ss": {TwoMin: 69, TwoMax: 85},
	"6ls": {TwoMin: 75, TwoMax: 107},
	"6cs": {TwoMin: 80, TwoMax: 93},
	"6bs": {TwoMin: 65, TwoMax: 108},
	"6ws": {TwoMin: 83, TwoMax: 99},

	//Wands
	"wnd": {Min: 2, Max: 4},
	"ywn": {Min: 2, Max: 8},
	"bwn": {Min: 3, Max: 7},
	"gwn": {Min: 5, Max: 11},
	"9wn": {Min: 8, Max: 18},
	"9yw": {Min: 8, Max: 24},
	"9bw": {Min: 10, Max: 22},
	"9gw": {Min: 13, Max: 29},
	"7wn": {Min: 18, Max: 33},
	"7yw": {Min: 20, Max: 40},
	"7bw": {Min: 10, Max: 31},
	"7gw": {Min: 22, Max: 28},

	//Orbs
	"ob1": {Min: 2, Max: 5},
	"ob2": {Min: 3, Max: 8},
	"ob3": {Min: 4, Max: 10},
	"ob4": {Min: 5, Max: 12},
	"ob5": {Min: 8, Max: 18},
	"ob6": {Min: 8, Max: 21},
	"ob7": {Min: 10, Max: 26},
	"ob8": {Min: 11, Max: 29},
	"ob9": {Min: 13, Max: 32},
	"oba": {Min: 18, Max: 42},
	"obb": {Min: 21, Max: 46},
	"obc": {Min: 18, Max: 50},
	"obd": {Min: 23, Max: 55},
	"obe": {Min: 12, Max: 66},
	"obf": {Min: 30, Max: 53},

	// Assassin Claws
	"ktr": {Min: 4, Max: 7},
	"wrb": {Min: 5, Max: 9},
	"axf": {Min: 2, Max: 15},
	"ces": {Min: 7, Max: 15},
	"clw": {Min: 8, Max: 15},
	"btl": {Min: 10, Max: 14},
	"skr": {Min: 9, Max: 17},
	"9ar": {Min: 11, Max: 24},
	"9wb": {Min: 13, Max: 27},
	"9xf": {Min: 8, Max: 37},
	"9cs": {Min: 16, Max: 37},
	"9lw": {Min: 18, Max: 37},
	"9tw": {Min: 21, Max: 35},
	"9qr": {Min: 19, Max: 40},
	"7ar": {Min: 39, Max: 52},
	"7wb": {Min: 34, Max: 45},
	"7xf": {Min: 44, Max: 53},
	"7cs": {Min: 36, Max: 42},
	"7lw": {Min: 22, Max: 53},
	"7tw": {Min: 24, Max: 44},
	"7qr": {Min: 40, Max: 51},
}
*/

typedef struct D2Item {
    unsigned int numSockets;
    struct D2Item *sockets;
    char personalisedName[D2S_CHARNAME_LENGTH];
    unsigned int ethereal;
    unsigned int currentDurability; 
    unsigned int maxDurability; // 0 means indestructible
    unsigned int ilvl;
    D2S_ITEMDATA_RARITY quality;
    D2S_ITEMDATA_PREFIX_IDENTIFIER *prefixes;
    D2S_ITEMDATA_SUFFIX_IDENTIFIER *suffixes;
    unsigned int minDamage;
    unsigned int maxDamage;
    unsigned int minDamageTwoHanded;
    unsigned int maxDamageTwoHanded;
    D2Ear* earData;
    // ignore if item is not a Set item, 
    // if it's a Set item, this adds 5 bits 
    // before the list of properties with this value
    unsigned int numSetAttrLists;
    D2ItemMagicalAttributeList* attrList;
    D2ItemMagicalAttributeList* setAttrList;
    D2ItemMagicalAttributeList* runeAttrList;
} D2Item;

D2Item* getItem(D2S_INVENTORYCLASS inv, unsigned int offset, void* charData, size_t dataLen);
int setItem(D2S_INVENTORYCLASS inv, unsigned int offset, D2Item* item, void* charData, size_t dataLen);

// Free item memory
void freeItem(D2Item* item);

int exportItem(D2Item* item, const char* filename);
D2Item* importItem(const char* filename);
void printItem(D2Item* item);

#endif